/*******************************************************************
 * @project Project: PalliaCare Mobile App                         *
 * @copyright Copyright (c) Arpage AG - 2017 - All rights reserved *
 * @address Address: Tobelweg 4, CH-8700 Küsnacht ZH               *
 * @web Web: www.arpage.ch                                         *
 * @file File: AbstractDynamicBaseService                          *
 * @author Gökhan Sari - <goekhan.sari@arpage.ch>                  *
 *******************************************************************/
import { Compiler, ComponentRef, Injector, ViewContainerRef, Type } from "@angular/core";
/**
 * Base class for all services that want to create components dynamically.
 */
export declare abstract class AbstractDynamicBaseService {
    protected compiler: Compiler;
    constructor(injector: Injector);
    /**
     * Creates a dynamic component on the fly by the given parameters.
     *
     * @param {ViewContainerRef} container
     * @param moduleToCreate
     * @param componentToCreate
     * @param properties
     * @returns {ComponentRef<any>}
     */
    protected createDynamicComponent(container: ViewContainerRef, moduleToCreate: Type<any>, componentToCreate: Type<any>, properties?: any): ComponentRef<any>;
}
