var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Injector } from '@angular/core';
import { MatIconRegistry } from '@angular/material';
import { DomSanitizer } from '@angular/platform-browser';
import { trigger, state, style, transition, animate } from '@angular/animations';
import { DynamicExpandableTableDataProvider } from './shared/dynamic-expandable-data.provider';
import { DynamicTableComponent } from '../dynamic-table/dynamic-table.component';
var DynamicExpandableTableComponent = /** @class */ (function (_super) {
    __extends(DynamicExpandableTableComponent, _super);
    function DynamicExpandableTableComponent(injector) {
        var _this = _super.call(this, injector) || this;
        _this.iconRegistry = injector.get(MatIconRegistry);
        _this.sanitizer = injector.get(DomSanitizer);
        _this.palTableDataProvider = injector.get(DynamicExpandableTableDataProvider);
        _this.tableOptions = _this.palTableDataProvider.getOptions();
        // Register SVG icons
        _this.iconRegistry.addSvgIcon('expand', _this.sanitizer.bypassSecurityTrustResourceUrl('assets/ui/images/svg/expand-icon.svg'));
        return _this;
    }
    DynamicExpandableTableComponent = __decorate([
        Component({
            selector: 'dynamic-expandable-table',
            templateUrl: './dynamic-expandable-table.component.html',
            styleUrls: [
                './dynamic-expandable-table.component.scss',
                '../dynamic-table/table/table-instance.component.scss'
            ],
            animations: [
                trigger('detailExpand', [
                    state('collapsed', style({ height: '0px', minHeight: '0px', display: 'none' })),
                    state('expanded', style({ display: 'inline', height: '*' })),
                    transition('expanded <=> collapsed', animate('225ms cubic-bezier(0.4, 0.0, 0.2, 1)')),
                ]),
            ],
        }),
        __metadata("design:paramtypes", [Injector])
    ], DynamicExpandableTableComponent);
    return DynamicExpandableTableComponent;
}(DynamicTableComponent));
export { DynamicExpandableTableComponent };
//# sourceMappingURL=dynamic-expandable-table.component.js.map