var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Injector, Input } from '@angular/core';
import { trigger, state, transition, style, animate } from '@angular/animations';
import { MatTableDataSource } from '@angular/material';
import { of } from 'rxjs';
import { catchError } from 'rxjs/operators';
import { DynamicExpandableTableDataProvider } from '../shared/dynamic-expandable-data.provider';
import { DynamicExpandableTableUtils } from '../shared/dynamic-expandable-table.utils';
import { TableInstanceComponent } from '../../dynamic-table/table/table-instance.component';
import { DynamicTableUtils } from '../../dynamic-table/shared/dynamic-table.utils';
var ExpandableTableInstanceComponent = /** @class */ (function (_super) {
    __extends(ExpandableTableInstanceComponent, _super);
    function ExpandableTableInstanceComponent(injector) {
        var _this = _super.call(this, injector) || this;
        _this.injector = injector;
        _this.expandedItemDetailsDataSource = new MatTableDataSource();
        _this.isLoadingExpandedItemResults = true;
        _this.noExpandedItemDataFound = false;
        _this.palExpandableDataProvider = injector.get(DynamicExpandableTableDataProvider);
        return _this;
    }
    /**
     * @override
     */
    ExpandableTableInstanceComponent.prototype.addStandardColumns = function () {
        //this.columns.unshift({ column: 'expandableColumn', name: 'expandableColumn' });
        //super.addStandardColumns();
    };
    /**
    * @override
    */
    ExpandableTableInstanceComponent.prototype.selectItem = function (index) {
        _super.prototype.selectItem.call(this, index);
        // Find out if it should expand or collapse. If expandedElement is null, it should be collapsed
        var currentSelectedItem = this.getCurrentSelectedItem();
        this.expandedElement = (this.expandedElement !== currentSelectedItem) ? currentSelectedItem : null;
        // Collapse 2.Level
        this.expandedElement2 = null;
        this.expandedItemDetailsDataSource.data = [];
    };
    /**
    * @override
    */
    ExpandableTableInstanceComponent.prototype.getColumnColor = function (columnId) {
        switch (columnId) {
            case 'expandableColumn':
                // if expanded
                if (this.expandedElement != null) {
                    var columnOption = DynamicTableUtils.getColumnById(columnId, this.columnOptions);
                    if (columnOption != null) {
                        var columnColor = columnOption['hoverBackgroundColor'];
                        return this.sanitizer.bypassSecurityTrustStyle(columnColor);
                    }
                }
                return _super.prototype.getColumnColor.call(this, columnId);
            default:
                return _super.prototype.getColumnColor.call(this, columnId);
        }
    };
    ExpandableTableInstanceComponent.prototype.selectItem2 = function (expandedItemDetails, expandedItem) {
        this.expandedElement2 = expandedItemDetails;
        this.expandedItemDetailsDataSource.data = [];
        this.loadExpandedItemDetailsTableData(expandedItemDetails, expandedItem);
    };
    ExpandableTableInstanceComponent.prototype.getExpandedItemTableColumns = function (expandedItem) {
        return this.palExpandableDataProvider.getExpandedItemTableColumns(expandedItem);
    };
    ExpandableTableInstanceComponent.prototype.getExpandedItemTableColumnIds = function (expandedItem) {
        return DynamicExpandableTableUtils.convertToColumnIds(this.getExpandedItemTableColumns(expandedItem));
    };
    ExpandableTableInstanceComponent.prototype.getExpandedItemTableData = function (expandedItem) {
        return this.palExpandableDataProvider.getExpandedItemTableData(expandedItem);
    };
    ExpandableTableInstanceComponent.prototype.getExpandedItemDetailsTableColumns = function (expandedItemDetails, expandedItem) {
        return this.palExpandableDataProvider.getExpandedItemDetailsTableColumns(expandedItemDetails, expandedItem);
    };
    ExpandableTableInstanceComponent.prototype.getExpandedItemDetailsTableColumnIds = function (expandedItemDetails, expandedItem) {
        return DynamicExpandableTableUtils.convertToColumnIds(this.getExpandedItemDetailsTableColumns(expandedItemDetails, expandedItem));
    };
    ExpandableTableInstanceComponent.prototype.loadExpandedItemDetailsTableData = function (expandedItemDetails, expandedItem) {
        var _this = this;
        this.isLoadingExpandedItemResults = true;
        this.palExpandableDataProvider.getExpandedItemDetailsTableData(expandedItemDetails, expandedItem)
            .subscribe(function (items) {
            _this.expandedItemDetailsDataSource.data = items;
            _this.isLoadingExpandedItemResults = false;
            if (items.length === 0) {
                _this.noDataFound = true;
            }
            else {
                _this.noDataFound = false;
            }
        }, catchError(function (error) {
            console.error('Error in loading pal table data', error);
            _this.expandedItemDetailsDataSource.data = [];
            _this.isLoadingExpandedItemResults = false;
            return of([]);
        }));
    };
    ExpandableTableInstanceComponent.EXPANDED_ITEM_EXPANDABLE_COLUMN_ID = 'expandedItemExpandableColumn';
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], ExpandableTableInstanceComponent.prototype, "groupIndex", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], ExpandableTableInstanceComponent.prototype, "hideColumnsOfExpandedItems", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], ExpandableTableInstanceComponent.prototype, "hideColumnsOfExpandedItemDetails", void 0);
    ExpandableTableInstanceComponent = __decorate([
        Component({
            selector: 'expandable-table-instance',
            templateUrl: './expandable-table-instance.component.html',
            styleUrls: [
                './expandable-table-instance.component.scss',
                '../../dynamic-table/table/table-instance.component.scss'
            ],
            animations: [
                trigger('detailExpand', [
                    state('collapsed', style({ height: '0px', minHeight: '0px', display: 'none' })),
                    state('expanded', style({ display: 'inline', height: '*' })),
                    transition('expanded <=> collapsed', animate('225ms cubic-bezier(0.4, 0.0, 0.2, 1)')),
                ]),
            ],
        }),
        __metadata("design:paramtypes", [Injector])
    ], ExpandableTableInstanceComponent);
    return ExpandableTableInstanceComponent;
}(TableInstanceComponent));
export { ExpandableTableInstanceComponent };
//# sourceMappingURL=expandable-table-instance.component.js.map