import { Injector, QueryList } from '@angular/core';
import { Subject } from 'rxjs';
import { AbstractWebWidgetComponent } from '../abstract-web-widget.component';
import { DynamicTableDataProvider } from './shared/dynamic-table-data-provider';
import { DynamicTableContainerDirective } from './directives/dynamic-table.directive';
import { DynamicTableOptionInterface } from './interfaces/dynamic-table-option.interface';
import { DynamicTableActionMessageService } from './services/dynamic-table-action-message.service';
import { DynamicTableMouseEventMessageService } from './services/dynamic-table-mouse-event-message.service';
export declare class DynamicTableComponent extends AbstractWebWidgetComponent {
    static readonly FILTER_MIN_VALUE: number;
    filterHint: string;
    tableOptions: Array<DynamicTableOptionInterface>;
    palTableDataProvider: DynamicTableDataProvider;
    actionsSubject: Subject<DynamicTableActionMessageService<object>>;
    mouseEventsSubject: Subject<DynamicTableMouseEventMessageService<object>>;
    tablesQueryList: QueryList<DynamicTableContainerDirective>;
    showFilter: boolean;
    constructor(injector: Injector);
    onFilterEnter(): void;
    onFilterLeave(): void;
}
