var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Injector, Input, ViewChildren, QueryList } from '@angular/core';
import { Subject } from 'rxjs';
import { AbstractWebWidgetComponent } from '../abstract-web-widget.component';
import { DynamicTableDataProvider } from './shared/dynamic-table-data-provider';
import { DynamicTableContainerDirective } from './directives/dynamic-table.directive';
var DynamicTableComponent = /** @class */ (function (_super) {
    __extends(DynamicTableComponent, _super);
    function DynamicTableComponent(injector) {
        var _this = _super.call(this) || this;
        _this.filterHint = 'Filter';
        _this.actionsSubject = new Subject();
        _this.mouseEventsSubject = new Subject();
        _this.showFilter = true;
        _this.palTableDataProvider = injector.get(DynamicTableDataProvider);
        _this.tableOptions = _this.palTableDataProvider.getOptions();
        return _this;
    }
    DynamicTableComponent.prototype.onFilterEnter = function () {
        this.filterHint = '';
    };
    DynamicTableComponent.prototype.onFilterLeave = function () {
        this.filterHint = 'Filter';
    };
    DynamicTableComponent.FILTER_MIN_VALUE = 3;
    __decorate([
        ViewChildren(DynamicTableContainerDirective),
        __metadata("design:type", QueryList)
    ], DynamicTableComponent.prototype, "tablesQueryList", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], DynamicTableComponent.prototype, "showFilter", void 0);
    DynamicTableComponent = __decorate([
        Component({
            selector: 'dynamic-table',
            templateUrl: './dynamic-table.component.html',
            styleUrls: [
                './dynamic-table.component.scss',
                './table/table-instance.component.scss'
            ],
            animations: []
        }),
        __metadata("design:paramtypes", [Injector])
    ], DynamicTableComponent);
    return DynamicTableComponent;
}(AbstractWebWidgetComponent));
export { DynamicTableComponent };
//# sourceMappingURL=dynamic-table.component.js.map