var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule, NO_ERRORS_SCHEMA, } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';
import { FlexLayoutModule } from '@angular/flex-layout';
import { MatTableModule, MatFormFieldModule, MatInputModule, MatProgressSpinnerModule, MatPaginatorModule, MatSortModule, MatButtonModule, MatIconModule, MatProgressBarModule, MatCardModule, MatToolbarModule, MatSlideToggleModule, } from '@angular/material';
import { DynamicTableDataProvider } from './shared/dynamic-table-data-provider';
import { DynamicTableActionsContainerDirective } from './directives/dynamic-table-actions-container.directive';
import { DynamicTableIconContainerDirective } from './directives/dynamic-table-icon-container.directive';
import { DynamicTableContentSummaryContainerDirective } from './directives/dynamic-table-content-summary-container.directive';
import { DynamicTableActionMessageService } from './services/dynamic-table-action-message.service';
import { PalTableAdditionalInfoContainerDirective } from './directives/dynamic-table-additional-info-container.directive';
import { DynamicTableDescriptionContainerDirective } from './directives/dynamic-table-description-container.directive';
import { DynamicTableColumnsContainerDirective } from './directives/dynamic-table-columns.directive';
import { DynamicTableContainerDirective } from './directives/dynamic-table.directive';
import { DynamicTableTitleContainerDirective } from './directives/dynamic-table-title-container.directive';
import { DynamicTableDynamicCellBuilder } from './shared/dynamic-table-dynamic-cell-builder';
import { TableInstanceComponent } from './table/table-instance.component';
import { DynamicTableComponent } from './dynamic-table.component';
import { DynamicTableMouseEventMessageService } from './services/dynamic-table-mouse-event-message.service';
var DynamicTableModule = /** @class */ (function () {
    function DynamicTableModule() {
    }
    DynamicTableModule_1 = DynamicTableModule;
    /**
     * Singleton services
     */
    DynamicTableModule.forRoot = function () {
        return {
            ngModule: DynamicTableModule_1,
            providers: [
                DynamicTableActionMessageService,
                DynamicTableMouseEventMessageService
            ]
        };
    };
    DynamicTableModule = DynamicTableModule_1 = __decorate([
        NgModule({
            imports: [
                CommonModule,
                FlexLayoutModule,
                MatPaginatorModule,
                MatSortModule,
                MatTableModule,
                MatFormFieldModule,
                MatInputModule,
                MatProgressSpinnerModule,
                MatProgressBarModule,
                FormsModule,
                ReactiveFormsModule,
                MatButtonModule,
                MatIconModule,
                MatCardModule,
                MatToolbarModule,
                MatSlideToggleModule
            ],
            schemas: [NO_ERRORS_SCHEMA],
            declarations: [
                TableInstanceComponent,
                DynamicTableComponent,
                DynamicTableColumnsContainerDirective,
                DynamicTableIconContainerDirective,
                DynamicTableContainerDirective,
                DynamicTableActionsContainerDirective,
                DynamicTableContentSummaryContainerDirective,
                PalTableAdditionalInfoContainerDirective,
                DynamicTableDescriptionContainerDirective,
                DynamicTableTitleContainerDirective
            ],
            exports: [
                MatPaginatorModule,
                MatSortModule,
                MatTableModule,
                MatFormFieldModule,
                MatInputModule,
                MatProgressSpinnerModule,
                MatProgressBarModule,
                FormsModule,
                ReactiveFormsModule,
                MatButtonModule,
                MatIconModule,
                MatCardModule,
                MatToolbarModule,
                MatSlideToggleModule,
                TableInstanceComponent,
                DynamicTableComponent,
                DynamicTableContainerDirective,
                DynamicTableIconContainerDirective,
                DynamicTableActionsContainerDirective,
                DynamicTableContentSummaryContainerDirective,
                PalTableAdditionalInfoContainerDirective,
                DynamicTableDescriptionContainerDirective,
                DynamicTableTitleContainerDirective,
            ],
            entryComponents: [],
            providers: [
                DynamicTableDataProvider,
                DynamicTableDynamicCellBuilder,
            ],
        })
    ], DynamicTableModule);
    return DynamicTableModule;
    var DynamicTableModule_1;
}());
export { DynamicTableModule };
//# sourceMappingURL=dynamic-table.module.js.map