import { Observable } from 'rxjs';
import { DynamicTableDataInterface } from '../interfaces/dynamic-table-data.interface';
import { DynamicTableOptionInterface } from '../interfaces/dynamic-table-option.interface';
import { DynamicTableColumnInterace } from '../interfaces/dynamic-table-column.interface';
export declare abstract class AbstractDynamicTableDataProvider<T> implements DynamicTableDataInterface<T> {
    private palTableEventPublisher;
    refreshList(): void;
    updateItem(item: object): void;
    removeItem(item: object): void;
    getEventPublisher(): Observable<any>;
    nextElement(): void;
    previousElement(): void;
    getColumnsStyleUrl(): string;
    abstract getColumns(): DynamicTableColumnInterace[];
    abstract getData(sort: string, order: string, page: number): Observable<T[]>;
    abstract getIndicatorColor(item: T, rowIndex: number, groupIndex: number, groupName: string): string;
    abstract getIndicatorSign(item: T, rowIndex: number, groupIndex: number, groupName: string): string;
    abstract getHTMLIcon(item: T, rowIndex: number, groupIndex: number, groupName: string): string;
    abstract getTitle(item: T, rowIndex: number, groupIndex: number, groupName: string): string;
    abstract getDescription(item: T, rowIndex: number, groupIndex: number, groupName: string): string;
    abstract getHTMLContentSummary(item: T, rowIndex: number, groupIndex: number, groupName: string): string;
    abstract getAdditionalInfo(item: T, rowIndex: number, groupIndex: number, groupName: string): string;
    abstract getHTMLAction(item: T, rowIndex: number, groupIndex: number, groupName: string): string;
    abstract getOtherTextBased(item: T, rowIndex: number, groupIndex: number, groupName: string): string;
    abstract getOptions(): DynamicTableOptionInterface[];
}
