import { Subject } from 'rxjs';
var AbstractDynamicTableDataProvider = /** @class */ (function () {
    function AbstractDynamicTableDataProvider() {
        this.palTableEventPublisher = new Subject();
    }
    AbstractDynamicTableDataProvider.prototype.refreshList = function () {
        this.palTableEventPublisher.next({ event: 'refreshList', item: null });
    };
    AbstractDynamicTableDataProvider.prototype.updateItem = function (item) {
        this.palTableEventPublisher.next({ event: 'updateItem', item: item });
    };
    AbstractDynamicTableDataProvider.prototype.removeItem = function (item) {
        this.palTableEventPublisher.next({ event: 'removeItem', item: item });
    };
    AbstractDynamicTableDataProvider.prototype.getEventPublisher = function () {
        return this.palTableEventPublisher;
    };
    AbstractDynamicTableDataProvider.prototype.nextElement = function () {
        this.palTableEventPublisher.next({ event: 'nextItem', item: null });
    };
    AbstractDynamicTableDataProvider.prototype.previousElement = function () {
        this.palTableEventPublisher.next({ event: 'previousItem', item: null });
    };
    AbstractDynamicTableDataProvider.prototype.getColumnsStyleUrl = function () {
        return './styles/pal-table-cells-style.scss';
    };
    return AbstractDynamicTableDataProvider;
}());
export { AbstractDynamicTableDataProvider };
//# sourceMappingURL=abstract-dynamic-table-data.provider.js.map