var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Injectable } from '@angular/core';
import { of } from 'rxjs';
import { DynamicTableColumnDefinitionConstants } from './dynamic-table-column-definition.constants';
var DynamicTableDataProvider = /** @class */ (function () {
    function DynamicTableDataProvider() {
    }
    DynamicTableDataProvider.prototype.getColumns = function () {
        return [
            { columns: [DynamicTableColumnDefinitionConstants.INDICATOR_COLOR], names: ['Color'], backgroundColor: null },
            { columns: [DynamicTableColumnDefinitionConstants.DESCRIPTION], names: ['Description'], backgroundColor: null },
            { columns: [DynamicTableColumnDefinitionConstants.ADDITIONAL_INFO], names: ['Additional info'], backgroundColor: null },
            { columns: [DynamicTableColumnDefinitionConstants.HTML_CONTENT_SUMMARY], names: ['Content summary'], backgroundColor: null },
            { columns: [DynamicTableColumnDefinitionConstants.HTML_ACTIONS], names: ['Actions'], backgroundColor: null }
        ];
    };
    DynamicTableDataProvider.prototype.getColumnsStyleUrl = function () {
        return './pal-table-columns-theme.scss';
    };
    DynamicTableDataProvider.prototype.getData = function (sort, order, page) {
        var list = [];
        list.push({
            'color': '#47b733',
            'payload': 'Pal-Table payload data',
            'updateDate': new Date(),
            'contentSummary': '<b>Pal-Table content summary</>',
            'actions': '<button>Pal-Table action</button>'
        });
        return of(list);
    };
    DynamicTableDataProvider.prototype.getIndicatorColor = function (item, rowIndex, groupIndex, groupName) {
        return item['color'];
    };
    DynamicTableDataProvider.prototype.getIndicatorSign = function (item, rowIndex, groupIndex, groupName) {
        return '1';
    };
    DynamicTableDataProvider.prototype.getTitle = function (item, rowIndex, groupIndex, groupName) {
        return 'this is a sample title';
    };
    DynamicTableDataProvider.prototype.getDescription = function (item, rowIndex, groupIndex, groupName) {
        return 'this is a description';
    };
    DynamicTableDataProvider.prototype.getAdditionalInfo = function (item, rowIndex, groupIndex, groupName) {
        return 'This is an additional info';
    };
    DynamicTableDataProvider.prototype.getHTMLIcon = function (item, rowIndex, groupIndex, groupName) {
        return '<mat-icon>play_arrow</mat-icon>';
    };
    DynamicTableDataProvider.prototype.getHTMLContentSummary = function (item, rowIndex, groupIndex, groupName) {
        return '<b>test content summary</>';
    };
    DynamicTableDataProvider.prototype.getHTMLAction = function (item, rowIndex, groupIndex, groupName) {
        return '<button mat-raised-button (click)="openSideNav(element)">Open</button>';
    };
    DynamicTableDataProvider.prototype.getOtherTextBased = function (item, rowIndex, groupIndex, groupName) {
        return 'this is an other text based column';
    };
    DynamicTableDataProvider.prototype.performAction = function (action, item) {
        console.log('Perform action: ' + action + ' called!');
    };
    DynamicTableDataProvider.prototype.getEventPublisher = function () {
        return null;
    };
    DynamicTableDataProvider.prototype.getOptions = function () {
        var options = [];
        var groupBy = {
            groupByField: 'approval',
            rules: [
                {
                    'operator': '>',
                    'value': 1
                }
            ]
        };
        var tableOptions = {
            groupName: 'Requested',
            groupExpressions: [
                {
                    group: groupBy,
                    operator: ''
                }
            ],
            groupItemRowColor: '',
            hideColumns: true,
            columnOptions: []
        };
        options.push(tableOptions);
        return options;
    };
    DynamicTableDataProvider = __decorate([
        Injectable()
    ], DynamicTableDataProvider);
    return DynamicTableDataProvider;
}());
export { DynamicTableDataProvider };
//# sourceMappingURL=dynamic-table-data-provider.js.map