var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable, Injector, Component, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FlexLayoutModule } from '@angular/flex-layout';
import { MatButtonModule, MatIconModule, MatDividerModule, MatTooltipModule, MatSlideToggleModule } from '@angular/material';
import { AbstractDynamicBaseService } from '../../abstract-dynamic-base.service';
var DynamicTableDynamicCellBuilder = /** @class */ (function (_super) {
    __extends(DynamicTableDynamicCellBuilder, _super);
    function DynamicTableDynamicCellBuilder(injector) {
        var _this = _super.call(this, injector) || this;
        _this.injector = injector;
        return _this;
    }
    DynamicTableDynamicCellBuilder.prototype.createColumn = function (container, htmlTemplate, columnsStyleUrl, properties) {
        if (properties === void 0) { properties = {}; }
        var componentOptions = {
            selector: 'column',
            template: htmlTemplate,
            styleUrls: ['../styles/pal-table-cells-style.scss'] // columnsStyleUrl
        };
        var PalTableColumnComponent = /** @class */ (function () {
            function PalTableColumnComponent() {
            }
            PalTableColumnComponent.prototype.ngOnInit = function () { };
            PalTableColumnComponent.prototype.publishAction = function (action, item) {
                properties.actionMessage.setAction(action);
                properties.actionMessage.setItem(item);
                properties.actionsSubject.next(properties.actionMessage);
            };
            PalTableColumnComponent.prototype.onMouseOver = function (mouseEvent, item) {
                properties.mouseEventMessage.setMouseEvent(mouseEvent);
                properties.mouseEventMessage.setItem(item);
                properties.mouseEventsSubject.next(properties.mouseEventMessage);
            };
            PalTableColumnComponent.prototype.onMouseOut = function (mouseEvent, item) {
                properties.mouseEventMessage.setMouseEvent(mouseEvent);
                properties.mouseEventMessage.setItem(item);
                properties.mouseEventsSubject.next(properties.mouseEventMessage);
            };
            PalTableColumnComponent = __decorate([
                Component(componentOptions),
                __metadata("design:paramtypes", [])
            ], PalTableColumnComponent);
            return PalTableColumnComponent;
        }());
        var PalTableColumnModule = /** @class */ (function () {
            function PalTableColumnModule() {
            }
            PalTableColumnModule = __decorate([
                NgModule({
                    imports: [
                        CommonModule,
                        FlexLayoutModule,
                        MatButtonModule,
                        MatIconModule,
                        MatDividerModule,
                        MatTooltipModule,
                        MatSlideToggleModule,
                    ],
                    declarations: [
                        PalTableColumnComponent
                    ],
                    providers: []
                })
            ], PalTableColumnModule);
            return PalTableColumnModule;
        }());
        // Create the component if the container is empty
        if (container.length === 0) {
            this.createDynamicComponent(container, PalTableColumnModule, PalTableColumnComponent, properties);
        }
    };
    DynamicTableDynamicCellBuilder = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [Injector])
    ], DynamicTableDynamicCellBuilder);
    return DynamicTableDynamicCellBuilder;
}(AbstractDynamicBaseService));
export { DynamicTableDynamicCellBuilder };
//# sourceMappingURL=dynamic-table-dynamic-cell-builder.js.map