var DynamicTableUtils = /** @class */ (function () {
    function DynamicTableUtils() {
    }
    DynamicTableUtils.createHTMLAction = function (action, item) {
        return 'publishAction(\'' + action + '\', item)';
    };
    DynamicTableUtils.createMouseOverEvent = function (mouseOverEvent, item) {
        return 'onMouseOver(\'' + mouseOverEvent + '\', item)';
    };
    DynamicTableUtils.createMouseOutEvent = function (mouseOutEvent, item) {
        return 'onMouseOut(\'' + mouseOutEvent + '\', item)';
    };
    DynamicTableUtils.createMiniFabButton = function (matColor, value, backgroundColor) {
        if (backgroundColor === void 0) { backgroundColor = null; }
        var miniFabButton;
        miniFabButton = '<button mat-mini-fab color="' + matColor + '"';
        miniFabButton += (backgroundColor != null) ? ' style="background-color:' + backgroundColor + ';"' : '';
        miniFabButton += '>' + value + '</button> ';
        return miniFabButton;
    };
    DynamicTableUtils.convertToColumnIds = function (columns) {
        var columnIds = [];
        if (columns != null) {
            for (var _i = 0, columns_1 = columns; _i < columns_1.length; _i++) {
                var palTableColumn = columns_1[_i];
                for (var _a = 0, _b = palTableColumn.columns; _a < _b.length; _a++) {
                    var column = _b[_a];
                    columnIds.push(column);
                }
            }
        }
        return columnIds;
    };
    DynamicTableUtils.convertToColumnNames = function (columns) {
        var columnNames = [];
        if (columns != null) {
            for (var _i = 0, columns_2 = columns; _i < columns_2.length; _i++) {
                var palTableColumn = columns_2[_i];
                for (var _a = 0, _b = palTableColumn.names; _a < _b.length; _a++) {
                    var name_1 = _b[_a];
                    columnNames.push(name_1);
                }
            }
        }
        return columnNames;
    };
    DynamicTableUtils.getColumnNameById = function (columnId, columns) {
        if (columns != null) {
            for (var _i = 0, columns_3 = columns; _i < columns_3.length; _i++) {
                var palTableColumn = columns_3[_i];
                for (var i = 0; i < palTableColumn.columns.length; i++) {
                    var column = palTableColumn.columns[i];
                    if (column === columnId) {
                        return palTableColumn.names[i];
                    }
                }
            }
        }
        return '';
    };
    DynamicTableUtils.getColumnById = function (columnId, columns) {
        if (columns != null) {
            for (var _i = 0, columns_4 = columns; _i < columns_4.length; _i++) {
                var palTableColumn = columns_4[_i];
                for (var i = 0; i < palTableColumn.columns.length; i++) {
                    var column = palTableColumn.columns[i];
                    if (column === columnId) {
                        return palTableColumn;
                    }
                }
            }
        }
        return null;
    };
    return DynamicTableUtils;
}());
export { DynamicTableUtils };
//# sourceMappingURL=dynamic-table.utils.js.map