(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('@angular/common'), require('@angular/flex-layout'), require('@angular/material'), require('lodash'), require('@angular/platform-browser'), require('@angular/forms'), require('@angular/animations')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/core', 'rxjs', '@angular/common', '@angular/flex-layout', '@angular/material', 'lodash', '@angular/platform-browser', '@angular/forms', '@angular/animations'], factory) :
    (factory((global['ngx-dynamic-table'] = global['ngx-dynamic-table'] || {}, global['ngx-dynamic-table'].module = {}),global.ng.core,global.rxjs,global.ng.common,global['flex-layout'],global.ng.material,global.lodash,global.ng['platform-browser'],global.ng.forms,global.ng.animations));
}(this, (function (exports,core,rxjs,common,flexLayout,material,lodash,platformBrowser,forms,animations) { 'use strict';

    var AbstractWebWidgetComponent = /** @class */ (function () {
        function AbstractWebWidgetComponent() {
        }
        AbstractWebWidgetComponent.prototype.ngOnDestroy = function () {
            console.log("Component destroyed properly!");
        };
        return AbstractWebWidgetComponent;
    }());

    /*******************************************************************
     * @project Project: PalliaCare Mobile App                         *
     * @copyright Copyright (c) Arpage AG - 2017 - All rights reserved *
     * @address Address: Tobelweg 4, CH-8700 Küsnacht ZH               *
     * @web Web: www.arpage.ch                                         *
     * @file File: AbstractDynamicBaseService                          *
     * @author Gökhan Sari - <goekhan.sari@arpage.ch>                  *
     *******************************************************************/
    /**
     * Base class for all services that want to create components dynamically.
     */
    var AbstractDynamicBaseService = /** @class */ (function () {
        function AbstractDynamicBaseService(injector) {
            this.compiler = injector.get(core.Compiler);
        }
        /**
         * Creates a dynamic component on the fly by the given parameters.
         *
         * @param {ViewContainerRef} container
         * @param moduleToCreate
         * @param componentToCreate
         * @param properties
         * @returns {ComponentRef<any>}
         */
        AbstractDynamicBaseService.prototype.createDynamicComponent = function (container, moduleToCreate, componentToCreate, properties) {
            if (properties === void 0) { properties = {}; }
            // Compile module and components
            var mod = this.compiler.compileModuleAndAllComponentsSync(moduleToCreate);
            var factory = mod.componentFactories.find(function (comp) {
                return comp.componentType === componentToCreate;
            });
            // Create component
            var component = container.createComponent(factory);
            Object.assign(component.instance, properties);
            // If properties are changed at a later stage, the change detection
            // may need to be triggered manually:
            component.changeDetectorRef.detectChanges();
            return component;
        };
        return AbstractDynamicBaseService;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    var DynamicTableColumnDefinitionConstants = /** @class */ (function () {
        function DynamicTableColumnDefinitionConstants() {
        }
        Object.defineProperty(DynamicTableColumnDefinitionConstants.prototype, "INDICATOR_COLOR", {
            get: function () {
                return DynamicTableColumnDefinitionConstants.INDICATOR_COLOR;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DynamicTableColumnDefinitionConstants.prototype, "HTML_ICON", {
            get: function () {
                return DynamicTableColumnDefinitionConstants.HTML_ICON;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DynamicTableColumnDefinitionConstants.prototype, "TITLE", {
            get: function () {
                return DynamicTableColumnDefinitionConstants.TITLE;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DynamicTableColumnDefinitionConstants.prototype, "ADDITIONAL_INFO", {
            get: function () {
                return DynamicTableColumnDefinitionConstants.ADDITIONAL_INFO;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DynamicTableColumnDefinitionConstants.prototype, "DESCRIPTION", {
            get: function () {
                return DynamicTableColumnDefinitionConstants.DESCRIPTION;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DynamicTableColumnDefinitionConstants.prototype, "HTML_CONTENT_SUMMARY", {
            get: function () {
                return DynamicTableColumnDefinitionConstants.HTML_CONTENT_SUMMARY;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DynamicTableColumnDefinitionConstants.prototype, "HTML_ACTIONS", {
            get: function () {
                return DynamicTableColumnDefinitionConstants.HTML_ACTIONS;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DynamicTableColumnDefinitionConstants.prototype, "OTHER_TEXT_BASED1", {
            get: function () {
                return DynamicTableColumnDefinitionConstants.OTHER_TEXT_BASED1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DynamicTableColumnDefinitionConstants.prototype, "OTHER_TEXT_BASED2", {
            get: function () {
                return DynamicTableColumnDefinitionConstants.OTHER_TEXT_BASED2;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DynamicTableColumnDefinitionConstants.prototype, "OTHER_TEXT_BASED3", {
            get: function () {
                return DynamicTableColumnDefinitionConstants.OTHER_TEXT_BASED3;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DynamicTableColumnDefinitionConstants.prototype, "OTHER_TEXT_BASED4", {
            get: function () {
                return DynamicTableColumnDefinitionConstants.OTHER_TEXT_BASED4;
            },
            enumerable: true,
            configurable: true
        });
        DynamicTableColumnDefinitionConstants.INDICATOR_COLOR = 'indicatorColor';
        DynamicTableColumnDefinitionConstants.HTML_ICON = 'htmlIcon';
        DynamicTableColumnDefinitionConstants.TITLE = 'title';
        DynamicTableColumnDefinitionConstants.ADDITIONAL_INFO = 'additionalInfo';
        DynamicTableColumnDefinitionConstants.DESCRIPTION = 'description';
        DynamicTableColumnDefinitionConstants.HTML_CONTENT_SUMMARY = 'htmlContentSummary';
        DynamicTableColumnDefinitionConstants.HTML_ACTIONS = 'htmlActions';
        DynamicTableColumnDefinitionConstants.OTHER_TEXT_BASED1 = 'otherTextBased1';
        DynamicTableColumnDefinitionConstants.OTHER_TEXT_BASED2 = 'otherTextBased2';
        DynamicTableColumnDefinitionConstants.OTHER_TEXT_BASED3 = 'otherTextBased3';
        DynamicTableColumnDefinitionConstants.OTHER_TEXT_BASED4 = 'otherTextBased4';
        return DynamicTableColumnDefinitionConstants;
    }());

    var DynamicTableDataProvider = /** @class */ (function () {
        function DynamicTableDataProvider() {
        }
        DynamicTableDataProvider.prototype.getColumns = function () {
            return [
                { columns: [DynamicTableColumnDefinitionConstants.INDICATOR_COLOR], names: ['Color'], backgroundColor: null },
                { columns: [DynamicTableColumnDefinitionConstants.DESCRIPTION], names: ['Description'], backgroundColor: null },
                { columns: [DynamicTableColumnDefinitionConstants.ADDITIONAL_INFO], names: ['Additional info'], backgroundColor: null },
                { columns: [DynamicTableColumnDefinitionConstants.HTML_CONTENT_SUMMARY], names: ['Content summary'], backgroundColor: null },
                { columns: [DynamicTableColumnDefinitionConstants.HTML_ACTIONS], names: ['Actions'], backgroundColor: null }
            ];
        };
        DynamicTableDataProvider.prototype.getColumnsStyleUrl = function () {
            return './pal-table-columns-theme.scss';
        };
        DynamicTableDataProvider.prototype.getData = function (sort, order, page) {
            var list = [];
            list.push({
                'color': '#47b733',
                'payload': 'Pal-Table payload data',
                'updateDate': new Date(),
                'contentSummary': '<b>Pal-Table content summary</>',
                'actions': '<button>Pal-Table action</button>'
            });
            return rxjs.of(list);
        };
        DynamicTableDataProvider.prototype.getIndicatorColor = function (item, rowIndex, groupIndex, groupName) {
            return item['color'];
        };
        DynamicTableDataProvider.prototype.getIndicatorSign = function (item, rowIndex, groupIndex, groupName) {
            return '1';
        };
        DynamicTableDataProvider.prototype.getTitle = function (item, rowIndex, groupIndex, groupName) {
            return 'this is a sample title';
        };
        DynamicTableDataProvider.prototype.getDescription = function (item, rowIndex, groupIndex, groupName) {
            return 'this is a description';
        };
        DynamicTableDataProvider.prototype.getAdditionalInfo = function (item, rowIndex, groupIndex, groupName) {
            return 'This is an additional info';
        };
        DynamicTableDataProvider.prototype.getHTMLIcon = function (item, rowIndex, groupIndex, groupName) {
            return '<mat-icon>play_arrow</mat-icon>';
        };
        DynamicTableDataProvider.prototype.getHTMLContentSummary = function (item, rowIndex, groupIndex, groupName) {
            return '<b>test content summary</>';
        };
        DynamicTableDataProvider.prototype.getHTMLAction = function (item, rowIndex, groupIndex, groupName) {
            return '<button mat-raised-button (click)="openSideNav(element)">Open</button>';
        };
        DynamicTableDataProvider.prototype.getOtherTextBased = function (item, rowIndex, groupIndex, groupName) {
            return 'this is an other text based column';
        };
        DynamicTableDataProvider.prototype.performAction = function (action, item) {
            console.log('Perform action: ' + action + ' called!');
        };
        DynamicTableDataProvider.prototype.getEventPublisher = function () {
            return null;
        };
        DynamicTableDataProvider.prototype.getOptions = function () {
            var options = [];
            var groupBy = {
                groupByField: 'approval',
                rules: [
                    {
                        'operator': '>',
                        'value': 1
                    }
                ]
            };
            var tableOptions = {
                groupName: 'Requested',
                groupExpressions: [
                    {
                        group: groupBy,
                        operator: ''
                    }
                ],
                groupItemRowColor: '',
                hideColumns: true,
                columnOptions: []
            };
            options.push(tableOptions);
            return options;
        };
        DynamicTableDataProvider = __decorate([
            core.Injectable()
        ], DynamicTableDataProvider);
        return DynamicTableDataProvider;
    }());

    /**
     * Indicates the container name where the generated HTML will be injected.
     */
    var DynamicTableActionsContainerDirective = /** @class */ (function () {
        function DynamicTableActionsContainerDirective(viewContainerRef) {
            this.viewContainerRef = viewContainerRef;
        }
        __decorate([
            core.Input('palTableActionsContainer'),
            __metadata("design:type", String)
        ], DynamicTableActionsContainerDirective.prototype, "palTableActionsContainer", void 0);
        DynamicTableActionsContainerDirective = __decorate([
            core.Directive({ selector: '[palTableActionsContainer]' }),
            __metadata("design:paramtypes", [core.ViewContainerRef])
        ], DynamicTableActionsContainerDirective);
        return DynamicTableActionsContainerDirective;
    }());

    /**
     * Indicates the container name where the generated HTML will be injected.
     */
    var DynamicTableIconContainerDirective = /** @class */ (function () {
        function DynamicTableIconContainerDirective(viewContainerRef) {
            this.viewContainerRef = viewContainerRef;
        }
        __decorate([
            core.Input('palTableIconContainer'),
            __metadata("design:type", String)
        ], DynamicTableIconContainerDirective.prototype, "palTableIconContainer", void 0);
        DynamicTableIconContainerDirective = __decorate([
            core.Directive({ selector: '[palTableIconContainer]' }),
            __metadata("design:paramtypes", [core.ViewContainerRef])
        ], DynamicTableIconContainerDirective);
        return DynamicTableIconContainerDirective;
    }());

    /**
     * Indicates the container name where the generated HTML will be injected.
     */
    var DynamicTableContentSummaryContainerDirective = /** @class */ (function () {
        function DynamicTableContentSummaryContainerDirective(viewContainerRef) {
            this.viewContainerRef = viewContainerRef;
        }
        __decorate([
            core.Input('palTableContentSummaryContainer'),
            __metadata("design:type", String)
        ], DynamicTableContentSummaryContainerDirective.prototype, "palTableContentSummaryContainer", void 0);
        DynamicTableContentSummaryContainerDirective = __decorate([
            core.Directive({ selector: '[palTableContentSummaryContainer]' }),
            __metadata("design:paramtypes", [core.ViewContainerRef])
        ], DynamicTableContentSummaryContainerDirective);
        return DynamicTableContentSummaryContainerDirective;
    }());

    var DynamicTableActionMessageService = /** @class */ (function () {
        function DynamicTableActionMessageService() {
        }
        DynamicTableActionMessageService.prototype.setAction = function (action) {
            this.action = action;
        };
        DynamicTableActionMessageService.prototype.getAction = function () {
            return this.action;
        };
        DynamicTableActionMessageService.prototype.setItem = function (item) {
            this.item = item;
        };
        DynamicTableActionMessageService.prototype.getItem = function () {
            return this.item;
        };
        DynamicTableActionMessageService.prototype.setPublisher = function (publisher) {
            this.publisher = publisher;
        };
        DynamicTableActionMessageService.prototype.getPubisher = function () {
            return this.publisher;
        };
        DynamicTableActionMessageService = __decorate([
            core.Injectable()
        ], DynamicTableActionMessageService);
        return DynamicTableActionMessageService;
    }());

    /**
     * Indicates the container name where the generated HTML will be injected.
     */
    var PalTableAdditionalInfoContainerDirective = /** @class */ (function () {
        function PalTableAdditionalInfoContainerDirective(viewContainerRef) {
            this.viewContainerRef = viewContainerRef;
        }
        __decorate([
            core.Input('palTableAdditionalInfoContainer'),
            __metadata("design:type", String)
        ], PalTableAdditionalInfoContainerDirective.prototype, "palTableAdditionalInfoContainer", void 0);
        PalTableAdditionalInfoContainerDirective = __decorate([
            core.Directive({ selector: '[palTableAdditionalInfoContainer]' }),
            __metadata("design:paramtypes", [core.ViewContainerRef])
        ], PalTableAdditionalInfoContainerDirective);
        return PalTableAdditionalInfoContainerDirective;
    }());

    /**
     * Indicates the container name where the generated HTML will be injected.
     */
    var DynamicTableDescriptionContainerDirective = /** @class */ (function () {
        function DynamicTableDescriptionContainerDirective(viewContainerRef) {
            this.viewContainerRef = viewContainerRef;
        }
        __decorate([
            core.Input('palTableDescriptionContainer'),
            __metadata("design:type", String)
        ], DynamicTableDescriptionContainerDirective.prototype, "palTableDescriptionContainer", void 0);
        DynamicTableDescriptionContainerDirective = __decorate([
            core.Directive({ selector: '[palTableDescriptionContainer]' }),
            __metadata("design:paramtypes", [core.ViewContainerRef])
        ], DynamicTableDescriptionContainerDirective);
        return DynamicTableDescriptionContainerDirective;
    }());

    /**
     * Indicates the container name where the generated HTML will be injected.
     */
    var DynamicTableColumnsContainerDirective = /** @class */ (function () {
        function DynamicTableColumnsContainerDirective(viewContainerRef) {
            this.viewContainerRef = viewContainerRef;
        }
        __decorate([
            core.Input('palDynamicTableColumnsContainer'),
            __metadata("design:type", String)
        ], DynamicTableColumnsContainerDirective.prototype, "palDynamicTableColumnsContainer", void 0);
        DynamicTableColumnsContainerDirective = __decorate([
            core.Directive({ selector: '[palDynamicTableColumnsContainer]' }),
            __metadata("design:paramtypes", [core.ViewContainerRef])
        ], DynamicTableColumnsContainerDirective);
        return DynamicTableColumnsContainerDirective;
    }());

    /**
     * Indicates the container name where the generated HTML will be injected.
     */
    var DynamicTableContainerDirective = /** @class */ (function () {
        function DynamicTableContainerDirective(viewContainerRef) {
            this.viewContainerRef = viewContainerRef;
        }
        __decorate([
            core.Input('palTableContainer'),
            __metadata("design:type", String)
        ], DynamicTableContainerDirective.prototype, "palTableContainer", void 0);
        DynamicTableContainerDirective = __decorate([
            core.Directive({ selector: '[palTableContainer]' }),
            __metadata("design:paramtypes", [core.ViewContainerRef])
        ], DynamicTableContainerDirective);
        return DynamicTableContainerDirective;
    }());

    /**
     * Indicates the container name where the generated HTML will be injected.
     */
    var DynamicTableTitleContainerDirective = /** @class */ (function () {
        function DynamicTableTitleContainerDirective(viewContainerRef) {
            this.viewContainerRef = viewContainerRef;
        }
        __decorate([
            core.Input('palTableTitleContainer'),
            __metadata("design:type", String)
        ], DynamicTableTitleContainerDirective.prototype, "palTableTitleContainer", void 0);
        DynamicTableTitleContainerDirective = __decorate([
            core.Directive({ selector: '[palTableTitleContainer]' }),
            __metadata("design:paramtypes", [core.ViewContainerRef])
        ], DynamicTableTitleContainerDirective);
        return DynamicTableTitleContainerDirective;
    }());

    var DynamicTableDynamicCellBuilder = /** @class */ (function (_super) {
        __extends(DynamicTableDynamicCellBuilder, _super);
        function DynamicTableDynamicCellBuilder(injector) {
            var _this = _super.call(this, injector) || this;
            _this.injector = injector;
            return _this;
        }
        DynamicTableDynamicCellBuilder.prototype.createColumn = function (container, htmlTemplate, columnsStyleUrl, properties) {
            if (properties === void 0) { properties = {}; }
            var componentOptions = {
                selector: 'column',
                template: htmlTemplate,
                styleUrls: ['../styles/pal-table-cells-style.scss'] // columnsStyleUrl
            };
            var PalTableColumnComponent = /** @class */ (function () {
                function PalTableColumnComponent() {
                }
                PalTableColumnComponent.prototype.ngOnInit = function () { };
                PalTableColumnComponent.prototype.publishAction = function (action, item) {
                    properties.actionMessage.setAction(action);
                    properties.actionMessage.setItem(item);
                    properties.actionsSubject.next(properties.actionMessage);
                };
                PalTableColumnComponent.prototype.onMouseOver = function (mouseEvent, item) {
                    properties.mouseEventMessage.setMouseEvent(mouseEvent);
                    properties.mouseEventMessage.setItem(item);
                    properties.mouseEventsSubject.next(properties.mouseEventMessage);
                };
                PalTableColumnComponent.prototype.onMouseOut = function (mouseEvent, item) {
                    properties.mouseEventMessage.setMouseEvent(mouseEvent);
                    properties.mouseEventMessage.setItem(item);
                    properties.mouseEventsSubject.next(properties.mouseEventMessage);
                };
                PalTableColumnComponent = __decorate([
                    core.Component(componentOptions),
                    __metadata("design:paramtypes", [])
                ], PalTableColumnComponent);
                return PalTableColumnComponent;
            }());
            var PalTableColumnModule = /** @class */ (function () {
                function PalTableColumnModule() {
                }
                PalTableColumnModule = __decorate([
                    core.NgModule({
                        imports: [
                            common.CommonModule,
                            flexLayout.FlexLayoutModule,
                            material.MatButtonModule,
                            material.MatIconModule,
                            material.MatDividerModule,
                            material.MatTooltipModule,
                            material.MatSlideToggleModule,
                        ],
                        declarations: [
                            PalTableColumnComponent
                        ],
                        providers: []
                    })
                ], PalTableColumnModule);
                return PalTableColumnModule;
            }());
            // Create the component if the container is empty
            if (container.length === 0) {
                this.createDynamicComponent(container, PalTableColumnModule, PalTableColumnComponent, properties);
            }
        };
        DynamicTableDynamicCellBuilder = __decorate([
            core.Injectable(),
            __metadata("design:paramtypes", [core.Injector])
        ], DynamicTableDynamicCellBuilder);
        return DynamicTableDynamicCellBuilder;
    }(AbstractDynamicBaseService));

    var DynamicTableUtils = /** @class */ (function () {
        function DynamicTableUtils() {
        }
        DynamicTableUtils.createHTMLAction = function (action, item) {
            return 'publishAction(\'' + action + '\', item)';
        };
        DynamicTableUtils.createMouseOverEvent = function (mouseOverEvent, item) {
            return 'onMouseOver(\'' + mouseOverEvent + '\', item)';
        };
        DynamicTableUtils.createMouseOutEvent = function (mouseOutEvent, item) {
            return 'onMouseOut(\'' + mouseOutEvent + '\', item)';
        };
        DynamicTableUtils.createMiniFabButton = function (matColor, value, backgroundColor) {
            if (backgroundColor === void 0) { backgroundColor = null; }
            var miniFabButton;
            miniFabButton = '<button mat-mini-fab color="' + matColor + '"';
            miniFabButton += (backgroundColor != null) ? ' style="background-color:' + backgroundColor + ';"' : '';
            miniFabButton += '>' + value + '</button> ';
            return miniFabButton;
        };
        DynamicTableUtils.convertToColumnIds = function (columns) {
            var columnIds = [];
            if (columns != null) {
                for (var _i = 0, columns_1 = columns; _i < columns_1.length; _i++) {
                    var palTableColumn = columns_1[_i];
                    for (var _a = 0, _b = palTableColumn.columns; _a < _b.length; _a++) {
                        var column = _b[_a];
                        columnIds.push(column);
                    }
                }
            }
            return columnIds;
        };
        DynamicTableUtils.convertToColumnNames = function (columns) {
            var columnNames = [];
            if (columns != null) {
                for (var _i = 0, columns_2 = columns; _i < columns_2.length; _i++) {
                    var palTableColumn = columns_2[_i];
                    for (var _a = 0, _b = palTableColumn.names; _a < _b.length; _a++) {
                        var name_1 = _b[_a];
                        columnNames.push(name_1);
                    }
                }
            }
            return columnNames;
        };
        DynamicTableUtils.getColumnNameById = function (columnId, columns) {
            if (columns != null) {
                for (var _i = 0, columns_3 = columns; _i < columns_3.length; _i++) {
                    var palTableColumn = columns_3[_i];
                    for (var i = 0; i < palTableColumn.columns.length; i++) {
                        var column = palTableColumn.columns[i];
                        if (column === columnId) {
                            return palTableColumn.names[i];
                        }
                    }
                }
            }
            return '';
        };
        DynamicTableUtils.getColumnById = function (columnId, columns) {
            if (columns != null) {
                for (var _i = 0, columns_4 = columns; _i < columns_4.length; _i++) {
                    var palTableColumn = columns_4[_i];
                    for (var i = 0; i < palTableColumn.columns.length; i++) {
                        var column = palTableColumn.columns[i];
                        if (column === columnId) {
                            return palTableColumn;
                        }
                    }
                }
            }
            return null;
        };
        return DynamicTableUtils;
    }());

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var errorObject = { e: {} };

    /** PURE_IMPORTS_START _errorObject PURE_IMPORTS_END */
    var tryCatchTarget;
    function tryCatcher() {
        try {
            return tryCatchTarget.apply(this, arguments);
        }
        catch (e) {
            errorObject.e = e;
            return errorObject;
        }
    }
    function tryCatch(fn) {
        tryCatchTarget = fn;
        return tryCatcher;
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function isFunction(x) {
        return typeof x === 'function';
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var _enable_super_gross_mode_that_will_cause_bad_things = false;
    var config = {
        Promise: undefined,
        set useDeprecatedSynchronousErrorHandling(value) {
            if (value) {
                var error = /*@__PURE__*/ new Error();
                /*@__PURE__*/ console.warn('DEPRECATED! RxJS was set to use deprecated synchronous error handling behavior by code at: \n' + error.stack);
            }
            else if (_enable_super_gross_mode_that_will_cause_bad_things) {
                /*@__PURE__*/ console.log('RxJS: Back to a better error behavior. Thank you. <3');
            }
            _enable_super_gross_mode_that_will_cause_bad_things = value;
        },
        get useDeprecatedSynchronousErrorHandling() {
            return _enable_super_gross_mode_that_will_cause_bad_things;
        },
    };

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function hostReportError(err) {
        setTimeout(function () { throw err; });
    }

    /** PURE_IMPORTS_START _config,_util_hostReportError PURE_IMPORTS_END */
    var empty = {
        closed: true,
        next: function (value) { },
        error: function (err) {
            if (config.useDeprecatedSynchronousErrorHandling) {
                throw err;
            }
            else {
                hostReportError(err);
            }
        },
        complete: function () { }
    };

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var isArray = Array.isArray || (function (x) { return x && typeof x.length === 'number'; });

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function isObject(x) {
        return x != null && typeof x === 'object';
    }

    /** PURE_IMPORTS_START tslib PURE_IMPORTS_END */
    var UnsubscriptionError = /*@__PURE__*/ (function (_super) {
        __extends(UnsubscriptionError, _super);
        function UnsubscriptionError(errors) {
            var _this = _super.call(this, errors ?
                errors.length + " errors occurred during unsubscription:\n  " + errors.map(function (err, i) { return i + 1 + ") " + err.toString(); }).join('\n  ') : '') || this;
            _this.errors = errors;
            _this.name = 'UnsubscriptionError';
            Object.setPrototypeOf(_this, UnsubscriptionError.prototype);
            return _this;
        }
        return UnsubscriptionError;
    }(Error));

    /** PURE_IMPORTS_START _util_isArray,_util_isObject,_util_isFunction,_util_tryCatch,_util_errorObject,_util_UnsubscriptionError PURE_IMPORTS_END */
    var Subscription = /*@__PURE__*/ (function () {
        function Subscription(unsubscribe) {
            this.closed = false;
            this._parent = null;
            this._parents = null;
            this._subscriptions = null;
            if (unsubscribe) {
                this._unsubscribe = unsubscribe;
            }
        }
        Subscription.prototype.unsubscribe = function () {
            var hasErrors = false;
            var errors;
            if (this.closed) {
                return;
            }
            var _a = this, _parent = _a._parent, _parents = _a._parents, _unsubscribe = _a._unsubscribe, _subscriptions = _a._subscriptions;
            this.closed = true;
            this._parent = null;
            this._parents = null;
            this._subscriptions = null;
            var index = -1;
            var len = _parents ? _parents.length : 0;
            while (_parent) {
                _parent.remove(this);
                _parent = ++index < len && _parents[index] || null;
            }
            if (isFunction(_unsubscribe)) {
                var trial = tryCatch(_unsubscribe).call(this);
                if (trial === errorObject) {
                    hasErrors = true;
                    errors = errors || (errorObject.e instanceof UnsubscriptionError ?
                        flattenUnsubscriptionErrors(errorObject.e.errors) : [errorObject.e]);
                }
            }
            if (isArray(_subscriptions)) {
                index = -1;
                len = _subscriptions.length;
                while (++index < len) {
                    var sub = _subscriptions[index];
                    if (isObject(sub)) {
                        var trial = tryCatch(sub.unsubscribe).call(sub);
                        if (trial === errorObject) {
                            hasErrors = true;
                            errors = errors || [];
                            var err = errorObject.e;
                            if (err instanceof UnsubscriptionError) {
                                errors = errors.concat(flattenUnsubscriptionErrors(err.errors));
                            }
                            else {
                                errors.push(err);
                            }
                        }
                    }
                }
            }
            if (hasErrors) {
                throw new UnsubscriptionError(errors);
            }
        };
        Subscription.prototype.add = function (teardown) {
            if (!teardown || (teardown === Subscription.EMPTY)) {
                return Subscription.EMPTY;
            }
            if (teardown === this) {
                return this;
            }
            var subscription = teardown;
            switch (typeof teardown) {
                case 'function':
                    subscription = new Subscription(teardown);
                case 'object':
                    if (subscription.closed || typeof subscription.unsubscribe !== 'function') {
                        return subscription;
                    }
                    else if (this.closed) {
                        subscription.unsubscribe();
                        return subscription;
                    }
                    else if (typeof subscription._addParent !== 'function') {
                        var tmp = subscription;
                        subscription = new Subscription();
                        subscription._subscriptions = [tmp];
                    }
                    break;
                default:
                    throw new Error('unrecognized teardown ' + teardown + ' added to Subscription.');
            }
            var subscriptions = this._subscriptions || (this._subscriptions = []);
            subscriptions.push(subscription);
            subscription._addParent(this);
            return subscription;
        };
        Subscription.prototype.remove = function (subscription) {
            var subscriptions = this._subscriptions;
            if (subscriptions) {
                var subscriptionIndex = subscriptions.indexOf(subscription);
                if (subscriptionIndex !== -1) {
                    subscriptions.splice(subscriptionIndex, 1);
                }
            }
        };
        Subscription.prototype._addParent = function (parent) {
            var _a = this, _parent = _a._parent, _parents = _a._parents;
            if (!_parent || _parent === parent) {
                this._parent = parent;
            }
            else if (!_parents) {
                this._parents = [parent];
            }
            else if (_parents.indexOf(parent) === -1) {
                _parents.push(parent);
            }
        };
        Subscription.EMPTY = (function (empty) {
            empty.closed = true;
            return empty;
        }(new Subscription()));
        return Subscription;
    }());
    function flattenUnsubscriptionErrors(errors) {
        return errors.reduce(function (errs, err) { return errs.concat((err instanceof UnsubscriptionError) ? err.errors : err); }, []);
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var rxSubscriber = (typeof Symbol === 'function' && typeof Symbol.for === 'function')
        ? /*@__PURE__*/ Symbol.for('rxSubscriber')
        : '@@rxSubscriber';

    /** PURE_IMPORTS_START tslib,_util_isFunction,_Observer,_Subscription,_internal_symbol_rxSubscriber,_config,_util_hostReportError PURE_IMPORTS_END */
    var Subscriber = /*@__PURE__*/ (function (_super) {
        __extends(Subscriber, _super);
        function Subscriber(destinationOrNext, error, complete) {
            var _this = _super.call(this) || this;
            _this.syncErrorValue = null;
            _this.syncErrorThrown = false;
            _this.syncErrorThrowable = false;
            _this.isStopped = false;
            switch (arguments.length) {
                case 0:
                    _this.destination = empty;
                    break;
                case 1:
                    if (!destinationOrNext) {
                        _this.destination = empty;
                        break;
                    }
                    if (typeof destinationOrNext === 'object') {
                        if (isTrustedSubscriber(destinationOrNext)) {
                            var trustedSubscriber = destinationOrNext[rxSubscriber]();
                            _this.syncErrorThrowable = trustedSubscriber.syncErrorThrowable;
                            _this.destination = trustedSubscriber;
                            trustedSubscriber.add(_this);
                        }
                        else {
                            _this.syncErrorThrowable = true;
                            _this.destination = new SafeSubscriber(_this, destinationOrNext);
                        }
                        break;
                    }
                default:
                    _this.syncErrorThrowable = true;
                    _this.destination = new SafeSubscriber(_this, destinationOrNext, error, complete);
                    break;
            }
            return _this;
        }
        Subscriber.prototype[rxSubscriber] = function () { return this; };
        Subscriber.create = function (next, error, complete) {
            var subscriber = new Subscriber(next, error, complete);
            subscriber.syncErrorThrowable = false;
            return subscriber;
        };
        Subscriber.prototype.next = function (value) {
            if (!this.isStopped) {
                this._next(value);
            }
        };
        Subscriber.prototype.error = function (err) {
            if (!this.isStopped) {
                this.isStopped = true;
                this._error(err);
            }
        };
        Subscriber.prototype.complete = function () {
            if (!this.isStopped) {
                this.isStopped = true;
                this._complete();
            }
        };
        Subscriber.prototype.unsubscribe = function () {
            if (this.closed) {
                return;
            }
            this.isStopped = true;
            _super.prototype.unsubscribe.call(this);
        };
        Subscriber.prototype._next = function (value) {
            this.destination.next(value);
        };
        Subscriber.prototype._error = function (err) {
            this.destination.error(err);
            this.unsubscribe();
        };
        Subscriber.prototype._complete = function () {
            this.destination.complete();
            this.unsubscribe();
        };
        Subscriber.prototype._unsubscribeAndRecycle = function () {
            var _a = this, _parent = _a._parent, _parents = _a._parents;
            this._parent = null;
            this._parents = null;
            this.unsubscribe();
            this.closed = false;
            this.isStopped = false;
            this._parent = _parent;
            this._parents = _parents;
            return this;
        };
        return Subscriber;
    }(Subscription));
    var SafeSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SafeSubscriber, _super);
        function SafeSubscriber(_parentSubscriber, observerOrNext, error, complete) {
            var _this = _super.call(this) || this;
            _this._parentSubscriber = _parentSubscriber;
            var next;
            var context = _this;
            if (isFunction(observerOrNext)) {
                next = observerOrNext;
            }
            else if (observerOrNext) {
                next = observerOrNext.next;
                error = observerOrNext.error;
                complete = observerOrNext.complete;
                if (observerOrNext !== empty) {
                    context = Object.create(observerOrNext);
                    if (isFunction(context.unsubscribe)) {
                        _this.add(context.unsubscribe.bind(context));
                    }
                    context.unsubscribe = _this.unsubscribe.bind(_this);
                }
            }
            _this._context = context;
            _this._next = next;
            _this._error = error;
            _this._complete = complete;
            return _this;
        }
        SafeSubscriber.prototype.next = function (value) {
            if (!this.isStopped && this._next) {
                var _parentSubscriber = this._parentSubscriber;
                if (!config.useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                    this.__tryOrUnsub(this._next, value);
                }
                else if (this.__tryOrSetError(_parentSubscriber, this._next, value)) {
                    this.unsubscribe();
                }
            }
        };
        SafeSubscriber.prototype.error = function (err) {
            if (!this.isStopped) {
                var _parentSubscriber = this._parentSubscriber;
                var useDeprecatedSynchronousErrorHandling = config.useDeprecatedSynchronousErrorHandling;
                if (this._error) {
                    if (!useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                        this.__tryOrUnsub(this._error, err);
                        this.unsubscribe();
                    }
                    else {
                        this.__tryOrSetError(_parentSubscriber, this._error, err);
                        this.unsubscribe();
                    }
                }
                else if (!_parentSubscriber.syncErrorThrowable) {
                    this.unsubscribe();
                    if (useDeprecatedSynchronousErrorHandling) {
                        throw err;
                    }
                    hostReportError(err);
                }
                else {
                    if (useDeprecatedSynchronousErrorHandling) {
                        _parentSubscriber.syncErrorValue = err;
                        _parentSubscriber.syncErrorThrown = true;
                    }
                    else {
                        hostReportError(err);
                    }
                    this.unsubscribe();
                }
            }
        };
        SafeSubscriber.prototype.complete = function () {
            var _this = this;
            if (!this.isStopped) {
                var _parentSubscriber = this._parentSubscriber;
                if (this._complete) {
                    var wrappedComplete = function () { return _this._complete.call(_this._context); };
                    if (!config.useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                        this.__tryOrUnsub(wrappedComplete);
                        this.unsubscribe();
                    }
                    else {
                        this.__tryOrSetError(_parentSubscriber, wrappedComplete);
                        this.unsubscribe();
                    }
                }
                else {
                    this.unsubscribe();
                }
            }
        };
        SafeSubscriber.prototype.__tryOrUnsub = function (fn, value) {
            try {
                fn.call(this._context, value);
            }
            catch (err) {
                this.unsubscribe();
                if (config.useDeprecatedSynchronousErrorHandling) {
                    throw err;
                }
                else {
                    hostReportError(err);
                }
            }
        };
        SafeSubscriber.prototype.__tryOrSetError = function (parent, fn, value) {
            if (!config.useDeprecatedSynchronousErrorHandling) {
                throw new Error('bad call');
            }
            try {
                fn.call(this._context, value);
            }
            catch (err) {
                if (config.useDeprecatedSynchronousErrorHandling) {
                    parent.syncErrorValue = err;
                    parent.syncErrorThrown = true;
                    return true;
                }
                else {
                    hostReportError(err);
                    return true;
                }
            }
            return false;
        };
        SafeSubscriber.prototype._unsubscribe = function () {
            var _parentSubscriber = this._parentSubscriber;
            this._context = null;
            this._parentSubscriber = null;
            _parentSubscriber.unsubscribe();
        };
        return SafeSubscriber;
    }(Subscriber));
    function isTrustedSubscriber(obj) {
        return obj instanceof Subscriber || ('syncErrorThrowable' in obj && obj[rxSubscriber]);
    }

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    var OuterSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(OuterSubscriber, _super);
        function OuterSubscriber() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        OuterSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.destination.next(innerValue);
        };
        OuterSubscriber.prototype.notifyError = function (error, innerSub) {
            this.destination.error(error);
        };
        OuterSubscriber.prototype.notifyComplete = function (innerSub) {
            this.destination.complete();
        };
        return OuterSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    var InnerSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(InnerSubscriber, _super);
        function InnerSubscriber(parent, outerValue, outerIndex) {
            var _this = _super.call(this) || this;
            _this.parent = parent;
            _this.outerValue = outerValue;
            _this.outerIndex = outerIndex;
            _this.index = 0;
            return _this;
        }
        InnerSubscriber.prototype._next = function (value) {
            this.parent.notifyNext(this.outerValue, value, this.outerIndex, this.index++, this);
        };
        InnerSubscriber.prototype._error = function (error) {
            this.parent.notifyError(error, this);
            this.unsubscribe();
        };
        InnerSubscriber.prototype._complete = function () {
            this.parent.notifyComplete(this);
            this.unsubscribe();
        };
        return InnerSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START _Subscriber,_symbol_rxSubscriber,_Observer PURE_IMPORTS_END */
    function toSubscriber(nextOrObserver, error, complete) {
        if (nextOrObserver) {
            if (nextOrObserver instanceof Subscriber) {
                return nextOrObserver;
            }
            if (nextOrObserver[rxSubscriber]) {
                return nextOrObserver[rxSubscriber]();
            }
        }
        if (!nextOrObserver && !error && !complete) {
            return new Subscriber(empty);
        }
        return new Subscriber(nextOrObserver, error, complete);
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var observable = typeof Symbol === 'function' && Symbol.observable || '@@observable';

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function noop() { }

    /** PURE_IMPORTS_START _noop PURE_IMPORTS_END */
    function pipeFromArray(fns) {
        if (!fns) {
            return noop;
        }
        if (fns.length === 1) {
            return fns[0];
        }
        return function piped(input) {
            return fns.reduce(function (prev, fn) { return fn(prev); }, input);
        };
    }

    /** PURE_IMPORTS_START _util_toSubscriber,_internal_symbol_observable,_util_pipe,_config PURE_IMPORTS_END */
    var Observable = /*@__PURE__*/ (function () {
        function Observable(subscribe) {
            this._isScalar = false;
            if (subscribe) {
                this._subscribe = subscribe;
            }
        }
        Observable.prototype.lift = function (operator) {
            var observable$$1 = new Observable();
            observable$$1.source = this;
            observable$$1.operator = operator;
            return observable$$1;
        };
        Observable.prototype.subscribe = function (observerOrNext, error, complete) {
            var operator = this.operator;
            var sink = toSubscriber(observerOrNext, error, complete);
            if (operator) {
                operator.call(sink, this.source);
            }
            else {
                sink.add(this.source || (config.useDeprecatedSynchronousErrorHandling && !sink.syncErrorThrowable) ?
                    this._subscribe(sink) :
                    this._trySubscribe(sink));
            }
            if (config.useDeprecatedSynchronousErrorHandling) {
                if (sink.syncErrorThrowable) {
                    sink.syncErrorThrowable = false;
                    if (sink.syncErrorThrown) {
                        throw sink.syncErrorValue;
                    }
                }
            }
            return sink;
        };
        Observable.prototype._trySubscribe = function (sink) {
            try {
                return this._subscribe(sink);
            }
            catch (err) {
                if (config.useDeprecatedSynchronousErrorHandling) {
                    sink.syncErrorThrown = true;
                    sink.syncErrorValue = err;
                }
                sink.error(err);
            }
        };
        Observable.prototype.forEach = function (next, promiseCtor) {
            var _this = this;
            promiseCtor = getPromiseCtor(promiseCtor);
            return new promiseCtor(function (resolve, reject) {
                var subscription;
                subscription = _this.subscribe(function (value) {
                    try {
                        next(value);
                    }
                    catch (err) {
                        reject(err);
                        if (subscription) {
                            subscription.unsubscribe();
                        }
                    }
                }, reject, resolve);
            });
        };
        Observable.prototype._subscribe = function (subscriber) {
            var source = this.source;
            return source && source.subscribe(subscriber);
        };
        Observable.prototype[observable] = function () {
            return this;
        };
        Observable.prototype.pipe = function () {
            var operations = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                operations[_i] = arguments[_i];
            }
            if (operations.length === 0) {
                return this;
            }
            return pipeFromArray(operations)(this);
        };
        Observable.prototype.toPromise = function (promiseCtor) {
            var _this = this;
            promiseCtor = getPromiseCtor(promiseCtor);
            return new promiseCtor(function (resolve, reject) {
                var value;
                _this.subscribe(function (x) { return value = x; }, function (err) { return reject(err); }, function () { return resolve(value); });
            });
        };
        Observable.create = function (subscribe) {
            return new Observable(subscribe);
        };
        return Observable;
    }());
    function getPromiseCtor(promiseCtor) {
        if (!promiseCtor) {
            promiseCtor = config.Promise || Promise;
        }
        if (!promiseCtor) {
            throw new Error('no Promise impl found');
        }
        return promiseCtor;
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var subscribeToArray = function (array) {
        return function (subscriber) {
            for (var i = 0, len = array.length; i < len && !subscriber.closed; i++) {
                subscriber.next(array[i]);
            }
            if (!subscriber.closed) {
                subscriber.complete();
            }
        };
    };

    /** PURE_IMPORTS_START _hostReportError PURE_IMPORTS_END */
    var subscribeToPromise = function (promise) {
        return function (subscriber) {
            promise.then(function (value) {
                if (!subscriber.closed) {
                    subscriber.next(value);
                    subscriber.complete();
                }
            }, function (err) { return subscriber.error(err); })
                .then(null, hostReportError);
            return subscriber;
        };
    };

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function getSymbolIterator() {
        if (typeof Symbol !== 'function' || !Symbol.iterator) {
            return '@@iterator';
        }
        return Symbol.iterator;
    }
    var iterator = /*@__PURE__*/ getSymbolIterator();

    /** PURE_IMPORTS_START _symbol_iterator PURE_IMPORTS_END */
    var subscribeToIterable = function (iterable) {
        return function (subscriber) {
            var iterator$$1 = iterable[iterator]();
            do {
                var item = iterator$$1.next();
                if (item.done) {
                    subscriber.complete();
                    break;
                }
                subscriber.next(item.value);
                if (subscriber.closed) {
                    break;
                }
            } while (true);
            if (typeof iterator$$1.return === 'function') {
                subscriber.add(function () {
                    if (iterator$$1.return) {
                        iterator$$1.return();
                    }
                });
            }
            return subscriber;
        };
    };

    /** PURE_IMPORTS_START _symbol_observable PURE_IMPORTS_END */
    var subscribeToObservable = function (obj) {
        return function (subscriber) {
            var obs = obj[observable]();
            if (typeof obs.subscribe !== 'function') {
                throw new TypeError('Provided object does not correctly implement Symbol.observable');
            }
            else {
                return obs.subscribe(subscriber);
            }
        };
    };

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var isArrayLike = (function (x) { return x && typeof x.length === 'number' && typeof x !== 'function'; });

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function isPromise(value) {
        return value && typeof value.subscribe !== 'function' && typeof value.then === 'function';
    }

    /** PURE_IMPORTS_START _Observable,_subscribeToArray,_subscribeToPromise,_subscribeToIterable,_subscribeToObservable,_isArrayLike,_isPromise,_isObject,_symbol_iterator,_symbol_observable PURE_IMPORTS_END */
    var subscribeTo = function (result) {
        if (result instanceof Observable) {
            return function (subscriber) {
                if (result._isScalar) {
                    subscriber.next(result.value);
                    subscriber.complete();
                    return undefined;
                }
                else {
                    return result.subscribe(subscriber);
                }
            };
        }
        else if (result && typeof result[observable] === 'function') {
            return subscribeToObservable(result);
        }
        else if (isArrayLike(result)) {
            return subscribeToArray(result);
        }
        else if (isPromise(result)) {
            return subscribeToPromise(result);
        }
        else if (result && typeof result[iterator] === 'function') {
            return subscribeToIterable(result);
        }
        else {
            var value = isObject(result) ? 'an invalid object' : "'" + result + "'";
            var msg = "You provided " + value + " where a stream was expected."
                + ' You can provide an Observable, Promise, Array, or Iterable.';
            throw new TypeError(msg);
        }
    };

    /** PURE_IMPORTS_START _InnerSubscriber,_subscribeTo PURE_IMPORTS_END */
    function subscribeToResult(outerSubscriber, result, outerValue, outerIndex) {
        var destination = new InnerSubscriber(outerSubscriber, outerValue, outerIndex);
        return subscribeTo(result)(destination);
    }

    /** PURE_IMPORTS_START tslib,_util_tryCatch,_util_errorObject,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var AuditSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(AuditSubscriber, _super);
        function AuditSubscriber(destination, durationSelector) {
            var _this = _super.call(this, destination) || this;
            _this.durationSelector = durationSelector;
            _this.hasValue = false;
            return _this;
        }
        AuditSubscriber.prototype._next = function (value) {
            this.value = value;
            this.hasValue = true;
            if (!this.throttled) {
                var duration = tryCatch(this.durationSelector)(value);
                if (duration === errorObject) {
                    this.destination.error(errorObject.e);
                }
                else {
                    var innerSubscription = subscribeToResult(this, duration);
                    if (!innerSubscription || innerSubscription.closed) {
                        this.clearThrottle();
                    }
                    else {
                        this.add(this.throttled = innerSubscription);
                    }
                }
            }
        };
        AuditSubscriber.prototype.clearThrottle = function () {
            var _a = this, value = _a.value, hasValue = _a.hasValue, throttled = _a.throttled;
            if (throttled) {
                this.remove(throttled);
                this.throttled = null;
                throttled.unsubscribe();
            }
            if (hasValue) {
                this.value = null;
                this.hasValue = false;
                this.destination.next(value);
            }
        };
        AuditSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex) {
            this.clearThrottle();
        };
        AuditSubscriber.prototype.notifyComplete = function () {
            this.clearThrottle();
        };
        return AuditSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_Subscription PURE_IMPORTS_END */
    var Action = /*@__PURE__*/ (function (_super) {
        __extends(Action, _super);
        function Action(scheduler, work) {
            return _super.call(this) || this;
        }
        Action.prototype.schedule = function (state, delay) {
            if (delay === void 0) {
                delay = 0;
            }
            return this;
        };
        return Action;
    }(Subscription));

    /** PURE_IMPORTS_START tslib,_Action PURE_IMPORTS_END */
    var AsyncAction = /*@__PURE__*/ (function (_super) {
        __extends(AsyncAction, _super);
        function AsyncAction(scheduler, work) {
            var _this = _super.call(this, scheduler, work) || this;
            _this.scheduler = scheduler;
            _this.work = work;
            _this.pending = false;
            return _this;
        }
        AsyncAction.prototype.schedule = function (state, delay) {
            if (delay === void 0) {
                delay = 0;
            }
            if (this.closed) {
                return this;
            }
            this.state = state;
            var id = this.id;
            var scheduler = this.scheduler;
            if (id != null) {
                this.id = this.recycleAsyncId(scheduler, id, delay);
            }
            this.pending = true;
            this.delay = delay;
            this.id = this.id || this.requestAsyncId(scheduler, this.id, delay);
            return this;
        };
        AsyncAction.prototype.requestAsyncId = function (scheduler, id, delay) {
            if (delay === void 0) {
                delay = 0;
            }
            return setInterval(scheduler.flush.bind(scheduler, this), delay);
        };
        AsyncAction.prototype.recycleAsyncId = function (scheduler, id, delay) {
            if (delay === void 0) {
                delay = 0;
            }
            if (delay !== null && this.delay === delay && this.pending === false) {
                return id;
            }
            return clearInterval(id) && undefined || undefined;
        };
        AsyncAction.prototype.execute = function (state, delay) {
            if (this.closed) {
                return new Error('executing a cancelled action');
            }
            this.pending = false;
            var error = this._execute(state, delay);
            if (error) {
                return error;
            }
            else if (this.pending === false && this.id != null) {
                this.id = this.recycleAsyncId(this.scheduler, this.id, null);
            }
        };
        AsyncAction.prototype._execute = function (state, delay) {
            var errored = false;
            var errorValue = undefined;
            try {
                this.work(state);
            }
            catch (e) {
                errored = true;
                errorValue = !!e && e || new Error(e);
            }
            if (errored) {
                this.unsubscribe();
                return errorValue;
            }
        };
        AsyncAction.prototype._unsubscribe = function () {
            var id = this.id;
            var scheduler = this.scheduler;
            var actions = scheduler.actions;
            var index = actions.indexOf(this);
            this.work = null;
            this.state = null;
            this.pending = false;
            this.scheduler = null;
            if (index !== -1) {
                actions.splice(index, 1);
            }
            if (id != null) {
                this.id = this.recycleAsyncId(scheduler, id, null);
            }
            this.delay = null;
        };
        return AsyncAction;
    }(Action));

    var Scheduler = /*@__PURE__*/ (function () {
        function Scheduler(SchedulerAction, now) {
            if (now === void 0) {
                now = Scheduler.now;
            }
            this.SchedulerAction = SchedulerAction;
            this.now = now;
        }
        Scheduler.prototype.schedule = function (work, delay, state) {
            if (delay === void 0) {
                delay = 0;
            }
            return new this.SchedulerAction(this, work).schedule(state, delay);
        };
        Scheduler.now = function () { return Date.now(); };
        return Scheduler;
    }());

    /** PURE_IMPORTS_START tslib,_Scheduler PURE_IMPORTS_END */
    var AsyncScheduler = /*@__PURE__*/ (function (_super) {
        __extends(AsyncScheduler, _super);
        function AsyncScheduler(SchedulerAction, now) {
            if (now === void 0) {
                now = Scheduler.now;
            }
            var _this = _super.call(this, SchedulerAction, function () {
                if (AsyncScheduler.delegate && AsyncScheduler.delegate !== _this) {
                    return AsyncScheduler.delegate.now();
                }
                else {
                    return now();
                }
            }) || this;
            _this.actions = [];
            _this.active = false;
            _this.scheduled = undefined;
            return _this;
        }
        AsyncScheduler.prototype.schedule = function (work, delay, state) {
            if (delay === void 0) {
                delay = 0;
            }
            if (AsyncScheduler.delegate && AsyncScheduler.delegate !== this) {
                return AsyncScheduler.delegate.schedule(work, delay, state);
            }
            else {
                return _super.prototype.schedule.call(this, work, delay, state);
            }
        };
        AsyncScheduler.prototype.flush = function (action) {
            var actions = this.actions;
            if (this.active) {
                actions.push(action);
                return;
            }
            var error;
            this.active = true;
            do {
                if (error = action.execute(action.state, action.delay)) {
                    break;
                }
            } while (action = actions.shift());
            this.active = false;
            if (error) {
                while (action = actions.shift()) {
                    action.unsubscribe();
                }
                throw error;
            }
        };
        return AsyncScheduler;
    }(Scheduler));

    /** PURE_IMPORTS_START _AsyncAction,_AsyncScheduler PURE_IMPORTS_END */
    var async = /*@__PURE__*/ new AsyncScheduler(AsyncAction);

    /** PURE_IMPORTS_START _isArray PURE_IMPORTS_END */
    function isNumeric(val) {
        return !isArray(val) && (val - parseFloat(val) + 1) >= 0;
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function isScheduler(value) {
        return value && typeof value.schedule === 'function';
    }

    /** PURE_IMPORTS_START _Observable,_scheduler_async,_util_isNumeric,_util_isScheduler PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _scheduler_async,_audit,_observable_timer PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var BufferSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(BufferSubscriber, _super);
        function BufferSubscriber(destination, closingNotifier) {
            var _this = _super.call(this, destination) || this;
            _this.buffer = [];
            _this.add(subscribeToResult(_this, closingNotifier));
            return _this;
        }
        BufferSubscriber.prototype._next = function (value) {
            this.buffer.push(value);
        };
        BufferSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            var buffer = this.buffer;
            this.buffer = [];
            this.destination.next(buffer);
        };
        return BufferSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    var BufferCountSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(BufferCountSubscriber, _super);
        function BufferCountSubscriber(destination, bufferSize) {
            var _this = _super.call(this, destination) || this;
            _this.bufferSize = bufferSize;
            _this.buffer = [];
            return _this;
        }
        BufferCountSubscriber.prototype._next = function (value) {
            var buffer = this.buffer;
            buffer.push(value);
            if (buffer.length == this.bufferSize) {
                this.destination.next(buffer);
                this.buffer = [];
            }
        };
        BufferCountSubscriber.prototype._complete = function () {
            var buffer = this.buffer;
            if (buffer.length > 0) {
                this.destination.next(buffer);
            }
            _super.prototype._complete.call(this);
        };
        return BufferCountSubscriber;
    }(Subscriber));
    var BufferSkipCountSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(BufferSkipCountSubscriber, _super);
        function BufferSkipCountSubscriber(destination, bufferSize, startBufferEvery) {
            var _this = _super.call(this, destination) || this;
            _this.bufferSize = bufferSize;
            _this.startBufferEvery = startBufferEvery;
            _this.buffers = [];
            _this.count = 0;
            return _this;
        }
        BufferSkipCountSubscriber.prototype._next = function (value) {
            var _a = this, bufferSize = _a.bufferSize, startBufferEvery = _a.startBufferEvery, buffers = _a.buffers, count = _a.count;
            this.count++;
            if (count % startBufferEvery === 0) {
                buffers.push([]);
            }
            for (var i = buffers.length; i--;) {
                var buffer = buffers[i];
                buffer.push(value);
                if (buffer.length === bufferSize) {
                    buffers.splice(i, 1);
                    this.destination.next(buffer);
                }
            }
        };
        BufferSkipCountSubscriber.prototype._complete = function () {
            var _a = this, buffers = _a.buffers, destination = _a.destination;
            while (buffers.length > 0) {
                var buffer = buffers.shift();
                if (buffer.length > 0) {
                    destination.next(buffer);
                }
            }
            _super.prototype._complete.call(this);
        };
        return BufferSkipCountSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_scheduler_async,_Subscriber,_util_isScheduler PURE_IMPORTS_END */
    var Context = /*@__PURE__*/ (function () {
        function Context() {
            this.buffer = [];
        }
        return Context;
    }());
    var BufferTimeSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(BufferTimeSubscriber, _super);
        function BufferTimeSubscriber(destination, bufferTimeSpan, bufferCreationInterval, maxBufferSize, scheduler) {
            var _this = _super.call(this, destination) || this;
            _this.bufferTimeSpan = bufferTimeSpan;
            _this.bufferCreationInterval = bufferCreationInterval;
            _this.maxBufferSize = maxBufferSize;
            _this.scheduler = scheduler;
            _this.contexts = [];
            var context = _this.openContext();
            _this.timespanOnly = bufferCreationInterval == null || bufferCreationInterval < 0;
            if (_this.timespanOnly) {
                var timeSpanOnlyState = { subscriber: _this, context: context, bufferTimeSpan: bufferTimeSpan };
                _this.add(context.closeAction = scheduler.schedule(dispatchBufferTimeSpanOnly, bufferTimeSpan, timeSpanOnlyState));
            }
            else {
                var closeState = { subscriber: _this, context: context };
                var creationState = { bufferTimeSpan: bufferTimeSpan, bufferCreationInterval: bufferCreationInterval, subscriber: _this, scheduler: scheduler };
                _this.add(context.closeAction = scheduler.schedule(dispatchBufferClose, bufferTimeSpan, closeState));
                _this.add(scheduler.schedule(dispatchBufferCreation, bufferCreationInterval, creationState));
            }
            return _this;
        }
        BufferTimeSubscriber.prototype._next = function (value) {
            var contexts = this.contexts;
            var len = contexts.length;
            var filledBufferContext;
            for (var i = 0; i < len; i++) {
                var context_1 = contexts[i];
                var buffer = context_1.buffer;
                buffer.push(value);
                if (buffer.length == this.maxBufferSize) {
                    filledBufferContext = context_1;
                }
            }
            if (filledBufferContext) {
                this.onBufferFull(filledBufferContext);
            }
        };
        BufferTimeSubscriber.prototype._error = function (err) {
            this.contexts.length = 0;
            _super.prototype._error.call(this, err);
        };
        BufferTimeSubscriber.prototype._complete = function () {
            var _a = this, contexts = _a.contexts, destination = _a.destination;
            while (contexts.length > 0) {
                var context_2 = contexts.shift();
                destination.next(context_2.buffer);
            }
            _super.prototype._complete.call(this);
        };
        BufferTimeSubscriber.prototype._unsubscribe = function () {
            this.contexts = null;
        };
        BufferTimeSubscriber.prototype.onBufferFull = function (context) {
            this.closeContext(context);
            var closeAction = context.closeAction;
            closeAction.unsubscribe();
            this.remove(closeAction);
            if (!this.closed && this.timespanOnly) {
                context = this.openContext();
                var bufferTimeSpan = this.bufferTimeSpan;
                var timeSpanOnlyState = { subscriber: this, context: context, bufferTimeSpan: bufferTimeSpan };
                this.add(context.closeAction = this.scheduler.schedule(dispatchBufferTimeSpanOnly, bufferTimeSpan, timeSpanOnlyState));
            }
        };
        BufferTimeSubscriber.prototype.openContext = function () {
            var context = new Context();
            this.contexts.push(context);
            return context;
        };
        BufferTimeSubscriber.prototype.closeContext = function (context) {
            this.destination.next(context.buffer);
            var contexts = this.contexts;
            var spliceIndex = contexts ? contexts.indexOf(context) : -1;
            if (spliceIndex >= 0) {
                contexts.splice(contexts.indexOf(context), 1);
            }
        };
        return BufferTimeSubscriber;
    }(Subscriber));
    function dispatchBufferTimeSpanOnly(state) {
        var subscriber = state.subscriber;
        var prevContext = state.context;
        if (prevContext) {
            subscriber.closeContext(prevContext);
        }
        if (!subscriber.closed) {
            state.context = subscriber.openContext();
            state.context.closeAction = this.schedule(state, state.bufferTimeSpan);
        }
    }
    function dispatchBufferCreation(state) {
        var bufferCreationInterval = state.bufferCreationInterval, bufferTimeSpan = state.bufferTimeSpan, subscriber = state.subscriber, scheduler = state.scheduler;
        var context = subscriber.openContext();
        var action = this;
        if (!subscriber.closed) {
            subscriber.add(context.closeAction = scheduler.schedule(dispatchBufferClose, bufferTimeSpan, { subscriber: subscriber, context: context }));
            action.schedule(state, bufferCreationInterval);
        }
    }
    function dispatchBufferClose(arg) {
        var subscriber = arg.subscriber, context = arg.context;
        subscriber.closeContext(context);
    }

    /** PURE_IMPORTS_START tslib,_Subscription,_util_subscribeToResult,_OuterSubscriber PURE_IMPORTS_END */
    var BufferToggleSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(BufferToggleSubscriber, _super);
        function BufferToggleSubscriber(destination, openings, closingSelector) {
            var _this = _super.call(this, destination) || this;
            _this.openings = openings;
            _this.closingSelector = closingSelector;
            _this.contexts = [];
            _this.add(subscribeToResult(_this, openings));
            return _this;
        }
        BufferToggleSubscriber.prototype._next = function (value) {
            var contexts = this.contexts;
            var len = contexts.length;
            for (var i = 0; i < len; i++) {
                contexts[i].buffer.push(value);
            }
        };
        BufferToggleSubscriber.prototype._error = function (err) {
            var contexts = this.contexts;
            while (contexts.length > 0) {
                var context_1 = contexts.shift();
                context_1.subscription.unsubscribe();
                context_1.buffer = null;
                context_1.subscription = null;
            }
            this.contexts = null;
            _super.prototype._error.call(this, err);
        };
        BufferToggleSubscriber.prototype._complete = function () {
            var contexts = this.contexts;
            while (contexts.length > 0) {
                var context_2 = contexts.shift();
                this.destination.next(context_2.buffer);
                context_2.subscription.unsubscribe();
                context_2.buffer = null;
                context_2.subscription = null;
            }
            this.contexts = null;
            _super.prototype._complete.call(this);
        };
        BufferToggleSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            outerValue ? this.closeBuffer(outerValue) : this.openBuffer(innerValue);
        };
        BufferToggleSubscriber.prototype.notifyComplete = function (innerSub) {
            this.closeBuffer(innerSub.context);
        };
        BufferToggleSubscriber.prototype.openBuffer = function (value) {
            try {
                var closingSelector = this.closingSelector;
                var closingNotifier = closingSelector.call(this, value);
                if (closingNotifier) {
                    this.trySubscribe(closingNotifier);
                }
            }
            catch (err) {
                this._error(err);
            }
        };
        BufferToggleSubscriber.prototype.closeBuffer = function (context) {
            var contexts = this.contexts;
            if (contexts && context) {
                var buffer = context.buffer, subscription = context.subscription;
                this.destination.next(buffer);
                contexts.splice(contexts.indexOf(context), 1);
                this.remove(subscription);
                subscription.unsubscribe();
            }
        };
        BufferToggleSubscriber.prototype.trySubscribe = function (closingNotifier) {
            var contexts = this.contexts;
            var buffer = [];
            var subscription = new Subscription();
            var context = { buffer: buffer, subscription: subscription };
            contexts.push(context);
            var innerSubscription = subscribeToResult(this, closingNotifier, context);
            if (!innerSubscription || innerSubscription.closed) {
                this.closeBuffer(context);
            }
            else {
                innerSubscription.context = context;
                this.add(innerSubscription);
                subscription.add(innerSubscription);
            }
        };
        return BufferToggleSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_Subscription,_util_tryCatch,_util_errorObject,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var BufferWhenSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(BufferWhenSubscriber, _super);
        function BufferWhenSubscriber(destination, closingSelector) {
            var _this = _super.call(this, destination) || this;
            _this.closingSelector = closingSelector;
            _this.subscribing = false;
            _this.openBuffer();
            return _this;
        }
        BufferWhenSubscriber.prototype._next = function (value) {
            this.buffer.push(value);
        };
        BufferWhenSubscriber.prototype._complete = function () {
            var buffer = this.buffer;
            if (buffer) {
                this.destination.next(buffer);
            }
            _super.prototype._complete.call(this);
        };
        BufferWhenSubscriber.prototype._unsubscribe = function () {
            this.buffer = null;
            this.subscribing = false;
        };
        BufferWhenSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.openBuffer();
        };
        BufferWhenSubscriber.prototype.notifyComplete = function () {
            if (this.subscribing) {
                this.complete();
            }
            else {
                this.openBuffer();
            }
        };
        BufferWhenSubscriber.prototype.openBuffer = function () {
            var closingSubscription = this.closingSubscription;
            if (closingSubscription) {
                this.remove(closingSubscription);
                closingSubscription.unsubscribe();
            }
            var buffer = this.buffer;
            if (this.buffer) {
                this.destination.next(buffer);
            }
            this.buffer = [];
            var closingNotifier = tryCatch(this.closingSelector)();
            if (closingNotifier === errorObject) {
                this.error(errorObject.e);
            }
            else {
                closingSubscription = new Subscription();
                this.closingSubscription = closingSubscription;
                this.add(closingSubscription);
                this.subscribing = true;
                closingSubscription.add(subscribeToResult(this, closingNotifier));
                this.subscribing = false;
            }
        };
        return BufferWhenSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    function catchError(selector) {
        return function catchErrorOperatorFunction(source) {
            var operator = new CatchOperator(selector);
            var caught = source.lift(operator);
            return (operator.caught = caught);
        };
    }
    var CatchOperator = /*@__PURE__*/ (function () {
        function CatchOperator(selector) {
            this.selector = selector;
        }
        CatchOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new CatchSubscriber(subscriber, this.selector, this.caught));
        };
        return CatchOperator;
    }());
    var CatchSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(CatchSubscriber, _super);
        function CatchSubscriber(destination, selector, caught) {
            var _this = _super.call(this, destination) || this;
            _this.selector = selector;
            _this.caught = caught;
            return _this;
        }
        CatchSubscriber.prototype.error = function (err) {
            if (!this.isStopped) {
                var result = void 0;
                try {
                    result = this.selector(err, this.caught);
                }
                catch (err2) {
                    _super.prototype.error.call(this, err2);
                    return;
                }
                this._unsubscribeAndRecycle();
                this.add(subscribeToResult(this, result));
            }
        };
        return CatchSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START _Observable,_Subscription,_util_subscribeToArray PURE_IMPORTS_END */
    function fromArray(input, scheduler) {
        if (!scheduler) {
            return new Observable(subscribeToArray(input));
        }
        else {
            return new Observable(function (subscriber) {
                var sub = new Subscription();
                var i = 0;
                sub.add(scheduler.schedule(function () {
                    if (i === input.length) {
                        subscriber.complete();
                        return;
                    }
                    subscriber.next(input[i++]);
                    if (!subscriber.closed) {
                        sub.add(this.schedule());
                    }
                }));
                return sub;
            });
        }
    }

    /** PURE_IMPORTS_START tslib,_util_isScheduler,_util_isArray,_OuterSubscriber,_util_subscribeToResult,_fromArray PURE_IMPORTS_END */
    var NONE = {};
    var CombineLatestSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(CombineLatestSubscriber, _super);
        function CombineLatestSubscriber(destination, resultSelector) {
            var _this = _super.call(this, destination) || this;
            _this.resultSelector = resultSelector;
            _this.active = 0;
            _this.values = [];
            _this.observables = [];
            return _this;
        }
        CombineLatestSubscriber.prototype._next = function (observable) {
            this.values.push(NONE);
            this.observables.push(observable);
        };
        CombineLatestSubscriber.prototype._complete = function () {
            var observables = this.observables;
            var len = observables.length;
            if (len === 0) {
                this.destination.complete();
            }
            else {
                this.active = len;
                this.toRespond = len;
                for (var i = 0; i < len; i++) {
                    var observable = observables[i];
                    this.add(subscribeToResult(this, observable, observable, i));
                }
            }
        };
        CombineLatestSubscriber.prototype.notifyComplete = function (unused) {
            if ((this.active -= 1) === 0) {
                this.destination.complete();
            }
        };
        CombineLatestSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            var values = this.values;
            var oldVal = values[outerIndex];
            var toRespond = !this.toRespond
                ? 0
                : oldVal === NONE ? --this.toRespond : this.toRespond;
            values[outerIndex] = innerValue;
            if (toRespond === 0) {
                if (this.resultSelector) {
                    this._tryResultSelector(values);
                }
                else {
                    this.destination.next(values.slice());
                }
            }
        };
        CombineLatestSubscriber.prototype._tryResultSelector = function (values) {
            var result;
            try {
                result = this.resultSelector.apply(this, values);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.destination.next(result);
        };
        return CombineLatestSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START _observable_combineLatest PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _symbol_observable PURE_IMPORTS_END */
    function isInteropObservable(input) {
        return input && typeof input[observable] === 'function';
    }

    /** PURE_IMPORTS_START _symbol_iterator PURE_IMPORTS_END */
    function isIterable(input) {
        return input && typeof input[iterator] === 'function';
    }

    /** PURE_IMPORTS_START _Observable,_Subscription,_util_subscribeToPromise PURE_IMPORTS_END */
    function fromPromise(input, scheduler) {
        if (!scheduler) {
            return new Observable(subscribeToPromise(input));
        }
        else {
            return new Observable(function (subscriber) {
                var sub = new Subscription();
                sub.add(scheduler.schedule(function () {
                    return input.then(function (value) {
                        sub.add(scheduler.schedule(function () {
                            subscriber.next(value);
                            sub.add(scheduler.schedule(function () { return subscriber.complete(); }));
                        }));
                    }, function (err) {
                        sub.add(scheduler.schedule(function () { return subscriber.error(err); }));
                    });
                }));
                return sub;
            });
        }
    }

    /** PURE_IMPORTS_START _Observable,_Subscription,_symbol_iterator,_util_subscribeToIterable PURE_IMPORTS_END */
    function fromIterable(input, scheduler) {
        if (!input) {
            throw new Error('Iterable cannot be null');
        }
        if (!scheduler) {
            return new Observable(subscribeToIterable(input));
        }
        else {
            return new Observable(function (subscriber) {
                var sub = new Subscription();
                var iterator$$1;
                sub.add(function () {
                    if (iterator$$1 && typeof iterator$$1.return === 'function') {
                        iterator$$1.return();
                    }
                });
                sub.add(scheduler.schedule(function () {
                    iterator$$1 = input[iterator]();
                    sub.add(scheduler.schedule(function () {
                        if (subscriber.closed) {
                            return;
                        }
                        var value;
                        var done;
                        try {
                            var result = iterator$$1.next();
                            value = result.value;
                            done = result.done;
                        }
                        catch (err) {
                            subscriber.error(err);
                            return;
                        }
                        if (done) {
                            subscriber.complete();
                        }
                        else {
                            subscriber.next(value);
                            this.schedule();
                        }
                    }));
                }));
                return sub;
            });
        }
    }

    /** PURE_IMPORTS_START _Observable,_Subscription,_symbol_observable,_util_subscribeToObservable PURE_IMPORTS_END */
    function fromObservable(input, scheduler) {
        if (!scheduler) {
            return new Observable(subscribeToObservable(input));
        }
        else {
            return new Observable(function (subscriber) {
                var sub = new Subscription();
                sub.add(scheduler.schedule(function () {
                    var observable$$1 = input[observable]();
                    sub.add(observable$$1.subscribe({
                        next: function (value) { sub.add(scheduler.schedule(function () { return subscriber.next(value); })); },
                        error: function (err) { sub.add(scheduler.schedule(function () { return subscriber.error(err); })); },
                        complete: function () { sub.add(scheduler.schedule(function () { return subscriber.complete(); })); },
                    }));
                }));
                return sub;
            });
        }
    }

    /** PURE_IMPORTS_START _Observable,_util_isPromise,_util_isArrayLike,_util_isInteropObservable,_util_isIterable,_fromArray,_fromPromise,_fromIterable,_fromObservable,_util_subscribeTo PURE_IMPORTS_END */
    function from(input, scheduler) {
        if (!scheduler) {
            if (input instanceof Observable) {
                return input;
            }
            return new Observable(subscribeTo(input));
        }
        if (input != null) {
            if (isInteropObservable(input)) {
                return fromObservable(input, scheduler);
            }
            else if (isPromise(input)) {
                return fromPromise(input, scheduler);
            }
            else if (isArrayLike(input)) {
                return fromArray(input, scheduler);
            }
            else if (isIterable(input) || typeof input === 'string') {
                return fromIterable(input, scheduler);
            }
        }
        throw new TypeError((input !== null && typeof input || input) + ' is not observable');
    }

    /** PURE_IMPORTS_START _util_isArray,_observable_combineLatest,_observable_from PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _Observable PURE_IMPORTS_END */
    var EMPTY = /*@__PURE__*/ new Observable(function (subscriber) { return subscriber.complete(); });
    function empty$1(scheduler) {
        return scheduler ? emptyScheduled(scheduler) : EMPTY;
    }
    function emptyScheduled(scheduler) {
        return new Observable(function (subscriber) { return scheduler.schedule(function () { return subscriber.complete(); }); });
    }

    /** PURE_IMPORTS_START _Observable PURE_IMPORTS_END */
    function scalar(value) {
        var result = new Observable(function (subscriber) {
            subscriber.next(value);
            subscriber.complete();
        });
        result._isScalar = true;
        result.value = value;
        return result;
    }

    /** PURE_IMPORTS_START _util_isScheduler,_fromArray,_empty,_scalar PURE_IMPORTS_END */
    function of() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var scheduler = args[args.length - 1];
        if (isScheduler(scheduler)) {
            args.pop();
        }
        else {
            scheduler = undefined;
        }
        switch (args.length) {
            case 0:
                return empty$1(scheduler);
            case 1:
                return scheduler ? fromArray(args, scheduler) : scalar(args[0]);
            default:
                return fromArray(args, scheduler);
        }
    }

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    function map(project, thisArg) {
        return function mapOperation(source) {
            if (typeof project !== 'function') {
                throw new TypeError('argument is not a function. Are you looking for `mapTo()`?');
            }
            return source.lift(new MapOperator(project, thisArg));
        };
    }
    var MapOperator = /*@__PURE__*/ (function () {
        function MapOperator(project, thisArg) {
            this.project = project;
            this.thisArg = thisArg;
        }
        MapOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new MapSubscriber(subscriber, this.project, this.thisArg));
        };
        return MapOperator;
    }());
    var MapSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(MapSubscriber, _super);
        function MapSubscriber(destination, project, thisArg) {
            var _this = _super.call(this, destination) || this;
            _this.project = project;
            _this.count = 0;
            _this.thisArg = thisArg || _this;
            return _this;
        }
        MapSubscriber.prototype._next = function (value) {
            var result;
            try {
                result = this.project.call(this.thisArg, value, this.count++);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.destination.next(result);
        };
        return MapSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_util_subscribeToResult,_OuterSubscriber,_map,_observable_from PURE_IMPORTS_END */
    function mergeMap(project, resultSelector, concurrent) {
        if (concurrent === void 0) {
            concurrent = Number.POSITIVE_INFINITY;
        }
        if (typeof resultSelector === 'function') {
            return function (source) { return source.pipe(mergeMap(function (a, i) { return from(project(a, i)).pipe(map(function (b, ii) { return resultSelector(a, b, i, ii); })); }, concurrent)); };
        }
        else if (typeof resultSelector === 'number') {
            concurrent = resultSelector;
        }
        return function (source) { return source.lift(new MergeMapOperator(project, concurrent)); };
    }
    var MergeMapOperator = /*@__PURE__*/ (function () {
        function MergeMapOperator(project, concurrent) {
            if (concurrent === void 0) {
                concurrent = Number.POSITIVE_INFINITY;
            }
            this.project = project;
            this.concurrent = concurrent;
        }
        MergeMapOperator.prototype.call = function (observer, source) {
            return source.subscribe(new MergeMapSubscriber(observer, this.project, this.concurrent));
        };
        return MergeMapOperator;
    }());
    var MergeMapSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(MergeMapSubscriber, _super);
        function MergeMapSubscriber(destination, project, concurrent) {
            if (concurrent === void 0) {
                concurrent = Number.POSITIVE_INFINITY;
            }
            var _this = _super.call(this, destination) || this;
            _this.project = project;
            _this.concurrent = concurrent;
            _this.hasCompleted = false;
            _this.buffer = [];
            _this.active = 0;
            _this.index = 0;
            return _this;
        }
        MergeMapSubscriber.prototype._next = function (value) {
            if (this.active < this.concurrent) {
                this._tryNext(value);
            }
            else {
                this.buffer.push(value);
            }
        };
        MergeMapSubscriber.prototype._tryNext = function (value) {
            var result;
            var index = this.index++;
            try {
                result = this.project(value, index);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.active++;
            this._innerSub(result, value, index);
        };
        MergeMapSubscriber.prototype._innerSub = function (ish, value, index) {
            this.add(subscribeToResult(this, ish, value, index));
        };
        MergeMapSubscriber.prototype._complete = function () {
            this.hasCompleted = true;
            if (this.active === 0 && this.buffer.length === 0) {
                this.destination.complete();
            }
        };
        MergeMapSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.destination.next(innerValue);
        };
        MergeMapSubscriber.prototype.notifyComplete = function (innerSub) {
            var buffer = this.buffer;
            this.remove(innerSub);
            this.active--;
            if (buffer.length > 0) {
                this._next(buffer.shift());
            }
            else if (this.active === 0 && this.hasCompleted) {
                this.destination.complete();
            }
        };
        return MergeMapSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function identity(x) {
        return x;
    }

    /** PURE_IMPORTS_START _mergeMap,_util_identity PURE_IMPORTS_END */
    function mergeAll(concurrent) {
        if (concurrent === void 0) {
            concurrent = Number.POSITIVE_INFINITY;
        }
        return mergeMap(identity, concurrent);
    }

    /** PURE_IMPORTS_START _mergeAll PURE_IMPORTS_END */
    function concatAll() {
        return mergeAll(1);
    }

    /** PURE_IMPORTS_START _util_isScheduler,_of,_from,_operators_concatAll PURE_IMPORTS_END */
    function concat() {
        var observables = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            observables[_i] = arguments[_i];
        }
        if (observables.length === 1 || (observables.length === 2 && isScheduler(observables[1]))) {
            return from(observables[0]);
        }
        return concatAll()(of.apply(void 0, observables));
    }

    /** PURE_IMPORTS_START _observable_concat PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _mergeMap PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _concatMap PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    var CountSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(CountSubscriber, _super);
        function CountSubscriber(destination, predicate, source) {
            var _this = _super.call(this, destination) || this;
            _this.predicate = predicate;
            _this.source = source;
            _this.count = 0;
            _this.index = 0;
            return _this;
        }
        CountSubscriber.prototype._next = function (value) {
            if (this.predicate) {
                this._tryPredicate(value);
            }
            else {
                this.count++;
            }
        };
        CountSubscriber.prototype._tryPredicate = function (value) {
            var result;
            try {
                result = this.predicate(value, this.index++, this.source);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            if (result) {
                this.count++;
            }
        };
        CountSubscriber.prototype._complete = function () {
            this.destination.next(this.count);
            this.destination.complete();
        };
        return CountSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var DebounceSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(DebounceSubscriber, _super);
        function DebounceSubscriber(destination, durationSelector) {
            var _this = _super.call(this, destination) || this;
            _this.durationSelector = durationSelector;
            _this.hasValue = false;
            _this.durationSubscription = null;
            return _this;
        }
        DebounceSubscriber.prototype._next = function (value) {
            try {
                var result = this.durationSelector.call(this, value);
                if (result) {
                    this._tryNext(value, result);
                }
            }
            catch (err) {
                this.destination.error(err);
            }
        };
        DebounceSubscriber.prototype._complete = function () {
            this.emitValue();
            this.destination.complete();
        };
        DebounceSubscriber.prototype._tryNext = function (value, duration) {
            var subscription = this.durationSubscription;
            this.value = value;
            this.hasValue = true;
            if (subscription) {
                subscription.unsubscribe();
                this.remove(subscription);
            }
            subscription = subscribeToResult(this, duration);
            if (subscription && !subscription.closed) {
                this.add(this.durationSubscription = subscription);
            }
        };
        DebounceSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.emitValue();
        };
        DebounceSubscriber.prototype.notifyComplete = function () {
            this.emitValue();
        };
        DebounceSubscriber.prototype.emitValue = function () {
            if (this.hasValue) {
                var value = this.value;
                var subscription = this.durationSubscription;
                if (subscription) {
                    this.durationSubscription = null;
                    subscription.unsubscribe();
                    this.remove(subscription);
                }
                this.value = null;
                this.hasValue = false;
                _super.prototype._next.call(this, value);
            }
        };
        return DebounceSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber,_scheduler_async PURE_IMPORTS_END */
    var DebounceTimeSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(DebounceTimeSubscriber, _super);
        function DebounceTimeSubscriber(destination, dueTime, scheduler) {
            var _this = _super.call(this, destination) || this;
            _this.dueTime = dueTime;
            _this.scheduler = scheduler;
            _this.debouncedSubscription = null;
            _this.lastValue = null;
            _this.hasValue = false;
            return _this;
        }
        DebounceTimeSubscriber.prototype._next = function (value) {
            this.clearDebounce();
            this.lastValue = value;
            this.hasValue = true;
            this.add(this.debouncedSubscription = this.scheduler.schedule(dispatchNext, this.dueTime, this));
        };
        DebounceTimeSubscriber.prototype._complete = function () {
            this.debouncedNext();
            this.destination.complete();
        };
        DebounceTimeSubscriber.prototype.debouncedNext = function () {
            this.clearDebounce();
            if (this.hasValue) {
                var lastValue = this.lastValue;
                this.lastValue = null;
                this.hasValue = false;
                this.destination.next(lastValue);
            }
        };
        DebounceTimeSubscriber.prototype.clearDebounce = function () {
            var debouncedSubscription = this.debouncedSubscription;
            if (debouncedSubscription !== null) {
                this.remove(debouncedSubscription);
                debouncedSubscription.unsubscribe();
                this.debouncedSubscription = null;
            }
        };
        return DebounceTimeSubscriber;
    }(Subscriber));
    function dispatchNext(subscriber) {
        subscriber.debouncedNext();
    }

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    var DefaultIfEmptySubscriber = /*@__PURE__*/ (function (_super) {
        __extends(DefaultIfEmptySubscriber, _super);
        function DefaultIfEmptySubscriber(destination, defaultValue) {
            var _this = _super.call(this, destination) || this;
            _this.defaultValue = defaultValue;
            _this.isEmpty = true;
            return _this;
        }
        DefaultIfEmptySubscriber.prototype._next = function (value) {
            this.isEmpty = false;
            this.destination.next(value);
        };
        DefaultIfEmptySubscriber.prototype._complete = function () {
            if (this.isEmpty) {
                this.destination.next(this.defaultValue);
            }
            this.destination.complete();
        };
        return DefaultIfEmptySubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _Observable PURE_IMPORTS_END */
    function throwError(error, scheduler) {
        if (!scheduler) {
            return new Observable(function (subscriber) { return subscriber.error(error); });
        }
        else {
            return new Observable(function (subscriber) { return scheduler.schedule(dispatch$1, 0, { error: error, subscriber: subscriber }); });
        }
    }
    function dispatch$1(_a) {
        var error = _a.error, subscriber = _a.subscriber;
        subscriber.error(error);
    }

    /** PURE_IMPORTS_START _observable_empty,_observable_of,_observable_throwError PURE_IMPORTS_END */
    var Notification = /*@__PURE__*/ (function () {
        function Notification(kind, value, error) {
            this.kind = kind;
            this.value = value;
            this.error = error;
            this.hasValue = kind === 'N';
        }
        Notification.prototype.observe = function (observer) {
            switch (this.kind) {
                case 'N':
                    return observer.next && observer.next(this.value);
                case 'E':
                    return observer.error && observer.error(this.error);
                case 'C':
                    return observer.complete && observer.complete();
            }
        };
        Notification.prototype.do = function (next, error, complete) {
            var kind = this.kind;
            switch (kind) {
                case 'N':
                    return next && next(this.value);
                case 'E':
                    return error && error(this.error);
                case 'C':
                    return complete && complete();
            }
        };
        Notification.prototype.accept = function (nextOrObserver, error, complete) {
            if (nextOrObserver && typeof nextOrObserver.next === 'function') {
                return this.observe(nextOrObserver);
            }
            else {
                return this.do(nextOrObserver, error, complete);
            }
        };
        Notification.prototype.toObservable = function () {
            var kind = this.kind;
            switch (kind) {
                case 'N':
                    return of(this.value);
                case 'E':
                    return throwError(this.error);
                case 'C':
                    return empty$1();
            }
            throw new Error('unexpected notification kind value');
        };
        Notification.createNext = function (value) {
            if (typeof value !== 'undefined') {
                return new Notification('N', value);
            }
            return Notification.undefinedValueNotification;
        };
        Notification.createError = function (err) {
            return new Notification('E', undefined, err);
        };
        Notification.createComplete = function () {
            return Notification.completeNotification;
        };
        Notification.completeNotification = new Notification('C');
        Notification.undefinedValueNotification = new Notification('N', undefined);
        return Notification;
    }());

    /** PURE_IMPORTS_START tslib,_scheduler_async,_util_isDate,_Subscriber,_Notification PURE_IMPORTS_END */
    var DelaySubscriber = /*@__PURE__*/ (function (_super) {
        __extends(DelaySubscriber, _super);
        function DelaySubscriber(destination, delay, scheduler) {
            var _this = _super.call(this, destination) || this;
            _this.delay = delay;
            _this.scheduler = scheduler;
            _this.queue = [];
            _this.active = false;
            _this.errored = false;
            return _this;
        }
        DelaySubscriber.dispatch = function (state) {
            var source = state.source;
            var queue = source.queue;
            var scheduler = state.scheduler;
            var destination = state.destination;
            while (queue.length > 0 && (queue[0].time - scheduler.now()) <= 0) {
                queue.shift().notification.observe(destination);
            }
            if (queue.length > 0) {
                var delay_1 = Math.max(0, queue[0].time - scheduler.now());
                this.schedule(state, delay_1);
            }
            else {
                this.unsubscribe();
                source.active = false;
            }
        };
        DelaySubscriber.prototype._schedule = function (scheduler) {
            this.active = true;
            this.add(scheduler.schedule(DelaySubscriber.dispatch, this.delay, {
                source: this, destination: this.destination, scheduler: scheduler
            }));
        };
        DelaySubscriber.prototype.scheduleNotification = function (notification) {
            if (this.errored === true) {
                return;
            }
            var scheduler = this.scheduler;
            var message = new DelayMessage(scheduler.now() + this.delay, notification);
            this.queue.push(message);
            if (this.active === false) {
                this._schedule(scheduler);
            }
        };
        DelaySubscriber.prototype._next = function (value) {
            this.scheduleNotification(Notification.createNext(value));
        };
        DelaySubscriber.prototype._error = function (err) {
            this.errored = true;
            this.queue = [];
            this.destination.error(err);
        };
        DelaySubscriber.prototype._complete = function () {
            this.scheduleNotification(Notification.createComplete());
        };
        return DelaySubscriber;
    }(Subscriber));
    var DelayMessage = /*@__PURE__*/ (function () {
        function DelayMessage(time, notification) {
            this.time = time;
            this.notification = notification;
        }
        return DelayMessage;
    }());

    /** PURE_IMPORTS_START tslib,_Subscriber,_Observable,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var DelayWhenSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(DelayWhenSubscriber, _super);
        function DelayWhenSubscriber(destination, delayDurationSelector) {
            var _this = _super.call(this, destination) || this;
            _this.delayDurationSelector = delayDurationSelector;
            _this.completed = false;
            _this.delayNotifierSubscriptions = [];
            return _this;
        }
        DelayWhenSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.destination.next(outerValue);
            this.removeSubscription(innerSub);
            this.tryComplete();
        };
        DelayWhenSubscriber.prototype.notifyError = function (error, innerSub) {
            this._error(error);
        };
        DelayWhenSubscriber.prototype.notifyComplete = function (innerSub) {
            var value = this.removeSubscription(innerSub);
            if (value) {
                this.destination.next(value);
            }
            this.tryComplete();
        };
        DelayWhenSubscriber.prototype._next = function (value) {
            try {
                var delayNotifier = this.delayDurationSelector(value);
                if (delayNotifier) {
                    this.tryDelay(delayNotifier, value);
                }
            }
            catch (err) {
                this.destination.error(err);
            }
        };
        DelayWhenSubscriber.prototype._complete = function () {
            this.completed = true;
            this.tryComplete();
        };
        DelayWhenSubscriber.prototype.removeSubscription = function (subscription) {
            subscription.unsubscribe();
            var subscriptionIdx = this.delayNotifierSubscriptions.indexOf(subscription);
            if (subscriptionIdx !== -1) {
                this.delayNotifierSubscriptions.splice(subscriptionIdx, 1);
            }
            return subscription.outerValue;
        };
        DelayWhenSubscriber.prototype.tryDelay = function (delayNotifier, value) {
            var notifierSubscription = subscribeToResult(this, delayNotifier, value);
            if (notifierSubscription && !notifierSubscription.closed) {
                this.add(notifierSubscription);
                this.delayNotifierSubscriptions.push(notifierSubscription);
            }
        };
        DelayWhenSubscriber.prototype.tryComplete = function () {
            if (this.completed && this.delayNotifierSubscriptions.length === 0) {
                this.destination.complete();
            }
        };
        return DelayWhenSubscriber;
    }(OuterSubscriber));
    var SubscriptionDelayObservable = /*@__PURE__*/ (function (_super) {
        __extends(SubscriptionDelayObservable, _super);
        function SubscriptionDelayObservable(source, subscriptionDelay) {
            var _this = _super.call(this) || this;
            _this.source = source;
            _this.subscriptionDelay = subscriptionDelay;
            return _this;
        }
        SubscriptionDelayObservable.prototype._subscribe = function (subscriber) {
            this.subscriptionDelay.subscribe(new SubscriptionDelaySubscriber(subscriber, this.source));
        };
        return SubscriptionDelayObservable;
    }(Observable));
    var SubscriptionDelaySubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SubscriptionDelaySubscriber, _super);
        function SubscriptionDelaySubscriber(parent, source) {
            var _this = _super.call(this) || this;
            _this.parent = parent;
            _this.source = source;
            _this.sourceSubscribed = false;
            return _this;
        }
        SubscriptionDelaySubscriber.prototype._next = function (unused) {
            this.subscribeToSource();
        };
        SubscriptionDelaySubscriber.prototype._error = function (err) {
            this.unsubscribe();
            this.parent.error(err);
        };
        SubscriptionDelaySubscriber.prototype._complete = function () {
            this.subscribeToSource();
        };
        SubscriptionDelaySubscriber.prototype.subscribeToSource = function () {
            if (!this.sourceSubscribed) {
                this.sourceSubscribed = true;
                this.unsubscribe();
                this.source.subscribe(this.parent);
            }
        };
        return SubscriptionDelaySubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    var DeMaterializeSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(DeMaterializeSubscriber, _super);
        function DeMaterializeSubscriber(destination) {
            return _super.call(this, destination) || this;
        }
        DeMaterializeSubscriber.prototype._next = function (value) {
            value.observe(this.destination);
        };
        return DeMaterializeSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var DistinctSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(DistinctSubscriber, _super);
        function DistinctSubscriber(destination, keySelector, flushes) {
            var _this = _super.call(this, destination) || this;
            _this.keySelector = keySelector;
            _this.values = new Set();
            if (flushes) {
                _this.add(subscribeToResult(_this, flushes));
            }
            return _this;
        }
        DistinctSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.values.clear();
        };
        DistinctSubscriber.prototype.notifyError = function (error, innerSub) {
            this._error(error);
        };
        DistinctSubscriber.prototype._next = function (value) {
            if (this.keySelector) {
                this._useKeySelector(value);
            }
            else {
                this._finalizeNext(value, value);
            }
        };
        DistinctSubscriber.prototype._useKeySelector = function (value) {
            var key;
            var destination = this.destination;
            try {
                key = this.keySelector(value);
            }
            catch (err) {
                destination.error(err);
                return;
            }
            this._finalizeNext(key, value);
        };
        DistinctSubscriber.prototype._finalizeNext = function (key, value) {
            var values = this.values;
            if (!values.has(key)) {
                values.add(key);
                this.destination.next(value);
            }
        };
        return DistinctSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber,_util_tryCatch,_util_errorObject PURE_IMPORTS_END */
    var DistinctUntilChangedSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(DistinctUntilChangedSubscriber, _super);
        function DistinctUntilChangedSubscriber(destination, compare, keySelector) {
            var _this = _super.call(this, destination) || this;
            _this.keySelector = keySelector;
            _this.hasKey = false;
            if (typeof compare === 'function') {
                _this.compare = compare;
            }
            return _this;
        }
        DistinctUntilChangedSubscriber.prototype.compare = function (x, y) {
            return x === y;
        };
        DistinctUntilChangedSubscriber.prototype._next = function (value) {
            var keySelector = this.keySelector;
            var key = value;
            if (keySelector) {
                key = tryCatch(this.keySelector)(value);
                if (key === errorObject) {
                    return this.destination.error(errorObject.e);
                }
            }
            var result = false;
            if (this.hasKey) {
                result = tryCatch(this.compare)(this.key, key);
                if (result === errorObject) {
                    return this.destination.error(errorObject.e);
                }
            }
            else {
                this.hasKey = true;
            }
            if (Boolean(result) === false) {
                this.key = key;
                this.destination.next(value);
            }
        };
        return DistinctUntilChangedSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START _distinctUntilChanged PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib PURE_IMPORTS_END */
    var ArgumentOutOfRangeError = /*@__PURE__*/ (function (_super) {
        __extends(ArgumentOutOfRangeError, _super);
        function ArgumentOutOfRangeError() {
            var _this = _super.call(this, 'argument out of range') || this;
            _this.name = 'ArgumentOutOfRangeError';
            Object.setPrototypeOf(_this, ArgumentOutOfRangeError.prototype);
            return _this;
        }
        return ArgumentOutOfRangeError;
    }(Error));

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    var FilterSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(FilterSubscriber, _super);
        function FilterSubscriber(destination, predicate, thisArg) {
            var _this = _super.call(this, destination) || this;
            _this.predicate = predicate;
            _this.thisArg = thisArg;
            _this.count = 0;
            return _this;
        }
        FilterSubscriber.prototype._next = function (value) {
            var result;
            try {
                result = this.predicate.call(this.thisArg, value, this.count++);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            if (result) {
                this.destination.next(value);
            }
        };
        return FilterSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber,_util_noop,_util_isFunction PURE_IMPORTS_END */
    var TapSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(TapSubscriber, _super);
        function TapSubscriber(destination, observerOrNext, error, complete) {
            var _this = _super.call(this, destination) || this;
            _this._tapNext = noop;
            _this._tapError = noop;
            _this._tapComplete = noop;
            _this._tapError = error || noop;
            _this._tapComplete = complete || noop;
            if (isFunction(observerOrNext)) {
                _this._context = _this;
                _this._tapNext = observerOrNext;
            }
            else if (observerOrNext) {
                _this._context = observerOrNext;
                _this._tapNext = observerOrNext.next || noop;
                _this._tapError = observerOrNext.error || noop;
                _this._tapComplete = observerOrNext.complete || noop;
            }
            return _this;
        }
        TapSubscriber.prototype._next = function (value) {
            try {
                this._tapNext.call(this._context, value);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.destination.next(value);
        };
        TapSubscriber.prototype._error = function (err) {
            try {
                this._tapError.call(this._context, err);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.destination.error(err);
        };
        TapSubscriber.prototype._complete = function () {
            try {
                this._tapComplete.call(this._context);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            return this.destination.complete();
        };
        return TapSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib PURE_IMPORTS_END */
    var EmptyError = /*@__PURE__*/ (function (_super) {
        __extends(EmptyError, _super);
        function EmptyError() {
            var _this = _super.call(this, 'no elements in sequence') || this;
            _this.name = 'EmptyError';
            Object.setPrototypeOf(_this, EmptyError.prototype);
            return _this;
        }
        return EmptyError;
    }(Error));

    /** PURE_IMPORTS_START _tap,_util_EmptyError PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib,_Subscriber,_util_ArgumentOutOfRangeError,_observable_empty PURE_IMPORTS_END */
    var TakeSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(TakeSubscriber, _super);
        function TakeSubscriber(destination, total) {
            var _this = _super.call(this, destination) || this;
            _this.total = total;
            _this.count = 0;
            return _this;
        }
        TakeSubscriber.prototype._next = function (value) {
            var total = this.total;
            var count = ++this.count;
            if (count <= total) {
                this.destination.next(value);
                if (count === total) {
                    this.destination.complete();
                    this.unsubscribe();
                }
            }
        };
        return TakeSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START _util_ArgumentOutOfRangeError,_filter,_throwIfEmpty,_defaultIfEmpty,_take PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _observable_fromArray,_observable_scalar,_observable_empty,_observable_concat,_util_isScheduler PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    var EverySubscriber = /*@__PURE__*/ (function (_super) {
        __extends(EverySubscriber, _super);
        function EverySubscriber(destination, predicate, thisArg, source) {
            var _this = _super.call(this, destination) || this;
            _this.predicate = predicate;
            _this.thisArg = thisArg;
            _this.source = source;
            _this.index = 0;
            _this.thisArg = thisArg || _this;
            return _this;
        }
        EverySubscriber.prototype.notifyComplete = function (everyValueMatch) {
            this.destination.next(everyValueMatch);
            this.destination.complete();
        };
        EverySubscriber.prototype._next = function (value) {
            var result = false;
            try {
                result = this.predicate.call(this.thisArg, value, this.index++, this.source);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            if (!result) {
                this.notifyComplete(false);
            }
        };
        EverySubscriber.prototype._complete = function () {
            this.notifyComplete(true);
        };
        return EverySubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var SwitchFirstSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SwitchFirstSubscriber, _super);
        function SwitchFirstSubscriber(destination) {
            var _this = _super.call(this, destination) || this;
            _this.hasCompleted = false;
            _this.hasSubscription = false;
            return _this;
        }
        SwitchFirstSubscriber.prototype._next = function (value) {
            if (!this.hasSubscription) {
                this.hasSubscription = true;
                this.add(subscribeToResult(this, value));
            }
        };
        SwitchFirstSubscriber.prototype._complete = function () {
            this.hasCompleted = true;
            if (!this.hasSubscription) {
                this.destination.complete();
            }
        };
        SwitchFirstSubscriber.prototype.notifyComplete = function (innerSub) {
            this.remove(innerSub);
            this.hasSubscription = false;
            if (this.hasCompleted) {
                this.destination.complete();
            }
        };
        return SwitchFirstSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_OuterSubscriber,_util_subscribeToResult,_map,_observable_from PURE_IMPORTS_END */
    var ExhaustMapSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(ExhaustMapSubscriber, _super);
        function ExhaustMapSubscriber(destination, project) {
            var _this = _super.call(this, destination) || this;
            _this.project = project;
            _this.hasSubscription = false;
            _this.hasCompleted = false;
            _this.index = 0;
            return _this;
        }
        ExhaustMapSubscriber.prototype._next = function (value) {
            if (!this.hasSubscription) {
                this.tryNext(value);
            }
        };
        ExhaustMapSubscriber.prototype.tryNext = function (value) {
            var index = this.index++;
            var destination = this.destination;
            try {
                var result = this.project(value, index);
                this.hasSubscription = true;
                this.add(subscribeToResult(this, result, value, index));
            }
            catch (err) {
                destination.error(err);
            }
        };
        ExhaustMapSubscriber.prototype._complete = function () {
            this.hasCompleted = true;
            if (!this.hasSubscription) {
                this.destination.complete();
            }
        };
        ExhaustMapSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.destination.next(innerValue);
        };
        ExhaustMapSubscriber.prototype.notifyError = function (err) {
            this.destination.error(err);
        };
        ExhaustMapSubscriber.prototype.notifyComplete = function (innerSub) {
            this.remove(innerSub);
            this.hasSubscription = false;
            if (this.hasCompleted) {
                this.destination.complete();
            }
        };
        return ExhaustMapSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_util_tryCatch,_util_errorObject,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var ExpandSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(ExpandSubscriber, _super);
        function ExpandSubscriber(destination, project, concurrent, scheduler) {
            var _this = _super.call(this, destination) || this;
            _this.project = project;
            _this.concurrent = concurrent;
            _this.scheduler = scheduler;
            _this.index = 0;
            _this.active = 0;
            _this.hasCompleted = false;
            if (concurrent < Number.POSITIVE_INFINITY) {
                _this.buffer = [];
            }
            return _this;
        }
        ExpandSubscriber.dispatch = function (arg) {
            var subscriber = arg.subscriber, result = arg.result, value = arg.value, index = arg.index;
            subscriber.subscribeToProjection(result, value, index);
        };
        ExpandSubscriber.prototype._next = function (value) {
            var destination = this.destination;
            if (destination.closed) {
                this._complete();
                return;
            }
            var index = this.index++;
            if (this.active < this.concurrent) {
                destination.next(value);
                var result = tryCatch(this.project)(value, index);
                if (result === errorObject) {
                    destination.error(errorObject.e);
                }
                else if (!this.scheduler) {
                    this.subscribeToProjection(result, value, index);
                }
                else {
                    var state = { subscriber: this, result: result, value: value, index: index };
                    this.add(this.scheduler.schedule(ExpandSubscriber.dispatch, 0, state));
                }
            }
            else {
                this.buffer.push(value);
            }
        };
        ExpandSubscriber.prototype.subscribeToProjection = function (result, value, index) {
            this.active++;
            this.add(subscribeToResult(this, result, value, index));
        };
        ExpandSubscriber.prototype._complete = function () {
            this.hasCompleted = true;
            if (this.hasCompleted && this.active === 0) {
                this.destination.complete();
            }
        };
        ExpandSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this._next(innerValue);
        };
        ExpandSubscriber.prototype.notifyComplete = function (innerSub) {
            var buffer = this.buffer;
            this.remove(innerSub);
            this.active--;
            if (buffer && buffer.length > 0) {
                this._next(buffer.shift());
            }
            if (this.hasCompleted && this.active === 0) {
                this.destination.complete();
            }
        };
        return ExpandSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber,_Subscription PURE_IMPORTS_END */
    var FinallySubscriber = /*@__PURE__*/ (function (_super) {
        __extends(FinallySubscriber, _super);
        function FinallySubscriber(destination, callback) {
            var _this = _super.call(this, destination) || this;
            _this.add(new Subscription(callback));
            return _this;
        }
        return FinallySubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    var FindValueSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(FindValueSubscriber, _super);
        function FindValueSubscriber(destination, predicate, source, yieldIndex, thisArg) {
            var _this = _super.call(this, destination) || this;
            _this.predicate = predicate;
            _this.source = source;
            _this.yieldIndex = yieldIndex;
            _this.thisArg = thisArg;
            _this.index = 0;
            return _this;
        }
        FindValueSubscriber.prototype.notifyComplete = function (value) {
            var destination = this.destination;
            destination.next(value);
            destination.complete();
        };
        FindValueSubscriber.prototype._next = function (value) {
            var _a = this, predicate = _a.predicate, thisArg = _a.thisArg;
            var index = this.index++;
            try {
                var result = predicate.call(thisArg || this, value, index, this.source);
                if (result) {
                    this.notifyComplete(this.yieldIndex ? index : value);
                }
            }
            catch (err) {
                this.destination.error(err);
            }
        };
        FindValueSubscriber.prototype._complete = function () {
            this.notifyComplete(this.yieldIndex ? -1 : undefined);
        };
        return FindValueSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START _operators_find PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _util_EmptyError,_filter,_take,_defaultIfEmpty,_throwIfEmpty,_util_identity PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib PURE_IMPORTS_END */
    var ObjectUnsubscribedError = /*@__PURE__*/ (function (_super) {
        __extends(ObjectUnsubscribedError, _super);
        function ObjectUnsubscribedError() {
            var _this = _super.call(this, 'object unsubscribed') || this;
            _this.name = 'ObjectUnsubscribedError';
            Object.setPrototypeOf(_this, ObjectUnsubscribedError.prototype);
            return _this;
        }
        return ObjectUnsubscribedError;
    }(Error));

    /** PURE_IMPORTS_START tslib,_Subscription PURE_IMPORTS_END */
    var SubjectSubscription = /*@__PURE__*/ (function (_super) {
        __extends(SubjectSubscription, _super);
        function SubjectSubscription(subject, subscriber) {
            var _this = _super.call(this) || this;
            _this.subject = subject;
            _this.subscriber = subscriber;
            _this.closed = false;
            return _this;
        }
        SubjectSubscription.prototype.unsubscribe = function () {
            if (this.closed) {
                return;
            }
            this.closed = true;
            var subject = this.subject;
            var observers = subject.observers;
            this.subject = null;
            if (!observers || observers.length === 0 || subject.isStopped || subject.closed) {
                return;
            }
            var subscriberIndex = observers.indexOf(this.subscriber);
            if (subscriberIndex !== -1) {
                observers.splice(subscriberIndex, 1);
            }
        };
        return SubjectSubscription;
    }(Subscription));

    /** PURE_IMPORTS_START tslib,_Observable,_Subscriber,_Subscription,_util_ObjectUnsubscribedError,_SubjectSubscription,_internal_symbol_rxSubscriber PURE_IMPORTS_END */
    var SubjectSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SubjectSubscriber, _super);
        function SubjectSubscriber(destination) {
            var _this = _super.call(this, destination) || this;
            _this.destination = destination;
            return _this;
        }
        return SubjectSubscriber;
    }(Subscriber));
    var Subject = /*@__PURE__*/ (function (_super) {
        __extends(Subject, _super);
        function Subject() {
            var _this = _super.call(this) || this;
            _this.observers = [];
            _this.closed = false;
            _this.isStopped = false;
            _this.hasError = false;
            _this.thrownError = null;
            return _this;
        }
        Subject.prototype[rxSubscriber] = function () {
            return new SubjectSubscriber(this);
        };
        Subject.prototype.lift = function (operator) {
            var subject = new AnonymousSubject(this, this);
            subject.operator = operator;
            return subject;
        };
        Subject.prototype.next = function (value) {
            if (this.closed) {
                throw new ObjectUnsubscribedError();
            }
            if (!this.isStopped) {
                var observers = this.observers;
                var len = observers.length;
                var copy = observers.slice();
                for (var i = 0; i < len; i++) {
                    copy[i].next(value);
                }
            }
        };
        Subject.prototype.error = function (err) {
            if (this.closed) {
                throw new ObjectUnsubscribedError();
            }
            this.hasError = true;
            this.thrownError = err;
            this.isStopped = true;
            var observers = this.observers;
            var len = observers.length;
            var copy = observers.slice();
            for (var i = 0; i < len; i++) {
                copy[i].error(err);
            }
            this.observers.length = 0;
        };
        Subject.prototype.complete = function () {
            if (this.closed) {
                throw new ObjectUnsubscribedError();
            }
            this.isStopped = true;
            var observers = this.observers;
            var len = observers.length;
            var copy = observers.slice();
            for (var i = 0; i < len; i++) {
                copy[i].complete();
            }
            this.observers.length = 0;
        };
        Subject.prototype.unsubscribe = function () {
            this.isStopped = true;
            this.closed = true;
            this.observers = null;
        };
        Subject.prototype._trySubscribe = function (subscriber) {
            if (this.closed) {
                throw new ObjectUnsubscribedError();
            }
            else {
                return _super.prototype._trySubscribe.call(this, subscriber);
            }
        };
        Subject.prototype._subscribe = function (subscriber) {
            if (this.closed) {
                throw new ObjectUnsubscribedError();
            }
            else if (this.hasError) {
                subscriber.error(this.thrownError);
                return Subscription.EMPTY;
            }
            else if (this.isStopped) {
                subscriber.complete();
                return Subscription.EMPTY;
            }
            else {
                this.observers.push(subscriber);
                return new SubjectSubscription(this, subscriber);
            }
        };
        Subject.prototype.asObservable = function () {
            var observable = new Observable();
            observable.source = this;
            return observable;
        };
        Subject.create = function (destination, source) {
            return new AnonymousSubject(destination, source);
        };
        return Subject;
    }(Observable));
    var AnonymousSubject = /*@__PURE__*/ (function (_super) {
        __extends(AnonymousSubject, _super);
        function AnonymousSubject(destination, source) {
            var _this = _super.call(this) || this;
            _this.destination = destination;
            _this.source = source;
            return _this;
        }
        AnonymousSubject.prototype.next = function (value) {
            var destination = this.destination;
            if (destination && destination.next) {
                destination.next(value);
            }
        };
        AnonymousSubject.prototype.error = function (err) {
            var destination = this.destination;
            if (destination && destination.error) {
                this.destination.error(err);
            }
        };
        AnonymousSubject.prototype.complete = function () {
            var destination = this.destination;
            if (destination && destination.complete) {
                this.destination.complete();
            }
        };
        AnonymousSubject.prototype._subscribe = function (subscriber) {
            var source = this.source;
            if (source) {
                return this.source.subscribe(subscriber);
            }
            else {
                return Subscription.EMPTY;
            }
        };
        return AnonymousSubject;
    }(Subject));

    /** PURE_IMPORTS_START tslib,_Subscriber,_Subscription,_Observable,_Subject PURE_IMPORTS_END */
    var GroupBySubscriber = /*@__PURE__*/ (function (_super) {
        __extends(GroupBySubscriber, _super);
        function GroupBySubscriber(destination, keySelector, elementSelector, durationSelector, subjectSelector) {
            var _this = _super.call(this, destination) || this;
            _this.keySelector = keySelector;
            _this.elementSelector = elementSelector;
            _this.durationSelector = durationSelector;
            _this.subjectSelector = subjectSelector;
            _this.groups = null;
            _this.attemptedToUnsubscribe = false;
            _this.count = 0;
            return _this;
        }
        GroupBySubscriber.prototype._next = function (value) {
            var key;
            try {
                key = this.keySelector(value);
            }
            catch (err) {
                this.error(err);
                return;
            }
            this._group(value, key);
        };
        GroupBySubscriber.prototype._group = function (value, key) {
            var groups = this.groups;
            if (!groups) {
                groups = this.groups = new Map();
            }
            var group = groups.get(key);
            var element;
            if (this.elementSelector) {
                try {
                    element = this.elementSelector(value);
                }
                catch (err) {
                    this.error(err);
                }
            }
            else {
                element = value;
            }
            if (!group) {
                group = (this.subjectSelector ? this.subjectSelector() : new Subject());
                groups.set(key, group);
                var groupedObservable = new GroupedObservable(key, group, this);
                this.destination.next(groupedObservable);
                if (this.durationSelector) {
                    var duration = void 0;
                    try {
                        duration = this.durationSelector(new GroupedObservable(key, group));
                    }
                    catch (err) {
                        this.error(err);
                        return;
                    }
                    this.add(duration.subscribe(new GroupDurationSubscriber(key, group, this)));
                }
            }
            if (!group.closed) {
                group.next(element);
            }
        };
        GroupBySubscriber.prototype._error = function (err) {
            var groups = this.groups;
            if (groups) {
                groups.forEach(function (group, key) {
                    group.error(err);
                });
                groups.clear();
            }
            this.destination.error(err);
        };
        GroupBySubscriber.prototype._complete = function () {
            var groups = this.groups;
            if (groups) {
                groups.forEach(function (group, key) {
                    group.complete();
                });
                groups.clear();
            }
            this.destination.complete();
        };
        GroupBySubscriber.prototype.removeGroup = function (key) {
            this.groups.delete(key);
        };
        GroupBySubscriber.prototype.unsubscribe = function () {
            if (!this.closed) {
                this.attemptedToUnsubscribe = true;
                if (this.count === 0) {
                    _super.prototype.unsubscribe.call(this);
                }
            }
        };
        return GroupBySubscriber;
    }(Subscriber));
    var GroupDurationSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(GroupDurationSubscriber, _super);
        function GroupDurationSubscriber(key, group, parent) {
            var _this = _super.call(this, group) || this;
            _this.key = key;
            _this.group = group;
            _this.parent = parent;
            return _this;
        }
        GroupDurationSubscriber.prototype._next = function (value) {
            this.complete();
        };
        GroupDurationSubscriber.prototype._unsubscribe = function () {
            var _a = this, parent = _a.parent, key = _a.key;
            this.key = this.parent = null;
            if (parent) {
                parent.removeGroup(key);
            }
        };
        return GroupDurationSubscriber;
    }(Subscriber));
    var GroupedObservable = /*@__PURE__*/ (function (_super) {
        __extends(GroupedObservable, _super);
        function GroupedObservable(key, groupSubject, refCountSubscription) {
            var _this = _super.call(this) || this;
            _this.key = key;
            _this.groupSubject = groupSubject;
            _this.refCountSubscription = refCountSubscription;
            return _this;
        }
        GroupedObservable.prototype._subscribe = function (subscriber) {
            var subscription = new Subscription();
            var _a = this, refCountSubscription = _a.refCountSubscription, groupSubject = _a.groupSubject;
            if (refCountSubscription && !refCountSubscription.closed) {
                subscription.add(new InnerRefCountSubscription(refCountSubscription));
            }
            subscription.add(groupSubject.subscribe(subscriber));
            return subscription;
        };
        return GroupedObservable;
    }(Observable));
    var InnerRefCountSubscription = /*@__PURE__*/ (function (_super) {
        __extends(InnerRefCountSubscription, _super);
        function InnerRefCountSubscription(parent) {
            var _this = _super.call(this) || this;
            _this.parent = parent;
            parent.count++;
            return _this;
        }
        InnerRefCountSubscription.prototype.unsubscribe = function () {
            var parent = this.parent;
            if (!parent.closed && !this.closed) {
                _super.prototype.unsubscribe.call(this);
                parent.count -= 1;
                if (parent.count === 0 && parent.attemptedToUnsubscribe) {
                    parent.unsubscribe();
                }
            }
        };
        return InnerRefCountSubscription;
    }(Subscription));

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    var IgnoreElementsSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(IgnoreElementsSubscriber, _super);
        function IgnoreElementsSubscriber() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        IgnoreElementsSubscriber.prototype._next = function (unused) {
        };
        return IgnoreElementsSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    var IsEmptySubscriber = /*@__PURE__*/ (function (_super) {
        __extends(IsEmptySubscriber, _super);
        function IsEmptySubscriber(destination) {
            return _super.call(this, destination) || this;
        }
        IsEmptySubscriber.prototype.notifyComplete = function (isEmpty) {
            var destination = this.destination;
            destination.next(isEmpty);
            destination.complete();
        };
        IsEmptySubscriber.prototype._next = function (value) {
            this.notifyComplete(false);
        };
        IsEmptySubscriber.prototype._complete = function () {
            this.notifyComplete(true);
        };
        return IsEmptySubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber,_util_ArgumentOutOfRangeError,_observable_empty PURE_IMPORTS_END */
    var TakeLastSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(TakeLastSubscriber, _super);
        function TakeLastSubscriber(destination, total) {
            var _this = _super.call(this, destination) || this;
            _this.total = total;
            _this.ring = new Array();
            _this.count = 0;
            return _this;
        }
        TakeLastSubscriber.prototype._next = function (value) {
            var ring = this.ring;
            var total = this.total;
            var count = this.count++;
            if (ring.length < total) {
                ring.push(value);
            }
            else {
                var index = count % total;
                ring[index] = value;
            }
        };
        TakeLastSubscriber.prototype._complete = function () {
            var destination = this.destination;
            var count = this.count;
            if (count > 0) {
                var total = this.count >= this.total ? this.total : this.count;
                var ring = this.ring;
                for (var i = 0; i < total; i++) {
                    var idx = (count++) % total;
                    destination.next(ring[idx]);
                }
            }
            destination.complete();
        };
        return TakeLastSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START _util_EmptyError,_filter,_takeLast,_throwIfEmpty,_defaultIfEmpty,_util_identity PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    var MapToSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(MapToSubscriber, _super);
        function MapToSubscriber(destination, value) {
            var _this = _super.call(this, destination) || this;
            _this.value = value;
            return _this;
        }
        MapToSubscriber.prototype._next = function (x) {
            this.destination.next(this.value);
        };
        return MapToSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber,_Notification PURE_IMPORTS_END */
    var MaterializeSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(MaterializeSubscriber, _super);
        function MaterializeSubscriber(destination) {
            return _super.call(this, destination) || this;
        }
        MaterializeSubscriber.prototype._next = function (value) {
            this.destination.next(Notification.createNext(value));
        };
        MaterializeSubscriber.prototype._error = function (err) {
            var destination = this.destination;
            destination.next(Notification.createError(err));
            destination.complete();
        };
        MaterializeSubscriber.prototype._complete = function () {
            var destination = this.destination;
            destination.next(Notification.createComplete());
            destination.complete();
        };
        return MaterializeSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    var ScanSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(ScanSubscriber, _super);
        function ScanSubscriber(destination, accumulator, _seed, hasSeed) {
            var _this = _super.call(this, destination) || this;
            _this.accumulator = accumulator;
            _this._seed = _seed;
            _this.hasSeed = hasSeed;
            _this.index = 0;
            return _this;
        }
        Object.defineProperty(ScanSubscriber.prototype, "seed", {
            get: function () {
                return this._seed;
            },
            set: function (value) {
                this.hasSeed = true;
                this._seed = value;
            },
            enumerable: true,
            configurable: true
        });
        ScanSubscriber.prototype._next = function (value) {
            if (!this.hasSeed) {
                this.seed = value;
                this.destination.next(value);
            }
            else {
                return this._tryNext(value);
            }
        };
        ScanSubscriber.prototype._tryNext = function (value) {
            var index = this.index++;
            var result;
            try {
                result = this.accumulator(this.seed, value, index);
            }
            catch (err) {
                this.destination.error(err);
            }
            this.seed = result;
            this.destination.next(result);
        };
        return ScanSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START _scan,_takeLast,_defaultIfEmpty,_util_pipe PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _reduce PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _Observable,_util_isScheduler,_operators_mergeAll,_fromArray PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _observable_merge PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _mergeMap PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib,_util_tryCatch,_util_errorObject,_util_subscribeToResult,_OuterSubscriber PURE_IMPORTS_END */
    var MergeScanSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(MergeScanSubscriber, _super);
        function MergeScanSubscriber(destination, accumulator, acc, concurrent) {
            var _this = _super.call(this, destination) || this;
            _this.accumulator = accumulator;
            _this.acc = acc;
            _this.concurrent = concurrent;
            _this.hasValue = false;
            _this.hasCompleted = false;
            _this.buffer = [];
            _this.active = 0;
            _this.index = 0;
            return _this;
        }
        MergeScanSubscriber.prototype._next = function (value) {
            if (this.active < this.concurrent) {
                var index = this.index++;
                var ish = tryCatch(this.accumulator)(this.acc, value);
                var destination = this.destination;
                if (ish === errorObject) {
                    destination.error(errorObject.e);
                }
                else {
                    this.active++;
                    this._innerSub(ish, value, index);
                }
            }
            else {
                this.buffer.push(value);
            }
        };
        MergeScanSubscriber.prototype._innerSub = function (ish, value, index) {
            this.add(subscribeToResult(this, ish, value, index));
        };
        MergeScanSubscriber.prototype._complete = function () {
            this.hasCompleted = true;
            if (this.active === 0 && this.buffer.length === 0) {
                if (this.hasValue === false) {
                    this.destination.next(this.acc);
                }
                this.destination.complete();
            }
        };
        MergeScanSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            var destination = this.destination;
            this.acc = innerValue;
            this.hasValue = true;
            destination.next(innerValue);
        };
        MergeScanSubscriber.prototype.notifyComplete = function (innerSub) {
            var buffer = this.buffer;
            this.remove(innerSub);
            this.active--;
            if (buffer.length > 0) {
                this._next(buffer.shift());
            }
            else if (this.active === 0 && this.hasCompleted) {
                if (this.hasValue === false) {
                    this.destination.next(this.acc);
                }
                this.destination.complete();
            }
        };
        return MergeScanSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START _reduce PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    function refCount() {
        return function refCountOperatorFunction(source) {
            return source.lift(new RefCountOperator(source));
        };
    }
    var RefCountOperator = /*@__PURE__*/ (function () {
        function RefCountOperator(connectable) {
            this.connectable = connectable;
        }
        RefCountOperator.prototype.call = function (subscriber, source) {
            var connectable = this.connectable;
            connectable._refCount++;
            var refCounter = new RefCountSubscriber(subscriber, connectable);
            var subscription = source.subscribe(refCounter);
            if (!refCounter.closed) {
                refCounter.connection = connectable.connect();
            }
            return subscription;
        };
        return RefCountOperator;
    }());
    var RefCountSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(RefCountSubscriber, _super);
        function RefCountSubscriber(destination, connectable) {
            var _this = _super.call(this, destination) || this;
            _this.connectable = connectable;
            return _this;
        }
        RefCountSubscriber.prototype._unsubscribe = function () {
            var connectable = this.connectable;
            if (!connectable) {
                this.connection = null;
                return;
            }
            this.connectable = null;
            var refCount = connectable._refCount;
            if (refCount <= 0) {
                this.connection = null;
                return;
            }
            connectable._refCount = refCount - 1;
            if (refCount > 1) {
                this.connection = null;
                return;
            }
            var connection = this.connection;
            var sharedConnection = connectable._connection;
            this.connection = null;
            if (sharedConnection && (!connection || sharedConnection === connection)) {
                sharedConnection.unsubscribe();
            }
        };
        return RefCountSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_Subject,_Observable,_Subscriber,_Subscription,_operators_refCount PURE_IMPORTS_END */
    var ConnectableObservable = /*@__PURE__*/ (function (_super) {
        __extends(ConnectableObservable, _super);
        function ConnectableObservable(source, subjectFactory) {
            var _this = _super.call(this) || this;
            _this.source = source;
            _this.subjectFactory = subjectFactory;
            _this._refCount = 0;
            _this._isComplete = false;
            return _this;
        }
        ConnectableObservable.prototype._subscribe = function (subscriber) {
            return this.getSubject().subscribe(subscriber);
        };
        ConnectableObservable.prototype.getSubject = function () {
            var subject = this._subject;
            if (!subject || subject.isStopped) {
                this._subject = this.subjectFactory();
            }
            return this._subject;
        };
        ConnectableObservable.prototype.connect = function () {
            var connection = this._connection;
            if (!connection) {
                this._isComplete = false;
                connection = this._connection = new Subscription();
                connection.add(this.source
                    .subscribe(new ConnectableSubscriber(this.getSubject(), this)));
                if (connection.closed) {
                    this._connection = null;
                    connection = Subscription.EMPTY;
                }
                else {
                    this._connection = connection;
                }
            }
            return connection;
        };
        ConnectableObservable.prototype.refCount = function () {
            return refCount()(this);
        };
        return ConnectableObservable;
    }(Observable));
    var ConnectableSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(ConnectableSubscriber, _super);
        function ConnectableSubscriber(destination, connectable) {
            var _this = _super.call(this, destination) || this;
            _this.connectable = connectable;
            return _this;
        }
        ConnectableSubscriber.prototype._error = function (err) {
            this._unsubscribe();
            _super.prototype._error.call(this, err);
        };
        ConnectableSubscriber.prototype._complete = function () {
            this.connectable._isComplete = true;
            this._unsubscribe();
            _super.prototype._complete.call(this);
        };
        ConnectableSubscriber.prototype._unsubscribe = function () {
            var connectable = this.connectable;
            if (connectable) {
                this.connectable = null;
                var connection = connectable._connection;
                connectable._refCount = 0;
                connectable._subject = null;
                connectable._connection = null;
                if (connection) {
                    connection.unsubscribe();
                }
            }
        };
        return ConnectableSubscriber;
    }(SubjectSubscriber));
    var RefCountSubscriber$1 = /*@__PURE__*/ (function (_super) {
        __extends(RefCountSubscriber, _super);
        function RefCountSubscriber(destination, connectable) {
            var _this = _super.call(this, destination) || this;
            _this.connectable = connectable;
            return _this;
        }
        RefCountSubscriber.prototype._unsubscribe = function () {
            var connectable = this.connectable;
            if (!connectable) {
                this.connection = null;
                return;
            }
            this.connectable = null;
            var refCount$$1 = connectable._refCount;
            if (refCount$$1 <= 0) {
                this.connection = null;
                return;
            }
            connectable._refCount = refCount$$1 - 1;
            if (refCount$$1 > 1) {
                this.connection = null;
                return;
            }
            var connection = this.connection;
            var sharedConnection = connectable._connection;
            this.connection = null;
            if (sharedConnection && (!connection || sharedConnection === connection)) {
                sharedConnection.unsubscribe();
            }
        };
        return RefCountSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START _observable_ConnectableObservable PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib,_Subscriber,_Notification PURE_IMPORTS_END */
    var ObserveOnSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(ObserveOnSubscriber, _super);
        function ObserveOnSubscriber(destination, scheduler, delay) {
            if (delay === void 0) {
                delay = 0;
            }
            var _this = _super.call(this, destination) || this;
            _this.scheduler = scheduler;
            _this.delay = delay;
            return _this;
        }
        ObserveOnSubscriber.dispatch = function (arg) {
            var notification = arg.notification, destination = arg.destination;
            notification.observe(destination);
            this.unsubscribe();
        };
        ObserveOnSubscriber.prototype.scheduleMessage = function (notification) {
            this.add(this.scheduler.schedule(ObserveOnSubscriber.dispatch, this.delay, new ObserveOnMessage(notification, this.destination)));
        };
        ObserveOnSubscriber.prototype._next = function (value) {
            this.scheduleMessage(Notification.createNext(value));
        };
        ObserveOnSubscriber.prototype._error = function (err) {
            this.scheduleMessage(Notification.createError(err));
        };
        ObserveOnSubscriber.prototype._complete = function () {
            this.scheduleMessage(Notification.createComplete());
        };
        return ObserveOnSubscriber;
    }(Subscriber));
    var ObserveOnMessage = /*@__PURE__*/ (function () {
        function ObserveOnMessage(notification, destination) {
            this.notification = notification;
            this.destination = destination;
        }
        return ObserveOnMessage;
    }());

    /** PURE_IMPORTS_START tslib,_observable_from,_util_isArray,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var OnErrorResumeNextSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(OnErrorResumeNextSubscriber, _super);
        function OnErrorResumeNextSubscriber(destination, nextSources) {
            var _this = _super.call(this, destination) || this;
            _this.destination = destination;
            _this.nextSources = nextSources;
            return _this;
        }
        OnErrorResumeNextSubscriber.prototype.notifyError = function (error, innerSub) {
            this.subscribeToNextSource();
        };
        OnErrorResumeNextSubscriber.prototype.notifyComplete = function (innerSub) {
            this.subscribeToNextSource();
        };
        OnErrorResumeNextSubscriber.prototype._error = function (err) {
            this.subscribeToNextSource();
        };
        OnErrorResumeNextSubscriber.prototype._complete = function () {
            this.subscribeToNextSource();
        };
        OnErrorResumeNextSubscriber.prototype.subscribeToNextSource = function () {
            var next = this.nextSources.shift();
            if (next) {
                this.add(subscribeToResult(this, next));
            }
            else {
                this.destination.complete();
            }
        };
        return OnErrorResumeNextSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    var PairwiseSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(PairwiseSubscriber, _super);
        function PairwiseSubscriber(destination) {
            var _this = _super.call(this, destination) || this;
            _this.hasPrev = false;
            return _this;
        }
        PairwiseSubscriber.prototype._next = function (value) {
            if (this.hasPrev) {
                this.destination.next([this.prev, value]);
            }
            else {
                this.hasPrev = true;
            }
            this.prev = value;
        };
        return PairwiseSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _util_not,_filter PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _map PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _Subject,_multicast PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib,_Subject,_util_ObjectUnsubscribedError PURE_IMPORTS_END */
    var BehaviorSubject = /*@__PURE__*/ (function (_super) {
        __extends(BehaviorSubject, _super);
        function BehaviorSubject(_value) {
            var _this = _super.call(this) || this;
            _this._value = _value;
            return _this;
        }
        Object.defineProperty(BehaviorSubject.prototype, "value", {
            get: function () {
                return this.getValue();
            },
            enumerable: true,
            configurable: true
        });
        BehaviorSubject.prototype._subscribe = function (subscriber) {
            var subscription = _super.prototype._subscribe.call(this, subscriber);
            if (subscription && !subscription.closed) {
                subscriber.next(this._value);
            }
            return subscription;
        };
        BehaviorSubject.prototype.getValue = function () {
            if (this.hasError) {
                throw this.thrownError;
            }
            else if (this.closed) {
                throw new ObjectUnsubscribedError();
            }
            else {
                return this._value;
            }
        };
        BehaviorSubject.prototype.next = function (value) {
            _super.prototype.next.call(this, this._value = value);
        };
        return BehaviorSubject;
    }(Subject));

    /** PURE_IMPORTS_START _BehaviorSubject,_multicast PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib,_Subject,_Subscription PURE_IMPORTS_END */
    var AsyncSubject = /*@__PURE__*/ (function (_super) {
        __extends(AsyncSubject, _super);
        function AsyncSubject() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.value = null;
            _this.hasNext = false;
            _this.hasCompleted = false;
            return _this;
        }
        AsyncSubject.prototype._subscribe = function (subscriber) {
            if (this.hasError) {
                subscriber.error(this.thrownError);
                return Subscription.EMPTY;
            }
            else if (this.hasCompleted && this.hasNext) {
                subscriber.next(this.value);
                subscriber.complete();
                return Subscription.EMPTY;
            }
            return _super.prototype._subscribe.call(this, subscriber);
        };
        AsyncSubject.prototype.next = function (value) {
            if (!this.hasCompleted) {
                this.value = value;
                this.hasNext = true;
            }
        };
        AsyncSubject.prototype.error = function (error) {
            if (!this.hasCompleted) {
                _super.prototype.error.call(this, error);
            }
        };
        AsyncSubject.prototype.complete = function () {
            this.hasCompleted = true;
            if (this.hasNext) {
                _super.prototype.next.call(this, this.value);
            }
            _super.prototype.complete.call(this);
        };
        return AsyncSubject;
    }(Subject));

    /** PURE_IMPORTS_START _AsyncSubject,_multicast PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib,_AsyncAction PURE_IMPORTS_END */
    var QueueAction = /*@__PURE__*/ (function (_super) {
        __extends(QueueAction, _super);
        function QueueAction(scheduler, work) {
            var _this = _super.call(this, scheduler, work) || this;
            _this.scheduler = scheduler;
            _this.work = work;
            return _this;
        }
        QueueAction.prototype.schedule = function (state, delay) {
            if (delay === void 0) {
                delay = 0;
            }
            if (delay > 0) {
                return _super.prototype.schedule.call(this, state, delay);
            }
            this.delay = delay;
            this.state = state;
            this.scheduler.flush(this);
            return this;
        };
        QueueAction.prototype.execute = function (state, delay) {
            return (delay > 0 || this.closed) ?
                _super.prototype.execute.call(this, state, delay) :
                this._execute(state, delay);
        };
        QueueAction.prototype.requestAsyncId = function (scheduler, id, delay) {
            if (delay === void 0) {
                delay = 0;
            }
            if ((delay !== null && delay > 0) || (delay === null && this.delay > 0)) {
                return _super.prototype.requestAsyncId.call(this, scheduler, id, delay);
            }
            return scheduler.flush(this);
        };
        return QueueAction;
    }(AsyncAction));

    /** PURE_IMPORTS_START tslib,_AsyncScheduler PURE_IMPORTS_END */
    var QueueScheduler = /*@__PURE__*/ (function (_super) {
        __extends(QueueScheduler, _super);
        function QueueScheduler() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return QueueScheduler;
    }(AsyncScheduler));

    /** PURE_IMPORTS_START _QueueAction,_QueueScheduler PURE_IMPORTS_END */
    var queue = /*@__PURE__*/ new QueueScheduler(QueueAction);

    /** PURE_IMPORTS_START tslib,_Subject,_scheduler_queue,_Subscription,_operators_observeOn,_util_ObjectUnsubscribedError,_SubjectSubscription PURE_IMPORTS_END */
    var ReplaySubject = /*@__PURE__*/ (function (_super) {
        __extends(ReplaySubject, _super);
        function ReplaySubject(bufferSize, windowTime, scheduler) {
            if (bufferSize === void 0) {
                bufferSize = Number.POSITIVE_INFINITY;
            }
            if (windowTime === void 0) {
                windowTime = Number.POSITIVE_INFINITY;
            }
            var _this = _super.call(this) || this;
            _this.scheduler = scheduler;
            _this._events = [];
            _this._infiniteTimeWindow = false;
            _this._bufferSize = bufferSize < 1 ? 1 : bufferSize;
            _this._windowTime = windowTime < 1 ? 1 : windowTime;
            if (windowTime === Number.POSITIVE_INFINITY) {
                _this._infiniteTimeWindow = true;
                _this.next = _this.nextInfiniteTimeWindow;
            }
            else {
                _this.next = _this.nextTimeWindow;
            }
            return _this;
        }
        ReplaySubject.prototype.nextInfiniteTimeWindow = function (value) {
            var _events = this._events;
            _events.push(value);
            if (_events.length > this._bufferSize) {
                _events.shift();
            }
            _super.prototype.next.call(this, value);
        };
        ReplaySubject.prototype.nextTimeWindow = function (value) {
            this._events.push(new ReplayEvent(this._getNow(), value));
            this._trimBufferThenGetEvents();
            _super.prototype.next.call(this, value);
        };
        ReplaySubject.prototype._subscribe = function (subscriber) {
            var _infiniteTimeWindow = this._infiniteTimeWindow;
            var _events = _infiniteTimeWindow ? this._events : this._trimBufferThenGetEvents();
            var scheduler = this.scheduler;
            var len = _events.length;
            var subscription;
            if (this.closed) {
                throw new ObjectUnsubscribedError();
            }
            else if (this.isStopped || this.hasError) {
                subscription = Subscription.EMPTY;
            }
            else {
                this.observers.push(subscriber);
                subscription = new SubjectSubscription(this, subscriber);
            }
            if (scheduler) {
                subscriber.add(subscriber = new ObserveOnSubscriber(subscriber, scheduler));
            }
            if (_infiniteTimeWindow) {
                for (var i = 0; i < len && !subscriber.closed; i++) {
                    subscriber.next(_events[i]);
                }
            }
            else {
                for (var i = 0; i < len && !subscriber.closed; i++) {
                    subscriber.next(_events[i].value);
                }
            }
            if (this.hasError) {
                subscriber.error(this.thrownError);
            }
            else if (this.isStopped) {
                subscriber.complete();
            }
            return subscription;
        };
        ReplaySubject.prototype._getNow = function () {
            return (this.scheduler || queue).now();
        };
        ReplaySubject.prototype._trimBufferThenGetEvents = function () {
            var now = this._getNow();
            var _bufferSize = this._bufferSize;
            var _windowTime = this._windowTime;
            var _events = this._events;
            var eventsCount = _events.length;
            var spliceCount = 0;
            while (spliceCount < eventsCount) {
                if ((now - _events[spliceCount].time) < _windowTime) {
                    break;
                }
                spliceCount++;
            }
            if (eventsCount > _bufferSize) {
                spliceCount = Math.max(spliceCount, eventsCount - _bufferSize);
            }
            if (spliceCount > 0) {
                _events.splice(0, spliceCount);
            }
            return _events;
        };
        return ReplaySubject;
    }(Subject));
    var ReplayEvent = /*@__PURE__*/ (function () {
        function ReplayEvent(time, value) {
            this.time = time;
            this.value = value;
        }
        return ReplayEvent;
    }());

    /** PURE_IMPORTS_START _ReplaySubject,_multicast PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib,_util_isArray,_fromArray,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var RaceSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(RaceSubscriber, _super);
        function RaceSubscriber(destination) {
            var _this = _super.call(this, destination) || this;
            _this.hasFirst = false;
            _this.observables = [];
            _this.subscriptions = [];
            return _this;
        }
        RaceSubscriber.prototype._next = function (observable) {
            this.observables.push(observable);
        };
        RaceSubscriber.prototype._complete = function () {
            var observables = this.observables;
            var len = observables.length;
            if (len === 0) {
                this.destination.complete();
            }
            else {
                for (var i = 0; i < len && !this.hasFirst; i++) {
                    var observable = observables[i];
                    var subscription = subscribeToResult(this, observable, observable, i);
                    if (this.subscriptions) {
                        this.subscriptions.push(subscription);
                    }
                    this.add(subscription);
                }
                this.observables = null;
            }
        };
        RaceSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            if (!this.hasFirst) {
                this.hasFirst = true;
                for (var i = 0; i < this.subscriptions.length; i++) {
                    if (i !== outerIndex) {
                        var subscription = this.subscriptions[i];
                        subscription.unsubscribe();
                        this.remove(subscription);
                    }
                }
                this.subscriptions = null;
            }
            this.destination.next(innerValue);
        };
        return RaceSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START _util_isArray,_observable_race PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib,_Subscriber,_observable_empty PURE_IMPORTS_END */
    var RepeatSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(RepeatSubscriber, _super);
        function RepeatSubscriber(destination, count, source) {
            var _this = _super.call(this, destination) || this;
            _this.count = count;
            _this.source = source;
            return _this;
        }
        RepeatSubscriber.prototype.complete = function () {
            if (!this.isStopped) {
                var _a = this, source = _a.source, count = _a.count;
                if (count === 0) {
                    return _super.prototype.complete.call(this);
                }
                else if (count > -1) {
                    this.count = count - 1;
                }
                source.subscribe(this._unsubscribeAndRecycle());
            }
        };
        return RepeatSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_Subject,_util_tryCatch,_util_errorObject,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var RepeatWhenSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(RepeatWhenSubscriber, _super);
        function RepeatWhenSubscriber(destination, notifier, source) {
            var _this = _super.call(this, destination) || this;
            _this.notifier = notifier;
            _this.source = source;
            _this.sourceIsBeingSubscribedTo = true;
            return _this;
        }
        RepeatWhenSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.sourceIsBeingSubscribedTo = true;
            this.source.subscribe(this);
        };
        RepeatWhenSubscriber.prototype.notifyComplete = function (innerSub) {
            if (this.sourceIsBeingSubscribedTo === false) {
                return _super.prototype.complete.call(this);
            }
        };
        RepeatWhenSubscriber.prototype.complete = function () {
            this.sourceIsBeingSubscribedTo = false;
            if (!this.isStopped) {
                if (!this.retries) {
                    this.subscribeToRetries();
                }
                if (!this.retriesSubscription || this.retriesSubscription.closed) {
                    return _super.prototype.complete.call(this);
                }
                this._unsubscribeAndRecycle();
                this.notifications.next();
            }
        };
        RepeatWhenSubscriber.prototype._unsubscribe = function () {
            var _a = this, notifications = _a.notifications, retriesSubscription = _a.retriesSubscription;
            if (notifications) {
                notifications.unsubscribe();
                this.notifications = null;
            }
            if (retriesSubscription) {
                retriesSubscription.unsubscribe();
                this.retriesSubscription = null;
            }
            this.retries = null;
        };
        RepeatWhenSubscriber.prototype._unsubscribeAndRecycle = function () {
            var _unsubscribe = this._unsubscribe;
            this._unsubscribe = null;
            _super.prototype._unsubscribeAndRecycle.call(this);
            this._unsubscribe = _unsubscribe;
            return this;
        };
        RepeatWhenSubscriber.prototype.subscribeToRetries = function () {
            this.notifications = new Subject();
            var retries = tryCatch(this.notifier)(this.notifications);
            if (retries === errorObject) {
                return _super.prototype.complete.call(this);
            }
            this.retries = retries;
            this.retriesSubscription = subscribeToResult(this, retries);
        };
        return RepeatWhenSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    var RetrySubscriber = /*@__PURE__*/ (function (_super) {
        __extends(RetrySubscriber, _super);
        function RetrySubscriber(destination, count, source) {
            var _this = _super.call(this, destination) || this;
            _this.count = count;
            _this.source = source;
            return _this;
        }
        RetrySubscriber.prototype.error = function (err) {
            if (!this.isStopped) {
                var _a = this, source = _a.source, count = _a.count;
                if (count === 0) {
                    return _super.prototype.error.call(this, err);
                }
                else if (count > -1) {
                    this.count = count - 1;
                }
                source.subscribe(this._unsubscribeAndRecycle());
            }
        };
        return RetrySubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_Subject,_util_tryCatch,_util_errorObject,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var RetryWhenSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(RetryWhenSubscriber, _super);
        function RetryWhenSubscriber(destination, notifier, source) {
            var _this = _super.call(this, destination) || this;
            _this.notifier = notifier;
            _this.source = source;
            return _this;
        }
        RetryWhenSubscriber.prototype.error = function (err) {
            if (!this.isStopped) {
                var errors = this.errors;
                var retries = this.retries;
                var retriesSubscription = this.retriesSubscription;
                if (!retries) {
                    errors = new Subject();
                    retries = tryCatch(this.notifier)(errors);
                    if (retries === errorObject) {
                        return _super.prototype.error.call(this, errorObject.e);
                    }
                    retriesSubscription = subscribeToResult(this, retries);
                }
                else {
                    this.errors = null;
                    this.retriesSubscription = null;
                }
                this._unsubscribeAndRecycle();
                this.errors = errors;
                this.retries = retries;
                this.retriesSubscription = retriesSubscription;
                errors.next(err);
            }
        };
        RetryWhenSubscriber.prototype._unsubscribe = function () {
            var _a = this, errors = _a.errors, retriesSubscription = _a.retriesSubscription;
            if (errors) {
                errors.unsubscribe();
                this.errors = null;
            }
            if (retriesSubscription) {
                retriesSubscription.unsubscribe();
                this.retriesSubscription = null;
            }
            this.retries = null;
        };
        RetryWhenSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            var _unsubscribe = this._unsubscribe;
            this._unsubscribe = null;
            this._unsubscribeAndRecycle();
            this._unsubscribe = _unsubscribe;
            this.source.subscribe(this);
        };
        return RetryWhenSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var SampleSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SampleSubscriber, _super);
        function SampleSubscriber() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.hasValue = false;
            return _this;
        }
        SampleSubscriber.prototype._next = function (value) {
            this.value = value;
            this.hasValue = true;
        };
        SampleSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.emitValue();
        };
        SampleSubscriber.prototype.notifyComplete = function () {
            this.emitValue();
        };
        SampleSubscriber.prototype.emitValue = function () {
            if (this.hasValue) {
                this.hasValue = false;
                this.destination.next(this.value);
            }
        };
        return SampleSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber,_scheduler_async PURE_IMPORTS_END */
    var SampleTimeSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SampleTimeSubscriber, _super);
        function SampleTimeSubscriber(destination, period, scheduler) {
            var _this = _super.call(this, destination) || this;
            _this.period = period;
            _this.scheduler = scheduler;
            _this.hasValue = false;
            _this.add(scheduler.schedule(dispatchNotification, period, { subscriber: _this, period: period }));
            return _this;
        }
        SampleTimeSubscriber.prototype._next = function (value) {
            this.lastValue = value;
            this.hasValue = true;
        };
        SampleTimeSubscriber.prototype.notifyNext = function () {
            if (this.hasValue) {
                this.hasValue = false;
                this.destination.next(this.lastValue);
            }
        };
        return SampleTimeSubscriber;
    }(Subscriber));
    function dispatchNotification(state) {
        var subscriber = state.subscriber, period = state.period;
        subscriber.notifyNext();
        this.schedule(state, period);
    }

    /** PURE_IMPORTS_START tslib,_Subscriber,_util_tryCatch,_util_errorObject PURE_IMPORTS_END */
    var SequenceEqualSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SequenceEqualSubscriber, _super);
        function SequenceEqualSubscriber(destination, compareTo, comparor) {
            var _this = _super.call(this, destination) || this;
            _this.compareTo = compareTo;
            _this.comparor = comparor;
            _this._a = [];
            _this._b = [];
            _this._oneComplete = false;
            _this.add(compareTo.subscribe(new SequenceEqualCompareToSubscriber(destination, _this)));
            return _this;
        }
        SequenceEqualSubscriber.prototype._next = function (value) {
            if (this._oneComplete && this._b.length === 0) {
                this.emit(false);
            }
            else {
                this._a.push(value);
                this.checkValues();
            }
        };
        SequenceEqualSubscriber.prototype._complete = function () {
            if (this._oneComplete) {
                this.emit(this._a.length === 0 && this._b.length === 0);
            }
            else {
                this._oneComplete = true;
            }
        };
        SequenceEqualSubscriber.prototype.checkValues = function () {
            var _c = this, _a = _c._a, _b = _c._b, comparor = _c.comparor;
            while (_a.length > 0 && _b.length > 0) {
                var a = _a.shift();
                var b = _b.shift();
                var areEqual = false;
                if (comparor) {
                    areEqual = tryCatch(comparor)(a, b);
                    if (areEqual === errorObject) {
                        this.destination.error(errorObject.e);
                    }
                }
                else {
                    areEqual = a === b;
                }
                if (!areEqual) {
                    this.emit(false);
                }
            }
        };
        SequenceEqualSubscriber.prototype.emit = function (value) {
            var destination = this.destination;
            destination.next(value);
            destination.complete();
        };
        SequenceEqualSubscriber.prototype.nextB = function (value) {
            if (this._oneComplete && this._a.length === 0) {
                this.emit(false);
            }
            else {
                this._b.push(value);
                this.checkValues();
            }
        };
        return SequenceEqualSubscriber;
    }(Subscriber));
    var SequenceEqualCompareToSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SequenceEqualCompareToSubscriber, _super);
        function SequenceEqualCompareToSubscriber(destination, parent) {
            var _this = _super.call(this, destination) || this;
            _this.parent = parent;
            return _this;
        }
        SequenceEqualCompareToSubscriber.prototype._next = function (value) {
            this.parent.nextB(value);
        };
        SequenceEqualCompareToSubscriber.prototype._error = function (err) {
            this.parent.error(err);
        };
        SequenceEqualCompareToSubscriber.prototype._complete = function () {
            this.parent._complete();
        };
        return SequenceEqualCompareToSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START _multicast,_refCount,_Subject PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _ReplaySubject PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib,_Subscriber,_util_EmptyError PURE_IMPORTS_END */
    var SingleSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SingleSubscriber, _super);
        function SingleSubscriber(destination, predicate, source) {
            var _this = _super.call(this, destination) || this;
            _this.predicate = predicate;
            _this.source = source;
            _this.seenValue = false;
            _this.index = 0;
            return _this;
        }
        SingleSubscriber.prototype.applySingleValue = function (value) {
            if (this.seenValue) {
                this.destination.error('Sequence contains more than one element');
            }
            else {
                this.seenValue = true;
                this.singleValue = value;
            }
        };
        SingleSubscriber.prototype._next = function (value) {
            var index = this.index++;
            if (this.predicate) {
                this.tryNext(value, index);
            }
            else {
                this.applySingleValue(value);
            }
        };
        SingleSubscriber.prototype.tryNext = function (value, index) {
            try {
                if (this.predicate(value, index, this.source)) {
                    this.applySingleValue(value);
                }
            }
            catch (err) {
                this.destination.error(err);
            }
        };
        SingleSubscriber.prototype._complete = function () {
            var destination = this.destination;
            if (this.index > 0) {
                destination.next(this.seenValue ? this.singleValue : undefined);
                destination.complete();
            }
            else {
                destination.error(new EmptyError);
            }
        };
        return SingleSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    var SkipSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SkipSubscriber, _super);
        function SkipSubscriber(destination, total) {
            var _this = _super.call(this, destination) || this;
            _this.total = total;
            _this.count = 0;
            return _this;
        }
        SkipSubscriber.prototype._next = function (x) {
            if (++this.count > this.total) {
                this.destination.next(x);
            }
        };
        return SkipSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber,_util_ArgumentOutOfRangeError PURE_IMPORTS_END */
    var SkipLastSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SkipLastSubscriber, _super);
        function SkipLastSubscriber(destination, _skipCount) {
            var _this = _super.call(this, destination) || this;
            _this._skipCount = _skipCount;
            _this._count = 0;
            _this._ring = new Array(_skipCount);
            return _this;
        }
        SkipLastSubscriber.prototype._next = function (value) {
            var skipCount = this._skipCount;
            var count = this._count++;
            if (count < skipCount) {
                this._ring[count] = value;
            }
            else {
                var currentIndex = count % skipCount;
                var ring = this._ring;
                var oldValue = ring[currentIndex];
                ring[currentIndex] = value;
                this.destination.next(oldValue);
            }
        };
        return SkipLastSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var SkipUntilSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SkipUntilSubscriber, _super);
        function SkipUntilSubscriber(destination, notifier) {
            var _this = _super.call(this, destination) || this;
            _this.hasValue = false;
            _this.add(_this.innerSubscription = subscribeToResult(_this, notifier));
            return _this;
        }
        SkipUntilSubscriber.prototype._next = function (value) {
            if (this.hasValue) {
                _super.prototype._next.call(this, value);
            }
        };
        SkipUntilSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.hasValue = true;
            if (this.innerSubscription) {
                this.innerSubscription.unsubscribe();
            }
        };
        SkipUntilSubscriber.prototype.notifyComplete = function () {
        };
        return SkipUntilSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    var SkipWhileSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SkipWhileSubscriber, _super);
        function SkipWhileSubscriber(destination, predicate) {
            var _this = _super.call(this, destination) || this;
            _this.predicate = predicate;
            _this.skipping = true;
            _this.index = 0;
            return _this;
        }
        SkipWhileSubscriber.prototype._next = function (value) {
            var destination = this.destination;
            if (this.skipping) {
                this.tryCallPredicate(value);
            }
            if (!this.skipping) {
                destination.next(value);
            }
        };
        SkipWhileSubscriber.prototype.tryCallPredicate = function (value) {
            try {
                var result = this.predicate(value, this.index++);
                this.skipping = Boolean(result);
            }
            catch (err) {
                this.destination.error(err);
            }
        };
        return SkipWhileSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START _observable_fromArray,_observable_scalar,_observable_empty,_observable_concat,_util_isScheduler PURE_IMPORTS_END */
    function startWith() {
        var array = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            array[_i] = arguments[_i];
        }
        return function (source) {
            var scheduler = array[array.length - 1];
            if (isScheduler(scheduler)) {
                array.pop();
            }
            else {
                scheduler = null;
            }
            var len = array.length;
            if (len === 1 && !scheduler) {
                return concat(scalar(array[0]), source);
            }
            else if (len > 0) {
                return concat(fromArray(array, scheduler), source);
            }
            else {
                return concat(empty$1(scheduler), source);
            }
        };
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var nextHandle = 1;
    var tasksByHandle = {};
    function runIfPresent(handle) {
        var cb = tasksByHandle[handle];
        if (cb) {
            cb();
        }
    }
    var Immediate = {
        setImmediate: function (cb) {
            var handle = nextHandle++;
            tasksByHandle[handle] = cb;
            Promise.resolve().then(function () { return runIfPresent(handle); });
            return handle;
        },
        clearImmediate: function (handle) {
            delete tasksByHandle[handle];
        },
    };

    /** PURE_IMPORTS_START tslib,_util_Immediate,_AsyncAction PURE_IMPORTS_END */
    var AsapAction = /*@__PURE__*/ (function (_super) {
        __extends(AsapAction, _super);
        function AsapAction(scheduler, work) {
            var _this = _super.call(this, scheduler, work) || this;
            _this.scheduler = scheduler;
            _this.work = work;
            return _this;
        }
        AsapAction.prototype.requestAsyncId = function (scheduler, id, delay) {
            if (delay === void 0) {
                delay = 0;
            }
            if (delay !== null && delay > 0) {
                return _super.prototype.requestAsyncId.call(this, scheduler, id, delay);
            }
            scheduler.actions.push(this);
            return scheduler.scheduled || (scheduler.scheduled = Immediate.setImmediate(scheduler.flush.bind(scheduler, null)));
        };
        AsapAction.prototype.recycleAsyncId = function (scheduler, id, delay) {
            if (delay === void 0) {
                delay = 0;
            }
            if ((delay !== null && delay > 0) || (delay === null && this.delay > 0)) {
                return _super.prototype.recycleAsyncId.call(this, scheduler, id, delay);
            }
            if (scheduler.actions.length === 0) {
                Immediate.clearImmediate(id);
                scheduler.scheduled = undefined;
            }
            return undefined;
        };
        return AsapAction;
    }(AsyncAction));

    /** PURE_IMPORTS_START tslib,_AsyncScheduler PURE_IMPORTS_END */
    var AsapScheduler = /*@__PURE__*/ (function (_super) {
        __extends(AsapScheduler, _super);
        function AsapScheduler() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AsapScheduler.prototype.flush = function (action) {
            this.active = true;
            this.scheduled = undefined;
            var actions = this.actions;
            var error;
            var index = -1;
            var count = actions.length;
            action = action || actions.shift();
            do {
                if (error = action.execute(action.state, action.delay)) {
                    break;
                }
            } while (++index < count && (action = actions.shift()));
            this.active = false;
            if (error) {
                while (++index < count && (action = actions.shift())) {
                    action.unsubscribe();
                }
                throw error;
            }
        };
        return AsapScheduler;
    }(AsyncScheduler));

    /** PURE_IMPORTS_START _AsapAction,_AsapScheduler PURE_IMPORTS_END */
    var asap = /*@__PURE__*/ new AsapScheduler(AsapAction);

    /** PURE_IMPORTS_START tslib,_Observable,_scheduler_asap,_util_isNumeric PURE_IMPORTS_END */
    var SubscribeOnObservable = /*@__PURE__*/ (function (_super) {
        __extends(SubscribeOnObservable, _super);
        function SubscribeOnObservable(source, delayTime, scheduler) {
            if (delayTime === void 0) {
                delayTime = 0;
            }
            if (scheduler === void 0) {
                scheduler = asap;
            }
            var _this = _super.call(this) || this;
            _this.source = source;
            _this.delayTime = delayTime;
            _this.scheduler = scheduler;
            if (!isNumeric(delayTime) || delayTime < 0) {
                _this.delayTime = 0;
            }
            if (!scheduler || typeof scheduler.schedule !== 'function') {
                _this.scheduler = asap;
            }
            return _this;
        }
        SubscribeOnObservable.create = function (source, delay, scheduler) {
            if (delay === void 0) {
                delay = 0;
            }
            if (scheduler === void 0) {
                scheduler = asap;
            }
            return new SubscribeOnObservable(source, delay, scheduler);
        };
        SubscribeOnObservable.dispatch = function (arg) {
            var source = arg.source, subscriber = arg.subscriber;
            return this.add(source.subscribe(subscriber));
        };
        SubscribeOnObservable.prototype._subscribe = function (subscriber) {
            var delay = this.delayTime;
            var source = this.source;
            var scheduler = this.scheduler;
            return scheduler.schedule(SubscribeOnObservable.dispatch, delay, {
                source: source, subscriber: subscriber
            });
        };
        return SubscribeOnObservable;
    }(Observable));

    /** PURE_IMPORTS_START _observable_SubscribeOnObservable PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib,_OuterSubscriber,_util_subscribeToResult,_map,_observable_from PURE_IMPORTS_END */
    function switchMap(project, resultSelector) {
        if (typeof resultSelector === 'function') {
            return function (source) { return source.pipe(switchMap(function (a, i) { return from(project(a, i)).pipe(map(function (b, ii) { return resultSelector(a, b, i, ii); })); })); };
        }
        return function (source) { return source.lift(new SwitchMapOperator(project)); };
    }
    var SwitchMapOperator = /*@__PURE__*/ (function () {
        function SwitchMapOperator(project) {
            this.project = project;
        }
        SwitchMapOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new SwitchMapSubscriber(subscriber, this.project));
        };
        return SwitchMapOperator;
    }());
    var SwitchMapSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SwitchMapSubscriber, _super);
        function SwitchMapSubscriber(destination, project) {
            var _this = _super.call(this, destination) || this;
            _this.project = project;
            _this.index = 0;
            return _this;
        }
        SwitchMapSubscriber.prototype._next = function (value) {
            var result;
            var index = this.index++;
            try {
                result = this.project(value, index);
            }
            catch (error) {
                this.destination.error(error);
                return;
            }
            this._innerSub(result, value, index);
        };
        SwitchMapSubscriber.prototype._innerSub = function (result, value, index) {
            var innerSubscription = this.innerSubscription;
            if (innerSubscription) {
                innerSubscription.unsubscribe();
            }
            this.add(this.innerSubscription = subscribeToResult(this, result, value, index));
        };
        SwitchMapSubscriber.prototype._complete = function () {
            var innerSubscription = this.innerSubscription;
            if (!innerSubscription || innerSubscription.closed) {
                _super.prototype._complete.call(this);
            }
        };
        SwitchMapSubscriber.prototype._unsubscribe = function () {
            this.innerSubscription = null;
        };
        SwitchMapSubscriber.prototype.notifyComplete = function (innerSub) {
            this.remove(innerSub);
            this.innerSubscription = null;
            if (this.isStopped) {
                _super.prototype._complete.call(this);
            }
        };
        SwitchMapSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.destination.next(innerValue);
        };
        return SwitchMapSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START _switchMap,_util_identity PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _switchMap PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var TakeUntilSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(TakeUntilSubscriber, _super);
        function TakeUntilSubscriber(destination) {
            return _super.call(this, destination) || this;
        }
        TakeUntilSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.complete();
        };
        TakeUntilSubscriber.prototype.notifyComplete = function () {
        };
        return TakeUntilSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    var TakeWhileSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(TakeWhileSubscriber, _super);
        function TakeWhileSubscriber(destination, predicate) {
            var _this = _super.call(this, destination) || this;
            _this.predicate = predicate;
            _this.index = 0;
            return _this;
        }
        TakeWhileSubscriber.prototype._next = function (value) {
            var destination = this.destination;
            var result;
            try {
                result = this.predicate(value, this.index++);
            }
            catch (err) {
                destination.error(err);
                return;
            }
            this.nextOrComplete(value, result);
        };
        TakeWhileSubscriber.prototype.nextOrComplete = function (value, predicateResult) {
            var destination = this.destination;
            if (Boolean(predicateResult)) {
                destination.next(value);
            }
            else {
                destination.complete();
            }
        };
        return TakeWhileSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var ThrottleSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(ThrottleSubscriber, _super);
        function ThrottleSubscriber(destination, durationSelector, _leading, _trailing) {
            var _this = _super.call(this, destination) || this;
            _this.destination = destination;
            _this.durationSelector = durationSelector;
            _this._leading = _leading;
            _this._trailing = _trailing;
            _this._hasValue = false;
            return _this;
        }
        ThrottleSubscriber.prototype._next = function (value) {
            this._hasValue = true;
            this._sendValue = value;
            if (!this._throttled) {
                if (this._leading) {
                    this.send();
                }
                else {
                    this.throttle(value);
                }
            }
        };
        ThrottleSubscriber.prototype.send = function () {
            var _a = this, _hasValue = _a._hasValue, _sendValue = _a._sendValue;
            if (_hasValue) {
                this.destination.next(_sendValue);
                this.throttle(_sendValue);
            }
            this._hasValue = false;
            this._sendValue = null;
        };
        ThrottleSubscriber.prototype.throttle = function (value) {
            var duration = this.tryDurationSelector(value);
            if (duration) {
                this.add(this._throttled = subscribeToResult(this, duration));
            }
        };
        ThrottleSubscriber.prototype.tryDurationSelector = function (value) {
            try {
                return this.durationSelector(value);
            }
            catch (err) {
                this.destination.error(err);
                return null;
            }
        };
        ThrottleSubscriber.prototype.throttlingDone = function () {
            var _a = this, _throttled = _a._throttled, _trailing = _a._trailing;
            if (_throttled) {
                _throttled.unsubscribe();
            }
            this._throttled = null;
            if (_trailing) {
                this.send();
            }
        };
        ThrottleSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.throttlingDone();
        };
        ThrottleSubscriber.prototype.notifyComplete = function () {
            this.throttlingDone();
        };
        return ThrottleSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber,_scheduler_async,_throttle PURE_IMPORTS_END */
    var ThrottleTimeSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(ThrottleTimeSubscriber, _super);
        function ThrottleTimeSubscriber(destination, duration, scheduler, leading, trailing) {
            var _this = _super.call(this, destination) || this;
            _this.duration = duration;
            _this.scheduler = scheduler;
            _this.leading = leading;
            _this.trailing = trailing;
            _this._hasTrailingValue = false;
            _this._trailingValue = null;
            return _this;
        }
        ThrottleTimeSubscriber.prototype._next = function (value) {
            if (this.throttled) {
                if (this.trailing) {
                    this._trailingValue = value;
                    this._hasTrailingValue = true;
                }
            }
            else {
                this.add(this.throttled = this.scheduler.schedule(dispatchNext$1, this.duration, { subscriber: this }));
                if (this.leading) {
                    this.destination.next(value);
                }
            }
        };
        ThrottleTimeSubscriber.prototype._complete = function () {
            if (this._hasTrailingValue) {
                this.destination.next(this._trailingValue);
                this.destination.complete();
            }
            else {
                this.destination.complete();
            }
        };
        ThrottleTimeSubscriber.prototype.clearThrottle = function () {
            var throttled = this.throttled;
            if (throttled) {
                if (this.trailing && this._hasTrailingValue) {
                    this.destination.next(this._trailingValue);
                    this._trailingValue = null;
                    this._hasTrailingValue = false;
                }
                throttled.unsubscribe();
                this.remove(throttled);
                this.throttled = null;
            }
        };
        return ThrottleTimeSubscriber;
    }(Subscriber));
    function dispatchNext$1(arg) {
        var subscriber = arg.subscriber;
        subscriber.clearThrottle();
    }

    /** PURE_IMPORTS_START _Observable,_from,_empty PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _scheduler_async,_scan,_observable_defer,_map PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib PURE_IMPORTS_END */
    var TimeoutError = /*@__PURE__*/ (function (_super) {
        __extends(TimeoutError, _super);
        function TimeoutError() {
            var _this = _super.call(this, 'Timeout has occurred') || this;
            _this.name = 'TimeoutError';
            Object.setPrototypeOf(_this, TimeoutError.prototype);
            return _this;
        }
        return TimeoutError;
    }(Error));

    /** PURE_IMPORTS_START tslib,_scheduler_async,_util_isDate,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var TimeoutWithSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(TimeoutWithSubscriber, _super);
        function TimeoutWithSubscriber(destination, absoluteTimeout, waitFor, withObservable, scheduler) {
            var _this = _super.call(this, destination) || this;
            _this.absoluteTimeout = absoluteTimeout;
            _this.waitFor = waitFor;
            _this.withObservable = withObservable;
            _this.scheduler = scheduler;
            _this.action = null;
            _this.scheduleTimeout();
            return _this;
        }
        TimeoutWithSubscriber.dispatchTimeout = function (subscriber) {
            var withObservable = subscriber.withObservable;
            subscriber._unsubscribeAndRecycle();
            subscriber.add(subscribeToResult(subscriber, withObservable));
        };
        TimeoutWithSubscriber.prototype.scheduleTimeout = function () {
            var action = this.action;
            if (action) {
                this.action = action.schedule(this, this.waitFor);
            }
            else {
                this.add(this.action = this.scheduler.schedule(TimeoutWithSubscriber.dispatchTimeout, this.waitFor, this));
            }
        };
        TimeoutWithSubscriber.prototype._next = function (value) {
            if (!this.absoluteTimeout) {
                this.scheduleTimeout();
            }
            _super.prototype._next.call(this, value);
        };
        TimeoutWithSubscriber.prototype._unsubscribe = function () {
            this.action = null;
            this.scheduler = null;
            this.withObservable = null;
        };
        return TimeoutWithSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START _scheduler_async,_util_TimeoutError,_timeoutWith,_observable_throwError PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _scheduler_async,_map PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _reduce PURE_IMPORTS_END */

    /** PURE_IMPORTS_START tslib,_Subject,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var WindowSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(WindowSubscriber, _super);
        function WindowSubscriber(destination) {
            var _this = _super.call(this, destination) || this;
            _this.window = new Subject();
            destination.next(_this.window);
            return _this;
        }
        WindowSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.openWindow();
        };
        WindowSubscriber.prototype.notifyError = function (error, innerSub) {
            this._error(error);
        };
        WindowSubscriber.prototype.notifyComplete = function (innerSub) {
            this._complete();
        };
        WindowSubscriber.prototype._next = function (value) {
            this.window.next(value);
        };
        WindowSubscriber.prototype._error = function (err) {
            this.window.error(err);
            this.destination.error(err);
        };
        WindowSubscriber.prototype._complete = function () {
            this.window.complete();
            this.destination.complete();
        };
        WindowSubscriber.prototype._unsubscribe = function () {
            this.window = null;
        };
        WindowSubscriber.prototype.openWindow = function () {
            var prevWindow = this.window;
            if (prevWindow) {
                prevWindow.complete();
            }
            var destination = this.destination;
            var newWindow = this.window = new Subject();
            destination.next(newWindow);
        };
        return WindowSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_Subscriber,_Subject PURE_IMPORTS_END */
    var WindowCountSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(WindowCountSubscriber, _super);
        function WindowCountSubscriber(destination, windowSize, startWindowEvery) {
            var _this = _super.call(this, destination) || this;
            _this.destination = destination;
            _this.windowSize = windowSize;
            _this.startWindowEvery = startWindowEvery;
            _this.windows = [new Subject()];
            _this.count = 0;
            destination.next(_this.windows[0]);
            return _this;
        }
        WindowCountSubscriber.prototype._next = function (value) {
            var startWindowEvery = (this.startWindowEvery > 0) ? this.startWindowEvery : this.windowSize;
            var destination = this.destination;
            var windowSize = this.windowSize;
            var windows = this.windows;
            var len = windows.length;
            for (var i = 0; i < len && !this.closed; i++) {
                windows[i].next(value);
            }
            var c = this.count - windowSize + 1;
            if (c >= 0 && c % startWindowEvery === 0 && !this.closed) {
                windows.shift().complete();
            }
            if (++this.count % startWindowEvery === 0 && !this.closed) {
                var window_1 = new Subject();
                windows.push(window_1);
                destination.next(window_1);
            }
        };
        WindowCountSubscriber.prototype._error = function (err) {
            var windows = this.windows;
            if (windows) {
                while (windows.length > 0 && !this.closed) {
                    windows.shift().error(err);
                }
            }
            this.destination.error(err);
        };
        WindowCountSubscriber.prototype._complete = function () {
            var windows = this.windows;
            if (windows) {
                while (windows.length > 0 && !this.closed) {
                    windows.shift().complete();
                }
            }
            this.destination.complete();
        };
        WindowCountSubscriber.prototype._unsubscribe = function () {
            this.count = 0;
            this.windows = null;
        };
        return WindowCountSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_Subject,_scheduler_async,_Subscriber,_util_isNumeric,_util_isScheduler PURE_IMPORTS_END */
    var CountedSubject = /*@__PURE__*/ (function (_super) {
        __extends(CountedSubject, _super);
        function CountedSubject() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._numberOfNextedValues = 0;
            return _this;
        }
        CountedSubject.prototype.next = function (value) {
            this._numberOfNextedValues++;
            _super.prototype.next.call(this, value);
        };
        Object.defineProperty(CountedSubject.prototype, "numberOfNextedValues", {
            get: function () {
                return this._numberOfNextedValues;
            },
            enumerable: true,
            configurable: true
        });
        return CountedSubject;
    }(Subject));
    var WindowTimeSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(WindowTimeSubscriber, _super);
        function WindowTimeSubscriber(destination, windowTimeSpan, windowCreationInterval, maxWindowSize, scheduler) {
            var _this = _super.call(this, destination) || this;
            _this.destination = destination;
            _this.windowTimeSpan = windowTimeSpan;
            _this.windowCreationInterval = windowCreationInterval;
            _this.maxWindowSize = maxWindowSize;
            _this.scheduler = scheduler;
            _this.windows = [];
            var window = _this.openWindow();
            if (windowCreationInterval !== null && windowCreationInterval >= 0) {
                var closeState = { subscriber: _this, window: window, context: null };
                var creationState = { windowTimeSpan: windowTimeSpan, windowCreationInterval: windowCreationInterval, subscriber: _this, scheduler: scheduler };
                _this.add(scheduler.schedule(dispatchWindowClose, windowTimeSpan, closeState));
                _this.add(scheduler.schedule(dispatchWindowCreation, windowCreationInterval, creationState));
            }
            else {
                var timeSpanOnlyState = { subscriber: _this, window: window, windowTimeSpan: windowTimeSpan };
                _this.add(scheduler.schedule(dispatchWindowTimeSpanOnly, windowTimeSpan, timeSpanOnlyState));
            }
            return _this;
        }
        WindowTimeSubscriber.prototype._next = function (value) {
            var windows = this.windows;
            var len = windows.length;
            for (var i = 0; i < len; i++) {
                var window_1 = windows[i];
                if (!window_1.closed) {
                    window_1.next(value);
                    if (window_1.numberOfNextedValues >= this.maxWindowSize) {
                        this.closeWindow(window_1);
                    }
                }
            }
        };
        WindowTimeSubscriber.prototype._error = function (err) {
            var windows = this.windows;
            while (windows.length > 0) {
                windows.shift().error(err);
            }
            this.destination.error(err);
        };
        WindowTimeSubscriber.prototype._complete = function () {
            var windows = this.windows;
            while (windows.length > 0) {
                var window_2 = windows.shift();
                if (!window_2.closed) {
                    window_2.complete();
                }
            }
            this.destination.complete();
        };
        WindowTimeSubscriber.prototype.openWindow = function () {
            var window = new CountedSubject();
            this.windows.push(window);
            var destination = this.destination;
            destination.next(window);
            return window;
        };
        WindowTimeSubscriber.prototype.closeWindow = function (window) {
            window.complete();
            var windows = this.windows;
            windows.splice(windows.indexOf(window), 1);
        };
        return WindowTimeSubscriber;
    }(Subscriber));
    function dispatchWindowTimeSpanOnly(state) {
        var subscriber = state.subscriber, windowTimeSpan = state.windowTimeSpan, window = state.window;
        if (window) {
            subscriber.closeWindow(window);
        }
        state.window = subscriber.openWindow();
        this.schedule(state, windowTimeSpan);
    }
    function dispatchWindowCreation(state) {
        var windowTimeSpan = state.windowTimeSpan, subscriber = state.subscriber, scheduler = state.scheduler, windowCreationInterval = state.windowCreationInterval;
        var window = subscriber.openWindow();
        var action = this;
        var context = { action: action, subscription: null };
        var timeSpanState = { subscriber: subscriber, window: window, context: context };
        context.subscription = scheduler.schedule(dispatchWindowClose, windowTimeSpan, timeSpanState);
        action.add(context.subscription);
        action.schedule(state, windowCreationInterval);
    }
    function dispatchWindowClose(state) {
        var subscriber = state.subscriber, window = state.window, context = state.context;
        if (context && context.action && context.subscription) {
            context.action.remove(context.subscription);
        }
        subscriber.closeWindow(window);
    }

    /** PURE_IMPORTS_START tslib,_Subject,_Subscription,_util_tryCatch,_util_errorObject,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var WindowToggleSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(WindowToggleSubscriber, _super);
        function WindowToggleSubscriber(destination, openings, closingSelector) {
            var _this = _super.call(this, destination) || this;
            _this.openings = openings;
            _this.closingSelector = closingSelector;
            _this.contexts = [];
            _this.add(_this.openSubscription = subscribeToResult(_this, openings, openings));
            return _this;
        }
        WindowToggleSubscriber.prototype._next = function (value) {
            var contexts = this.contexts;
            if (contexts) {
                var len = contexts.length;
                for (var i = 0; i < len; i++) {
                    contexts[i].window.next(value);
                }
            }
        };
        WindowToggleSubscriber.prototype._error = function (err) {
            var contexts = this.contexts;
            this.contexts = null;
            if (contexts) {
                var len = contexts.length;
                var index = -1;
                while (++index < len) {
                    var context_1 = contexts[index];
                    context_1.window.error(err);
                    context_1.subscription.unsubscribe();
                }
            }
            _super.prototype._error.call(this, err);
        };
        WindowToggleSubscriber.prototype._complete = function () {
            var contexts = this.contexts;
            this.contexts = null;
            if (contexts) {
                var len = contexts.length;
                var index = -1;
                while (++index < len) {
                    var context_2 = contexts[index];
                    context_2.window.complete();
                    context_2.subscription.unsubscribe();
                }
            }
            _super.prototype._complete.call(this);
        };
        WindowToggleSubscriber.prototype._unsubscribe = function () {
            var contexts = this.contexts;
            this.contexts = null;
            if (contexts) {
                var len = contexts.length;
                var index = -1;
                while (++index < len) {
                    var context_3 = contexts[index];
                    context_3.window.unsubscribe();
                    context_3.subscription.unsubscribe();
                }
            }
        };
        WindowToggleSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            if (outerValue === this.openings) {
                var closingSelector = this.closingSelector;
                var closingNotifier = tryCatch(closingSelector)(innerValue);
                if (closingNotifier === errorObject) {
                    return this.error(errorObject.e);
                }
                else {
                    var window_1 = new Subject();
                    var subscription = new Subscription();
                    var context_4 = { window: window_1, subscription: subscription };
                    this.contexts.push(context_4);
                    var innerSubscription = subscribeToResult(this, closingNotifier, context_4);
                    if (innerSubscription.closed) {
                        this.closeWindow(this.contexts.length - 1);
                    }
                    else {
                        innerSubscription.context = context_4;
                        subscription.add(innerSubscription);
                    }
                    this.destination.next(window_1);
                }
            }
            else {
                this.closeWindow(this.contexts.indexOf(outerValue));
            }
        };
        WindowToggleSubscriber.prototype.notifyError = function (err) {
            this.error(err);
        };
        WindowToggleSubscriber.prototype.notifyComplete = function (inner) {
            if (inner !== this.openSubscription) {
                this.closeWindow(this.contexts.indexOf(inner.context));
            }
        };
        WindowToggleSubscriber.prototype.closeWindow = function (index) {
            if (index === -1) {
                return;
            }
            var contexts = this.contexts;
            var context = contexts[index];
            var window = context.window, subscription = context.subscription;
            contexts.splice(index, 1);
            window.complete();
            subscription.unsubscribe();
        };
        return WindowToggleSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_Subject,_util_tryCatch,_util_errorObject,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var WindowSubscriber$1 = /*@__PURE__*/ (function (_super) {
        __extends(WindowSubscriber, _super);
        function WindowSubscriber(destination, closingSelector) {
            var _this = _super.call(this, destination) || this;
            _this.destination = destination;
            _this.closingSelector = closingSelector;
            _this.openWindow();
            return _this;
        }
        WindowSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.openWindow(innerSub);
        };
        WindowSubscriber.prototype.notifyError = function (error, innerSub) {
            this._error(error);
        };
        WindowSubscriber.prototype.notifyComplete = function (innerSub) {
            this.openWindow(innerSub);
        };
        WindowSubscriber.prototype._next = function (value) {
            this.window.next(value);
        };
        WindowSubscriber.prototype._error = function (err) {
            this.window.error(err);
            this.destination.error(err);
            this.unsubscribeClosingNotification();
        };
        WindowSubscriber.prototype._complete = function () {
            this.window.complete();
            this.destination.complete();
            this.unsubscribeClosingNotification();
        };
        WindowSubscriber.prototype.unsubscribeClosingNotification = function () {
            if (this.closingNotification) {
                this.closingNotification.unsubscribe();
            }
        };
        WindowSubscriber.prototype.openWindow = function (innerSub) {
            if (innerSub === void 0) {
                innerSub = null;
            }
            if (innerSub) {
                this.remove(innerSub);
                innerSub.unsubscribe();
            }
            var prevWindow = this.window;
            if (prevWindow) {
                prevWindow.complete();
            }
            var window = this.window = new Subject();
            this.destination.next(window);
            var closingNotifier = tryCatch(this.closingSelector)();
            if (closingNotifier === errorObject) {
                var err = errorObject.e;
                this.destination.error(err);
                this.window.error(err);
            }
            else {
                this.add(this.closingNotification = subscribeToResult(this, closingNotifier));
            }
        };
        return WindowSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
    var WithLatestFromSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(WithLatestFromSubscriber, _super);
        function WithLatestFromSubscriber(destination, observables, project) {
            var _this = _super.call(this, destination) || this;
            _this.observables = observables;
            _this.project = project;
            _this.toRespond = [];
            var len = observables.length;
            _this.values = new Array(len);
            for (var i = 0; i < len; i++) {
                _this.toRespond.push(i);
            }
            for (var i = 0; i < len; i++) {
                var observable = observables[i];
                _this.add(subscribeToResult(_this, observable, observable, i));
            }
            return _this;
        }
        WithLatestFromSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.values[outerIndex] = innerValue;
            var toRespond = this.toRespond;
            if (toRespond.length > 0) {
                var found = toRespond.indexOf(outerIndex);
                if (found !== -1) {
                    toRespond.splice(found, 1);
                }
            }
        };
        WithLatestFromSubscriber.prototype.notifyComplete = function () {
        };
        WithLatestFromSubscriber.prototype._next = function (value) {
            if (this.toRespond.length === 0) {
                var args = [value].concat(this.values);
                if (this.project) {
                    this._tryProject(args);
                }
                else {
                    this.destination.next(args);
                }
            }
        };
        WithLatestFromSubscriber.prototype._tryProject = function (args) {
            var result;
            try {
                result = this.project.apply(this, args);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.destination.next(result);
        };
        return WithLatestFromSubscriber;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START tslib,_fromArray,_util_isArray,_Subscriber,_OuterSubscriber,_util_subscribeToResult,_.._internal_symbol_iterator PURE_IMPORTS_END */
    var ZipSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(ZipSubscriber, _super);
        function ZipSubscriber(destination, resultSelector, values) {
            if (values === void 0) {
                values = Object.create(null);
            }
            var _this = _super.call(this, destination) || this;
            _this.iterators = [];
            _this.active = 0;
            _this.resultSelector = (typeof resultSelector === 'function') ? resultSelector : null;
            _this.values = values;
            return _this;
        }
        ZipSubscriber.prototype._next = function (value) {
            var iterators = this.iterators;
            if (isArray(value)) {
                iterators.push(new StaticArrayIterator(value));
            }
            else if (typeof value[iterator] === 'function') {
                iterators.push(new StaticIterator(value[iterator]()));
            }
            else {
                iterators.push(new ZipBufferIterator(this.destination, this, value));
            }
        };
        ZipSubscriber.prototype._complete = function () {
            var iterators = this.iterators;
            var len = iterators.length;
            if (len === 0) {
                this.destination.complete();
                return;
            }
            this.active = len;
            for (var i = 0; i < len; i++) {
                var iterator$$1 = iterators[i];
                if (iterator$$1.stillUnsubscribed) {
                    this.add(iterator$$1.subscribe(iterator$$1, i));
                }
                else {
                    this.active--;
                }
            }
        };
        ZipSubscriber.prototype.notifyInactive = function () {
            this.active--;
            if (this.active === 0) {
                this.destination.complete();
            }
        };
        ZipSubscriber.prototype.checkIterators = function () {
            var iterators = this.iterators;
            var len = iterators.length;
            var destination = this.destination;
            for (var i = 0; i < len; i++) {
                var iterator$$1 = iterators[i];
                if (typeof iterator$$1.hasValue === 'function' && !iterator$$1.hasValue()) {
                    return;
                }
            }
            var shouldComplete = false;
            var args = [];
            for (var i = 0; i < len; i++) {
                var iterator$$1 = iterators[i];
                var result = iterator$$1.next();
                if (iterator$$1.hasCompleted()) {
                    shouldComplete = true;
                }
                if (result.done) {
                    destination.complete();
                    return;
                }
                args.push(result.value);
            }
            if (this.resultSelector) {
                this._tryresultSelector(args);
            }
            else {
                destination.next(args);
            }
            if (shouldComplete) {
                destination.complete();
            }
        };
        ZipSubscriber.prototype._tryresultSelector = function (args) {
            var result;
            try {
                result = this.resultSelector.apply(this, args);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.destination.next(result);
        };
        return ZipSubscriber;
    }(Subscriber));
    var StaticIterator = /*@__PURE__*/ (function () {
        function StaticIterator(iterator$$1) {
            this.iterator = iterator$$1;
            this.nextResult = iterator$$1.next();
        }
        StaticIterator.prototype.hasValue = function () {
            return true;
        };
        StaticIterator.prototype.next = function () {
            var result = this.nextResult;
            this.nextResult = this.iterator.next();
            return result;
        };
        StaticIterator.prototype.hasCompleted = function () {
            var nextResult = this.nextResult;
            return nextResult && nextResult.done;
        };
        return StaticIterator;
    }());
    var StaticArrayIterator = /*@__PURE__*/ (function () {
        function StaticArrayIterator(array) {
            this.array = array;
            this.index = 0;
            this.length = 0;
            this.length = array.length;
        }
        StaticArrayIterator.prototype[iterator] = function () {
            return this;
        };
        StaticArrayIterator.prototype.next = function (value) {
            var i = this.index++;
            var array = this.array;
            return i < this.length ? { value: array[i], done: false } : { value: null, done: true };
        };
        StaticArrayIterator.prototype.hasValue = function () {
            return this.array.length > this.index;
        };
        StaticArrayIterator.prototype.hasCompleted = function () {
            return this.array.length === this.index;
        };
        return StaticArrayIterator;
    }());
    var ZipBufferIterator = /*@__PURE__*/ (function (_super) {
        __extends(ZipBufferIterator, _super);
        function ZipBufferIterator(destination, parent, observable) {
            var _this = _super.call(this, destination) || this;
            _this.parent = parent;
            _this.observable = observable;
            _this.stillUnsubscribed = true;
            _this.buffer = [];
            _this.isComplete = false;
            return _this;
        }
        ZipBufferIterator.prototype[iterator] = function () {
            return this;
        };
        ZipBufferIterator.prototype.next = function () {
            var buffer = this.buffer;
            if (buffer.length === 0 && this.isComplete) {
                return { value: null, done: true };
            }
            else {
                return { value: buffer.shift(), done: false };
            }
        };
        ZipBufferIterator.prototype.hasValue = function () {
            return this.buffer.length > 0;
        };
        ZipBufferIterator.prototype.hasCompleted = function () {
            return this.buffer.length === 0 && this.isComplete;
        };
        ZipBufferIterator.prototype.notifyComplete = function () {
            if (this.buffer.length > 0) {
                this.isComplete = true;
                this.parent.notifyInactive();
            }
            else {
                this.destination.complete();
            }
        };
        ZipBufferIterator.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.buffer.push(innerValue);
            this.parent.checkIterators();
        };
        ZipBufferIterator.prototype.subscribe = function (value, index) {
            return subscribeToResult(this, this.observable, this, index);
        };
        return ZipBufferIterator;
    }(OuterSubscriber));

    /** PURE_IMPORTS_START _observable_zip PURE_IMPORTS_END */

    /** PURE_IMPORTS_START _observable_zip PURE_IMPORTS_END */

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */

    var DynamicTableMouseEventMessageService = /** @class */ (function () {
        function DynamicTableMouseEventMessageService() {
        }
        DynamicTableMouseEventMessageService.prototype.setMouseEvent = function (mouseEvent) {
            this.mouseEvent = mouseEvent;
        };
        DynamicTableMouseEventMessageService.prototype.getMouseEvent = function () {
            return this.mouseEvent;
        };
        DynamicTableMouseEventMessageService.prototype.setItem = function (item) {
            this.item = item;
        };
        DynamicTableMouseEventMessageService.prototype.getItem = function () {
            return this.item;
        };
        DynamicTableMouseEventMessageService.prototype.setPublisher = function (publisher) {
            this.publisher = publisher;
        };
        DynamicTableMouseEventMessageService.prototype.getPubisher = function () {
            return this.publisher;
        };
        DynamicTableMouseEventMessageService = __decorate([
            core.Injectable()
        ], DynamicTableMouseEventMessageService);
        return DynamicTableMouseEventMessageService;
    }());

    var TableInstanceComponent = /** @class */ (function (_super) {
        __extends(TableInstanceComponent, _super);
        function TableInstanceComponent(injector) {
            var _this = _super.call(this) || this;
            _this.filterHint = 'Filter';
            _this.isLoadingResults = true;
            _this.noDataFound = false;
            _this.showFilter = true;
            _this.resultsLength = 0;
            _this.dataSource = new material.MatTableDataSource();
            _this.COLUMN_DEFINITIONS = new DynamicTableColumnDefinitionConstants();
            _this.showSpeedDialLabels = true;
            _this.hideColumns = true;
            _this.palTableDataProvider = injector.get(DynamicTableDataProvider);
            _this.palTableDynamicCellBuilder = injector.get(DynamicTableDynamicCellBuilder);
            _this.actionMessage = injector.get(DynamicTableActionMessageService);
            _this.mouseEventMessage = injector.get(DynamicTableMouseEventMessageService);
            _this.zone = injector.get(core.NgZone);
            _this.changeDetectorRef = injector.get(core.ChangeDetectorRef);
            _this.sanitizer = injector.get(platformBrowser.DomSanitizer);
            _this.columns = _this.palTableDataProvider.getColumns();
            _this.addStandardColumns();
            return _this;
        }
        TableInstanceComponent_1 = TableInstanceComponent;
        TableInstanceComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.displayedColumns = DynamicTableUtils.convertToColumnIds(this.columns);
            var eventPublisher = this.palTableDataProvider.getEventPublisher();
            if (eventPublisher != null) {
                this.subscription = eventPublisher.subscribe(function (data) { return _this.handleDataProviderEvents(data); }, function (error) { return console.error(error); });
            }
            this.load();
            this.actionMessage.setPublisher(this.actionsSubject.asObservable());
            this.mouseEventMessage.setPublisher(this.mouseEventsSubject.asObservable());
        };
        TableInstanceComponent.prototype.ngAfterViewInit = function () {
            this.load();
        };
        TableInstanceComponent.prototype.ngOnDestroy = function () {
            this.changeDetectorRef.detach();
            if (this.subscription != null) {
                this.subscription.unsubscribe();
            }
        };
        TableInstanceComponent.prototype.load = function () {
            var _this = this;
            setTimeout(function () {
                _this.zone.run(function () { return _this.loadData(); });
            }, 300);
        };
        TableInstanceComponent.prototype.addStandardColumns = function () {
            this.columns.unshift({ columns: ['selectedRowColumn'], names: ['selectedRowColumn'], backgroundColor: null });
        };
        TableInstanceComponent.prototype.loadData = function () {
            var _this = this;
            rxjs.merge()
                .pipe(startWith({}), switchMap(function () {
                _this.isLoadingResults = true;
                return _this.palTableDataProvider.getData(_this.sort.active, _this.sort.direction, null);
            }), map(function (items) {
                _this.isLoadingResults = false;
                if (items.length === 0) {
                    _this.noDataFound = true;
                }
                else {
                    _this.noDataFound = false;
                }
                _this.resultsLength = items['length'];
                return items;
            }), catchError(function (error) {
                console.error('Error in loading pal table data', error);
                _this.isLoadingResults = false;
                return rxjs.of([]);
            })).subscribe(function (items) {
                if (_this.hasGroups()) {
                    _this.dataSource.data = items.filter(function (item) {
                        var expression = _this.buildGroupExpressions();
                        return expression(item);
                    });
                    _this.isLoadingResults = false;
                }
                else {
                    _this.dataSource.data = items;
                    _this.isLoadingResults = false;
                }
                _this.changeDetectorRef.detectChanges();
            });
        };
        TableInstanceComponent.prototype.buildGroupExpressions = function () {
            var queryString = 'return ';
            for (var i = 0; i < this.groupExpressions.length; i++) {
                var groupExpression = this.groupExpressions[i];
                queryString += this.buildGroupExpression(groupExpression);
                if (this.groupExpressions.length > 0 && ((i + 1) !== this.groupExpressions.length)) {
                    queryString += ' ' + groupExpression.operator + ' ';
                }
            }
            return new Function('item', queryString);
        };
        TableInstanceComponent.prototype.buildGroupExpression = function (groupExpression) {
            var queryString = '';
            var group = groupExpression.group;
            var rules = group.rules;
            queryString += '(';
            for (var _i = 0, rules_1 = rules; _i < rules_1.length; _i++) {
                var rule = rules_1[_i];
                var operator = rule['operator'];
                var value = rule['value'];
                switch (operator) {
                    case '&&':
                        queryString += ' && ';
                        break;
                    case '||':
                        queryString += ' || ';
                        break;
                    case '!=':
                        queryString += 'item["' + group.groupByField + '"]' + ' != ' + value;
                        break;
                    case '<':
                        queryString += 'item["' + group.groupByField + '"]' + ' < ' + value;
                        break;
                    case '<=':
                        queryString += 'item["' + group.groupByField + '"]' + ' <= ' + value;
                        break;
                    case '>':
                        queryString += 'item["' + group.groupByField + '"]' + ' > ' + value;
                        break;
                    case '>=':
                        queryString += 'item["' + group.groupByField + '"]' + ' >= ' + value;
                        break;
                    case '==':
                        queryString += 'item["' + group.groupByField + '"]' + ' == ' + value;
                        break;
                }
            }
            queryString += ')';
            return queryString;
        };
        TableInstanceComponent.prototype.getItemRowColor = function () {
            return this.sanitizer.bypassSecurityTrustStyle(this.itemRowColor);
        };
        TableInstanceComponent.prototype.getColumnColor = function (columnId) {
            var column = DynamicTableUtils.getColumnById(columnId, this.columns);
            var columnOption = DynamicTableUtils.getColumnById(columnId, this.columnOptions);
            var columnColor = column['backgroundColor'];
            if (columnOption != null) {
                columnColor = columnOption['backgroundColor'];
            }
            return this.sanitizer.bypassSecurityTrustStyle(columnColor);
        };
        TableInstanceComponent.prototype.hasGroups = function () {
            return (this.groupExpressions != null && this.groupExpressions.length > 0);
        };
        TableInstanceComponent.prototype.replaceItem = function (item) {
            if (item !== null) {
                var filteredItems = this.dataSource.data.filter(function (itemFromList) { return lodash.isEqual(itemFromList['id'], item['id']); });
                filteredItems = (filteredItems.length > 0) ? filteredItems : this.dataSource.data.filter(function (itemFromList) { return lodash.isEqual(itemFromList['id'].elementId, item['id'].elementId); });
                if (filteredItems != null && filteredItems.length > 0) {
                    var index = this.dataSource.data.indexOf(this.dataSource.data[0]);
                    this.dataSource.data[index] = item;
                }
            }
        };
        TableInstanceComponent.prototype.removeItem = function (item) {
            if (item !== null) {
                var index = this.dataSource.data.indexOf(item);
                this.dataSource.data.splice(index, 1);
            }
        };
        TableInstanceComponent.prototype.handleDataProviderEvents = function (data) {
            switch (data['event']) {
                case 'refreshList':
                    this.load();
                    break;
                case 'updateItem':
                    this.replaceItem(data['item']);
                    break;
                case 'removeItem':
                    this.removeItem(data['item']);
                    break;
                case 'nextItem':
                    this.actionMessage.setItem(this.getNextItem());
                    this.actionMessage.setAction('nextItem');
                    this.actionsSubject.next(this.actionMessage);
                    break;
                case 'previousItem':
                    this.actionMessage.setItem(this.getPreviousItem());
                    this.actionMessage.setAction('previousItem');
                    this.actionsSubject.next(this.actionMessage);
                    break;
            }
        };
        TableInstanceComponent.prototype.isColumnDefined = function (column) {
            return this.displayedColumns.indexOf(column) > -1;
        };
        TableInstanceComponent.prototype.getColumnsStyleUrl = function () {
            return this.palTableDataProvider.getColumnsStyleUrl();
        };
        TableInstanceComponent.prototype.getIndicatorColor = function (item, rowIndex, groupIndex) {
            return this.palTableDataProvider.getIndicatorColor(item, rowIndex, groupIndex, this.groupName);
        };
        TableInstanceComponent.prototype.getIndicatorSign = function (item, rowIndex, groupIndex) {
            return this.palTableDataProvider.getIndicatorSign(item, rowIndex, groupIndex, this.groupName);
        };
        TableInstanceComponent.prototype.getHTMLContentSummary = function (item, rowIndex, groupIndex) {
            var _this = this;
            this.palTableContentSummaryContainerDirectives = this.palTableContentSummaryContainerQueryList.toArray();
            var htmlContentSummary = this.palTableDataProvider.getHTMLContentSummary(item, rowIndex, groupIndex, this.groupName);
            var palTableContentSummaryContainerDirective = this.palTableContentSummaryContainerDirectives[rowIndex];
            if (palTableContentSummaryContainerDirective != null) {
                this.zone.run(function () { return _this.palTableDynamicCellBuilder.createColumn(palTableContentSummaryContainerDirective.viewContainerRef, htmlContentSummary, _this.getColumnsStyleUrl(), {
                    item: item,
                    actionsSubject: _this.actionsSubject,
                    actionMessage: _this.actionMessage,
                    mouseEventsSubject: _this.mouseEventsSubject,
                    mouseEventMessage: _this.mouseEventMessage
                }); });
            }
            return '';
        };
        TableInstanceComponent.prototype.getAdditionalInfo = function (item, rowIndex, groupIndex) {
            var _this = this;
            this.palTableAdditionalInfoContainerDirectives = this.palTableAdditionalInfoContainerQueryList.toArray();
            var htmlAdditionalInfo = this.palTableDataProvider.getAdditionalInfo(item, rowIndex, groupIndex, this.groupName);
            var palTableAdditionalInfoContainerDirective = this.palTableAdditionalInfoContainerDirectives[rowIndex];
            if (palTableAdditionalInfoContainerDirective != null) {
                this.zone.run(function () { return _this.palTableDynamicCellBuilder.createColumn(palTableAdditionalInfoContainerDirective.viewContainerRef, htmlAdditionalInfo, _this.getColumnsStyleUrl(), {
                    item: item,
                    actionsSubject: _this.actionsSubject,
                    actionMessage: _this.actionMessage,
                    mouseEventsSubject: _this.mouseEventsSubject,
                    mouseEventMessage: _this.mouseEventMessage
                }); });
            }
            return '';
        };
        TableInstanceComponent.prototype.getHTMLIcon = function (item, rowIndex, groupIndex) {
            var _this = this;
            this.palTableIconContainerDirectives = this.palTableIconContainerQueryList.toArray();
            var iconHtml = this.palTableDataProvider.getHTMLIcon(item, rowIndex, groupIndex, this.groupName);
            var palTableIconContainerDirective = this.palTableIconContainerDirectives[rowIndex];
            if (palTableIconContainerDirective != null) {
                this.zone.run(function () { return _this.palTableDynamicCellBuilder.createColumn(palTableIconContainerDirective.viewContainerRef, iconHtml, _this.getColumnsStyleUrl(), {
                    item: item,
                    actionsSubject: _this.actionsSubject,
                    actionMessage: _this.actionMessage,
                    mouseEventsSubject: _this.mouseEventsSubject,
                    mouseEventMessage: _this.mouseEventMessage
                }); });
            }
            return '';
        };
        TableInstanceComponent.prototype.getTitle = function (item, rowIndex, groupIndex) {
            var _this = this;
            this.palTableTitleContainerDirectives = this.palTableTitleContainerQueryList.toArray();
            var htmlTitle = this.palTableDataProvider.getTitle(item, rowIndex, groupIndex, this.groupName);
            var palTableTitleContainerDirective = this.palTableTitleContainerDirectives[rowIndex];
            if (palTableTitleContainerDirective != null) {
                this.zone.run(function () { return _this.palTableDynamicCellBuilder.createColumn(palTableTitleContainerDirective.viewContainerRef, htmlTitle, _this.getColumnsStyleUrl(), {
                    item: item,
                    actionsSubject: _this.actionsSubject,
                    actionMessage: _this.actionMessage,
                    mouseEventsSubject: _this.mouseEventsSubject,
                    mouseEventMessage: _this.mouseEventMessage
                }); });
            }
            return '';
        };
        TableInstanceComponent.prototype.getOtherTextBased = function (item, rowIndex, groupIndex) {
            return this.palTableDataProvider.getOtherTextBased(item, rowIndex, groupIndex, this.groupName);
        };
        TableInstanceComponent.prototype.getDescription = function (item, rowIndex, groupIndex) {
            var _this = this;
            this.palTableDescriptionContainerDirectives = this.palTableDescriptionContainerQueryList.toArray();
            var htmlDescription = this.palTableDataProvider.getDescription(item, rowIndex, groupIndex, this.groupName);
            var palTableDescriptionContainerDirective = this.palTableDescriptionContainerDirectives[rowIndex];
            if (palTableDescriptionContainerDirective != null) {
                this.zone.run(function () { return _this.palTableDynamicCellBuilder.createColumn(palTableDescriptionContainerDirective.viewContainerRef, htmlDescription, _this.getColumnsStyleUrl(), {
                    item: item,
                    actionsSubject: _this.actionsSubject,
                    actionMessage: _this.actionMessage,
                    mouseEventsSubject: _this.mouseEventsSubject,
                    mouseEventMessage: _this.mouseEventMessage
                }); });
            }
            return '';
        };
        TableInstanceComponent.prototype.getHTMLAction = function (item, rowIndex, groupIndex) {
            var _this = this;
            this.palTableActionsContainerDirectives = this.palTableActionsContainerQueryList.toArray();
            var actionsHtml = this.palTableDataProvider.getHTMLAction(item, rowIndex, groupIndex, this.groupName);
            var palTableActionsContainerDirective = this.palTableActionsContainerDirectives[rowIndex];
            if (palTableActionsContainerDirective != null) {
                this.zone.run(function () { return _this.palTableDynamicCellBuilder.createColumn(palTableActionsContainerDirective.viewContainerRef, actionsHtml, _this.getColumnsStyleUrl(), {
                    item: item,
                    actionsSubject: _this.actionsSubject,
                    actionMessage: _this.actionMessage,
                    mouseEventsSubject: _this.mouseEventsSubject,
                    mouseEventMessage: _this.mouseEventMessage
                }); });
            }
            return '';
        };
        TableInstanceComponent.prototype.getColumnName = function (columnId) {
            return DynamicTableUtils.getColumnNameById(columnId, this.columns);
        };
        TableInstanceComponent.prototype.applyFilter = function (filterValue) {
            if (filterValue.length >= TableInstanceComponent_1.FILTER_MIN_VALUE && filterValue !== this.filterHint) {
                filterValue = filterValue.trim();
                filterValue = filterValue.toLowerCase();
            }
            else {
                filterValue = '';
            }
            this.dataSource.filter = filterValue;
        };
        TableInstanceComponent.prototype.selectItem = function (index) {
            this.currentSelectedRowIndex = index;
            this.changeDetectorRef.detectChanges();
        };
        TableInstanceComponent.prototype.getCurrentSelectedItem = function () {
            return this.dataSource.data[this.currentSelectedRowIndex];
        };
        TableInstanceComponent.prototype.getPreviousItem = function () {
            var previousItemPosition = (this.currentSelectedRowIndex > 0) ? this.currentSelectedRowIndex - 1 : 0;
            this.selectItem(previousItemPosition);
            return this.dataSource.data[previousItemPosition];
        };
        TableInstanceComponent.prototype.getNextItem = function () {
            var nextElementPosition = (this.currentSelectedRowIndex < (this.dataSource.data.length - 1)) ? this.currentSelectedRowIndex + 1 : this.currentSelectedRowIndex;
            this.selectItem(nextElementPosition);
            return this.dataSource.data[nextElementPosition];
        };
        TableInstanceComponent.prototype.onFilterEnter = function () {
            this.filterHint = '';
        };
        TableInstanceComponent.prototype.onFilterLeave = function () {
            this.filterHint = 'Filter';
        };
        TableInstanceComponent.FILTER_MIN_VALUE = 3;
        __decorate([
            core.ViewChildren(DynamicTableIconContainerDirective),
            __metadata("design:type", core.QueryList)
        ], TableInstanceComponent.prototype, "palTableIconContainerQueryList", void 0);
        __decorate([
            core.ViewChildren(DynamicTableActionsContainerDirective),
            __metadata("design:type", core.QueryList)
        ], TableInstanceComponent.prototype, "palTableActionsContainerQueryList", void 0);
        __decorate([
            core.ViewChildren(DynamicTableContentSummaryContainerDirective),
            __metadata("design:type", core.QueryList)
        ], TableInstanceComponent.prototype, "palTableContentSummaryContainerQueryList", void 0);
        __decorate([
            core.ViewChildren(PalTableAdditionalInfoContainerDirective),
            __metadata("design:type", core.QueryList)
        ], TableInstanceComponent.prototype, "palTableAdditionalInfoContainerQueryList", void 0);
        __decorate([
            core.ViewChildren(DynamicTableDescriptionContainerDirective),
            __metadata("design:type", core.QueryList)
        ], TableInstanceComponent.prototype, "palTableDescriptionContainerQueryList", void 0);
        __decorate([
            core.ViewChildren(DynamicTableTitleContainerDirective),
            __metadata("design:type", core.QueryList)
        ], TableInstanceComponent.prototype, "palTableTitleContainerQueryList", void 0);
        __decorate([
            core.ViewChild(material.MatSort),
            __metadata("design:type", material.MatSort)
        ], TableInstanceComponent.prototype, "sort", void 0);
        __decorate([
            core.ViewChild(material.MatTable),
            __metadata("design:type", material.MatTable)
        ], TableInstanceComponent.prototype, "table", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], TableInstanceComponent.prototype, "groupName", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], TableInstanceComponent.prototype, "itemRowColor", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], TableInstanceComponent.prototype, "hideColumns", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Array)
        ], TableInstanceComponent.prototype, "groupExpressions", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Array)
        ], TableInstanceComponent.prototype, "columnOptions", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", rxjs.Subject)
        ], TableInstanceComponent.prototype, "actionsSubject", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", rxjs.Subject)
        ], TableInstanceComponent.prototype, "mouseEventsSubject", void 0);
        TableInstanceComponent = TableInstanceComponent_1 = __decorate([
            core.Component({
                selector: 'table-instance-component',
                template: "<div class=\"pal-table-loading-shade\" *ngIf=\"isLoadingResults || noDataFound\">\n    <div fxLayout=\"column\" fxLayoutAlign=\"space-around center\" *ngIf=\"isLoadingResults\">\n        <mat-spinner mode=\"indeterminate\" color=\"primary\" [diameter]=\"80\" [strokeWidth]=\"2\"></mat-spinner>\n        <!-- <mat-progress-bar mode=\"buffer\" color=\"accent\"></mat-progress-bar> -->\n        <span>wird geladen...</span>\n    </div>\n    <div fxLayout=\"column\" fxLayoutAlign=\"space-around center\" class=\"pal-table-message\" *ngIf=\"noDataFound\">\n        <mat-icon svgIcon=\"no-data-found\" class=\"no-data-found-icon\"></mat-icon>\n        <span class=\"no-data-found-text\">No data found!</span>\n    </div>\n</div>\n\n<mat-table class=\"pal-table\" #table [dataSource]=\"dataSource\" matSort matSortActive=\"title\" matSortDirection=\"asc\"\n    class=\"def-animated\">\n\n    <!-- Selected Row Column -->\n    <ng-container matColumnDef=\"selectedRowColumn\">\n        <mat-header-cell *matHeaderCellDef mat-sort-header class=\"selected-row-column\"></mat-header-cell>\n        <mat-cell *matCellDef=\"let rowIndex = index;\" class=\"selected-row-column\">\n            <mat-icon class=\"selected-row-icon\" *ngIf=\"currentSelectedRowIndex == rowIndex\">lens</mat-icon>\n        </mat-cell>\n    </ng-container>\n\n    <!-- <ng-template [palDynamicTableColumnsContainer]></ng-template> -->\n\n    <!-- Position Column -->\n    <ng-container matColumnDef=\"{{COLUMN_DEFINITIONS.INDICATOR_COLOR}}\" *ngIf=\"isColumnDefined(COLUMN_DEFINITIONS.INDICATOR_COLOR)\">\n        <mat-header-cell *matHeaderCellDef class=\"color-column\" mat-sort-header>{{getColumnName(COLUMN_DEFINITIONS.INDICATOR_COLOR)}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let item; let rowIndex = index;\" [style.background-color]=\"getIndicatorColor(item)\"\n            class=\"color-column\">\n            {{(rowIndex+1)}} {{getIndicatorSign(item, rowIndex, groupIndex)}} </mat-cell>\n    </ng-container>\n\n    <!-- Icon column -->\n    <ng-container matColumnDef=\"{{COLUMN_DEFINITIONS.HTML_ICON}}\" *ngIf=\"isColumnDefined(COLUMN_DEFINITIONS.HTML_ICON)\">\n        <mat-header-cell *matHeaderCellDef class=\"icon-column\">{{getColumnName(COLUMN_DEFINITIONS.HTML_ICON)}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let item; let i = index;\" class=\"icon-column\" [style.background]=\"getColumnColor(COLUMN_DEFINITIONS.HTML_ICON)\">\n            {{getHTMLIcon(item, i, groupIndex)}}\n            <ng-template [palTableIconContainer]=\"i\"></ng-template>\n        </mat-cell>\n    </ng-container>\n\n    <!-- Title Column -->\n    <ng-container matColumnDef=\"{{COLUMN_DEFINITIONS.TITLE}}\" *ngIf=\"isColumnDefined(COLUMN_DEFINITIONS.TITLE)\">\n        <mat-header-cell *matHeaderCellDef mat-sort-header class=\"title-column\">\n            {{getColumnName(COLUMN_DEFINITIONS.TITLE)}}\n        </mat-header-cell>\n        <mat-cell *matCellDef=\"let item; let i = index;\" class=\"title-column\" [style.background]=\"getColumnColor(COLUMN_DEFINITIONS.TITLE)\">\n            {{getTitle(item, i, groupIndex)}}\n            <ng-template [palTableTitleContainer]=\"i\"></ng-template>\n        </mat-cell>\n    </ng-container>\n\n    <!-- Description column -->\n    <ng-container matColumnDef=\"{{COLUMN_DEFINITIONS.DESCRIPTION}}\" *ngIf=\"isColumnDefined(COLUMN_DEFINITIONS.DESCRIPTION)\">\n        <mat-header-cell *matHeaderCellDef class=\"description-column\" mat-sort-header>\n            {{getColumnName(COLUMN_DEFINITIONS.DESCRIPTION)}}\n        </mat-header-cell>\n        <mat-cell *matCellDef=\"let item; let i = index;\" class=\"description-column\" [style.background]=\"getColumnColor(COLUMN_DEFINITIONS.DESCRIPTION)\">\n            {{getDescription(item, i, groupIndex)}}\n            <ng-template [palTableDescriptionContainer]=\"i\"></ng-template>\n        </mat-cell>\n    </ng-container>\n\n    <!-- Additional info column -->\n    <ng-container matColumnDef=\"{{COLUMN_DEFINITIONS.ADDITIONAL_INFO}}\" *ngIf=\"isColumnDefined(COLUMN_DEFINITIONS.ADDITIONAL_INFO)\">\n        <mat-header-cell *matHeaderCellDef class=\"additional-info-column\" mat-sort-header>{{getColumnName(COLUMN_DEFINITIONS.ADDITIONAL_INFO)}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let item; let i = index;\" class=\"additional-info-column\" fxLayout=\"row\" fxLayoutAlign=\"space-around center\"\n            [style.background]=\"getColumnColor(COLUMN_DEFINITIONS.ADDITIONAL_INFO)\">\n            {{getAdditionalInfo(item, i, groupIndex)}}\n            <ng-template [palTableAdditionalInfoContainer]=\"i\"></ng-template>\n        </mat-cell>\n    </ng-container>\n\n    <!-- Other Text Based Column -->\n    <ng-container matColumnDef=\"{{COLUMN_DEFINITIONS.OTHER_TEXT_BASED1}}\" *ngIf=\"isColumnDefined(COLUMN_DEFINITIONS.OTHER_TEXT_BASED1)\">\n        <mat-header-cell *matHeaderCellDef mat-sort-header class=\"other-text-based-column\">{{getColumnName(COLUMN_DEFINITIONS.OTHER_TEXT_BASED1)}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let item; let rowIndex = index;\" class=\"other-text-based-column\" [style.background]=\"getColumnColor(COLUMN_DEFINITIONS.OTHER_TEXT_BASED1)\">{{getOtherTextBased(item,\n            rowIndex, groupIndex)}}</mat-cell>\n    </ng-container>\n\n    <!-- Content summary column -->\n    <ng-container matColumnDef=\"{{COLUMN_DEFINITIONS.HTML_CONTENT_SUMMARY}}\" *ngIf=\"isColumnDefined(COLUMN_DEFINITIONS.HTML_CONTENT_SUMMARY)\">\n        <mat-header-cell *matHeaderCellDef class=\"html-content-summary-column\" mat-sort-header>{{columnIndex}}\n            {{getColumnName(COLUMN_DEFINITIONS.HTML_CONTENT_SUMMARY)}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let item; let i = index;\" class=\"html-content-summary-column\" fxLayout=\"row\"\n            fxLayoutAlign=\"space-around center\" [style.background]=\"getColumnColor(COLUMN_DEFINITIONS.HTML_CONTENT_SUMMARY)\">\n            {{getHTMLContentSummary(item, i, groupIndex)}}\n            <ng-template [palTableContentSummaryContainer]=\"i\"></ng-template>\n        </mat-cell>\n    </ng-container>\n\n    <!-- Actions column -->\n    <ng-container matColumnDef=\"{{COLUMN_DEFINITIONS.HTML_ACTIONS}}\" *ngIf=\"isColumnDefined(COLUMN_DEFINITIONS.HTML_ACTIONS)\">\n        <mat-header-cell *matHeaderCellDef class=\"actions-column\">{{getColumnName(COLUMN_DEFINITIONS.HTML_ACTIONS)}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let item; let i = index;\" class=\"actions-column\" [style.background]=\"getColumnColor(COLUMN_DEFINITIONS.HTML_ACTIONS)\">\n            <div fxLayout=\"row\" fxLayoutAlign=\"space-around center\">\n                {{getHTMLAction(item, i, groupIndex)}}\n                <ng-template [palTableActionsContainer]=\"i\"></ng-template>\n            </div>\n        </mat-cell>\n    </ng-container>\n\n    <mat-header-row *matHeaderRowDef=\"let columnIndex = index;displayedColumns\" [ngClass]=\"{'no-header-columns': hideColumns}\"></mat-header-row>\n    <mat-row *matRowDef=\"let row; columns: displayedColumns; let rowIndex = index;\" (click)=\"selectItem(rowIndex)\"\n        [style.background]=\"getItemRowColor()\" [class.mat-elevation-z1]=\"currentSelectedRowIndex == rowIndex\" [ngClass]=\"{'current-selected-row': currentSelectedRowIndex == rowIndex}\"></mat-row>\n\n\n</mat-table>\n<!-- <mat-paginator [length]=\"resultsLength\" [pageSize]=\"30\"></mat-paginator> -->",
                styles: ["// COLORS\n//-------------------------------------//\n$md-primary-color: #00DB5D;\n$md-accent-color: #1EBAE4;\n$md-warning-color: #D32F2F;\n$md-white-color: #FFF;\n$md-grey-color: #929292;\n$md-blue-color: #40C4FF;\n\n// FONT FAMILY AND FONT SIZE\n//-------------------------------------//\n$application-font: 'RobotoLight',\nsans-serif;\n$application-font-color: #00c853;\n$application-font-placeholder-color: #B6B6B6;\n$application-font-white: #FFF;\n$font-size-50: 7.25vw;\n$font-size-40: 3.5vw;\n$font-size-35: 2.3vw;\n$font-size-30: 1.95vw;\n$font-size-28: 1.85vw;\n$font-size-25: 1.7vw;\n$font-size-20: 1.57vw;\n$font-size-18: 1.4vw;\n$font-size-15: 1.1vw;\n$font-size-13: 1vw;\n\n\n// OTHER VARIABLES\n//-------------------------------------//\n$mat-cell-height: 130px;\n\n\n// ICONS\n//-------------------------------------//\n.icon-medium {\n    width: 32px;\n    height: 32px;\n    font-size: 32px;\n}\n\n.icon-large {\n    width: 48px;\n    height: 48px;\n    font-size: 48px;\n}\n\n.icon-big {\n    width: 64px;\n    height: 64px;\n    font-size: 64px;\n}\n\n.icon-color-grey {\n    color: #929292;\n}\n\n.icon-color-white {\n    color: #ffffff;\n}\n\n\n\n// CLASSES\n//-------------------------------------//\n.pal-table-container {\n    position: relative;\n    display: flex;\n    flex-direction: column;\n    min-width: 300px;\n    height: 94vh;\n    padding-bottom: $mat-cell-height;\n    overflow: auto;\n    -webkit-overflow-scrolling: touch;\n}\n\n.pal-table-header {\n    min-height: 65px;\n    height: 65px;\n    width: 100%;\n    display: flex;\n    align-items: center;\n    padding-left: 24px;\n    padding-right: 24px;\n    padding-top: 12px;\n}\n\n.pal-table {\n    overflow: auto;\n    height: 100%;\n    font-size: 1.5vw;\n}\n\n.pal-table-loading-shade {\n    position: absolute;\n    top: 0;\n    left: 0; // bottom: 56px;\n    height: 100%;\n    right: 0;\n    background: rgba(0, 0, 0, 0.10);\n    z-index: 1;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n}\n\n.pal-table-message {\n    color: #980000;\n    max-width: 360px;\n    text-align: center;\n}\n\n.mat-header-cell.mat-sort-header-sorted {\n    color: black;\n}\n\n.mat-row {\n    min-height: $mat-cell-height;\n    padding: 0 7px;\n}\n\n.mat-cell {\n    font-size: $font-size-20;\n    min-height: $mat-cell-height;\n}\n\n// Columns\n.flex-column {\n    display: -webkit-box;\n    display: -moz-box;\n    display: -ms-flexbox;\n    display: -webkit-flex;\n    display: flex;\n    flex-wrap: wrap;\n    flex-direction: row;\n}\n\n.color-column {\n    @extend .flex-column;\n    font-size: $font-size-28;\n    width: 40px;\n    min-width: 40px;\n    max-width: 40px;\n}\n\n.title-column {\n    @extend .flex-column;\n}\n\n.icon-column {\n    @extend .flex-column;\n    width: 5%;\n    min-width: 5%;\n    max-width: 5%;\n}\n\n.description-column {\n    @extend .flex-column;\n}\n\n.html-content-summary-column {\n    @extend .flex-column;\n    width: 15%;\n    min-width: 15%;\n    max-width: 15%;\n}\n\n.additional-info-column {\n    @extend .flex-column;\n    width: 15%;\n    min-width: 15%;\n    max-width: 15%;\n}\n\n.actions-column {\n    @extend .flex-column;\n    width: 30%;\n    min-width: 30%;\n    max-width: 30%;\n}\n\n.other-text-based-column {\n    @extend .flex-column;\n}\n\n.no-data-found-icon {\n    height: 128px;\n    width: 128px;\n}\n\n.no-data-found-text {\n    font-size: 32px;\n    color: gray;\n    font-weight: 700;\n}\n\n.no-header-columns {\n    display: none;\n}\n\n.current-selected-row {\n    background-color: rgb(245, 252, 253);\n}\n\n.selected-row-icon {\n    font-size: 12px;\n    color: $md-accent-color;\n}\n\n.selected-row-column {\n    @extend .flex-column;\n    justify-content: flex-start;\n    width: 12px;\n    min-width: 12px;\n    max-width: 12px;\n}\n\n.speed-dial-container {\n    position: fixed;\n    bottom: 32px;\n    right: 32px;\n}\n\n.speed-dial-option-icon {\n    color: #ffffff;\n}\n\n.toolbar-buttons {\n    width: 50%;\n}\n\n.toolbar-button {\n    margin: 5px;\n}\n\n.mat-form-field-label-wrapper {\n    top: -3px;\n    padding-top: -3px;\n}\n\n.mat-toolbar {\n    background-color: #494949;\n}\n\n.pal-table-grouped-container {\n    width: 100%\n}\n\n.pal-table-grouped {\n    width: 100%\n}"]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], TableInstanceComponent);
        return TableInstanceComponent;
        var TableInstanceComponent_1;
    }(AbstractWebWidgetComponent));

    var DynamicTableComponent = /** @class */ (function (_super) {
        __extends(DynamicTableComponent, _super);
        function DynamicTableComponent(injector) {
            var _this = _super.call(this) || this;
            _this.filterHint = 'Filter';
            _this.actionsSubject = new rxjs.Subject();
            _this.mouseEventsSubject = new rxjs.Subject();
            _this.showFilter = true;
            _this.palTableDataProvider = injector.get(DynamicTableDataProvider);
            _this.tableOptions = _this.palTableDataProvider.getOptions();
            return _this;
        }
        DynamicTableComponent.prototype.onFilterEnter = function () {
            this.filterHint = '';
        };
        DynamicTableComponent.prototype.onFilterLeave = function () {
            this.filterHint = 'Filter';
        };
        DynamicTableComponent.FILTER_MIN_VALUE = 3;
        __decorate([
            core.ViewChildren(DynamicTableContainerDirective),
            __metadata("design:type", core.QueryList)
        ], DynamicTableComponent.prototype, "tablesQueryList", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], DynamicTableComponent.prototype, "showFilter", void 0);
        DynamicTableComponent = __decorate([
            core.Component({
                selector: 'dynamic-table',
                template: "<div class=\"pal-table-container mat-elevation-z8\">\n\n    <div class=\"pal-table-header\" *ngIf=\"showFilter\">\n        <mat-form-field class=\"pal-table-filter\">\n            <input matInput (keyup)=\"applyFilter($event.target.value)\" value=\"{{filterHint}}\" (click)=\"onFilterEnter()\"\n                (blur)=\"onFilterLeave()\">\n        </mat-form-field>\n    </div>\n\n    <!-- TABLE WITH GROUPS -->\n    <div class=\"pal-table-grouped-container\" *ngIf=\"tableOptions != null && tableOptions.length > 0\">\n        <div class=\"pal-table-grouped\" *ngFor=\"let tableOption of tableOptions; let tableIndex = index;\">\n            <mat-toolbar>{{tableOption.groupName}} </mat-toolbar>\n            <table-instance-component [palTableContainer]=\"tableIndex\" [hideColumns]=\"tableOption.hideColumns\"\n                [groupName]=\"tableOption.groupName\" [groupExpressions]=\"tableOption.groupExpressions\" [itemRowColor]=\"tableOption.groupItemRowColor\"\n                [columnOptions]=\"tableOption.columnOptions\" [actionsSubject]=\"actionsSubject\" [mouseEventsSubject]=\"mouseEventsSubject\"></table-instance-component>\n        </div>\n    </div>\n\n    <!-- TABLE ONLY -->\n    <table-instance-component *ngIf=\"tableOptions == null || tableOptions.length == 0\" [hideColumns]=\"true\" [groupName]=\"null\"\n        [groupExpressions]=\"null\" [itemRowColor]=\"null\" [columnOptions]=\"null\" [actionsSubject]=\"actionsSubject\"\n        [mouseEventsSubject]=\"mouseEventsSubject\"></table-instance-component>\n\n</div>",
                styles: [
                    "dynamic-table {\n    \n}",
                    "// COLORS\n//-------------------------------------//\n$md-primary-color: #00DB5D;\n$md-accent-color: #1EBAE4;\n$md-warning-color: #D32F2F;\n$md-white-color: #FFF;\n$md-grey-color: #929292;\n$md-blue-color: #40C4FF;\n\n// FONT FAMILY AND FONT SIZE\n//-------------------------------------//\n$application-font: 'RobotoLight',\nsans-serif;\n$application-font-color: #00c853;\n$application-font-placeholder-color: #B6B6B6;\n$application-font-white: #FFF;\n$font-size-50: 7.25vw;\n$font-size-40: 3.5vw;\n$font-size-35: 2.3vw;\n$font-size-30: 1.95vw;\n$font-size-28: 1.85vw;\n$font-size-25: 1.7vw;\n$font-size-20: 1.57vw;\n$font-size-18: 1.4vw;\n$font-size-15: 1.1vw;\n$font-size-13: 1vw;\n\n\n// OTHER VARIABLES\n//-------------------------------------//\n$mat-cell-height: 130px;\n\n\n// ICONS\n//-------------------------------------//\n.icon-medium {\n    width: 32px;\n    height: 32px;\n    font-size: 32px;\n}\n\n.icon-large {\n    width: 48px;\n    height: 48px;\n    font-size: 48px;\n}\n\n.icon-big {\n    width: 64px;\n    height: 64px;\n    font-size: 64px;\n}\n\n.icon-color-grey {\n    color: #929292;\n}\n\n.icon-color-white {\n    color: #ffffff;\n}\n\n\n\n// CLASSES\n//-------------------------------------//\n.pal-table-container {\n    position: relative;\n    display: flex;\n    flex-direction: column;\n    min-width: 300px;\n    height: 94vh;\n    padding-bottom: $mat-cell-height;\n    overflow: auto;\n    -webkit-overflow-scrolling: touch;\n}\n\n.pal-table-header {\n    min-height: 65px;\n    height: 65px;\n    width: 100%;\n    display: flex;\n    align-items: center;\n    padding-left: 24px;\n    padding-right: 24px;\n    padding-top: 12px;\n}\n\n.pal-table {\n    overflow: auto;\n    height: 100%;\n    font-size: 1.5vw;\n}\n\n.pal-table-loading-shade {\n    position: absolute;\n    top: 0;\n    left: 0; // bottom: 56px;\n    height: 100%;\n    right: 0;\n    background: rgba(0, 0, 0, 0.10);\n    z-index: 1;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n}\n\n.pal-table-message {\n    color: #980000;\n    max-width: 360px;\n    text-align: center;\n}\n\n.mat-header-cell.mat-sort-header-sorted {\n    color: black;\n}\n\n.mat-row {\n    min-height: $mat-cell-height;\n    padding: 0 7px;\n}\n\n.mat-cell {\n    font-size: $font-size-20;\n    min-height: $mat-cell-height;\n}\n\n// Columns\n.flex-column {\n    display: -webkit-box;\n    display: -moz-box;\n    display: -ms-flexbox;\n    display: -webkit-flex;\n    display: flex;\n    flex-wrap: wrap;\n    flex-direction: row;\n}\n\n.color-column {\n    @extend .flex-column;\n    font-size: $font-size-28;\n    width: 40px;\n    min-width: 40px;\n    max-width: 40px;\n}\n\n.title-column {\n    @extend .flex-column;\n}\n\n.icon-column {\n    @extend .flex-column;\n    width: 5%;\n    min-width: 5%;\n    max-width: 5%;\n}\n\n.description-column {\n    @extend .flex-column;\n}\n\n.html-content-summary-column {\n    @extend .flex-column;\n    width: 15%;\n    min-width: 15%;\n    max-width: 15%;\n}\n\n.additional-info-column {\n    @extend .flex-column;\n    width: 15%;\n    min-width: 15%;\n    max-width: 15%;\n}\n\n.actions-column {\n    @extend .flex-column;\n    width: 30%;\n    min-width: 30%;\n    max-width: 30%;\n}\n\n.other-text-based-column {\n    @extend .flex-column;\n}\n\n.no-data-found-icon {\n    height: 128px;\n    width: 128px;\n}\n\n.no-data-found-text {\n    font-size: 32px;\n    color: gray;\n    font-weight: 700;\n}\n\n.no-header-columns {\n    display: none;\n}\n\n.current-selected-row {\n    background-color: rgb(245, 252, 253);\n}\n\n.selected-row-icon {\n    font-size: 12px;\n    color: $md-accent-color;\n}\n\n.selected-row-column {\n    @extend .flex-column;\n    justify-content: flex-start;\n    width: 12px;\n    min-width: 12px;\n    max-width: 12px;\n}\n\n.speed-dial-container {\n    position: fixed;\n    bottom: 32px;\n    right: 32px;\n}\n\n.speed-dial-option-icon {\n    color: #ffffff;\n}\n\n.toolbar-buttons {\n    width: 50%;\n}\n\n.toolbar-button {\n    margin: 5px;\n}\n\n.mat-form-field-label-wrapper {\n    top: -3px;\n    padding-top: -3px;\n}\n\n.mat-toolbar {\n    background-color: #494949;\n}\n\n.pal-table-grouped-container {\n    width: 100%\n}\n\n.pal-table-grouped {\n    width: 100%\n}"
                ],
                animations: []
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], DynamicTableComponent);
        return DynamicTableComponent;
    }(AbstractWebWidgetComponent));

    var DynamicTableModule = /** @class */ (function () {
        function DynamicTableModule() {
        }
        DynamicTableModule_1 = DynamicTableModule;
        /**
         * Singleton services
         */
        DynamicTableModule.forRoot = function () {
            return {
                ngModule: DynamicTableModule_1,
                providers: [
                    DynamicTableActionMessageService,
                    DynamicTableMouseEventMessageService
                ]
            };
        };
        DynamicTableModule = DynamicTableModule_1 = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    flexLayout.FlexLayoutModule,
                    material.MatPaginatorModule,
                    material.MatSortModule,
                    material.MatTableModule,
                    material.MatFormFieldModule,
                    material.MatInputModule,
                    material.MatProgressSpinnerModule,
                    material.MatProgressBarModule,
                    forms.FormsModule,
                    forms.ReactiveFormsModule,
                    material.MatButtonModule,
                    material.MatIconModule,
                    material.MatCardModule,
                    material.MatToolbarModule,
                    material.MatSlideToggleModule
                ],
                schemas: [core.NO_ERRORS_SCHEMA],
                declarations: [
                    TableInstanceComponent,
                    DynamicTableComponent,
                    DynamicTableColumnsContainerDirective,
                    DynamicTableIconContainerDirective,
                    DynamicTableContainerDirective,
                    DynamicTableActionsContainerDirective,
                    DynamicTableContentSummaryContainerDirective,
                    PalTableAdditionalInfoContainerDirective,
                    DynamicTableDescriptionContainerDirective,
                    DynamicTableTitleContainerDirective
                ],
                exports: [
                    material.MatPaginatorModule,
                    material.MatSortModule,
                    material.MatTableModule,
                    material.MatFormFieldModule,
                    material.MatInputModule,
                    material.MatProgressSpinnerModule,
                    material.MatProgressBarModule,
                    forms.FormsModule,
                    forms.ReactiveFormsModule,
                    material.MatButtonModule,
                    material.MatIconModule,
                    material.MatCardModule,
                    material.MatToolbarModule,
                    material.MatSlideToggleModule,
                    TableInstanceComponent,
                    DynamicTableComponent,
                    DynamicTableContainerDirective,
                    DynamicTableIconContainerDirective,
                    DynamicTableActionsContainerDirective,
                    DynamicTableContentSummaryContainerDirective,
                    PalTableAdditionalInfoContainerDirective,
                    DynamicTableDescriptionContainerDirective,
                    DynamicTableTitleContainerDirective,
                ],
                entryComponents: [],
                providers: [
                    DynamicTableDataProvider,
                    DynamicTableDynamicCellBuilder,
                ],
            })
        ], DynamicTableModule);
        return DynamicTableModule;
        var DynamicTableModule_1;
    }());

    var AbstractDynamicTableDataProvider = /** @class */ (function () {
        function AbstractDynamicTableDataProvider() {
            this.palTableEventPublisher = new rxjs.Subject();
        }
        AbstractDynamicTableDataProvider.prototype.refreshList = function () {
            this.palTableEventPublisher.next({ event: 'refreshList', item: null });
        };
        AbstractDynamicTableDataProvider.prototype.updateItem = function (item) {
            this.palTableEventPublisher.next({ event: 'updateItem', item: item });
        };
        AbstractDynamicTableDataProvider.prototype.removeItem = function (item) {
            this.palTableEventPublisher.next({ event: 'removeItem', item: item });
        };
        AbstractDynamicTableDataProvider.prototype.getEventPublisher = function () {
            return this.palTableEventPublisher;
        };
        AbstractDynamicTableDataProvider.prototype.nextElement = function () {
            this.palTableEventPublisher.next({ event: 'nextItem', item: null });
        };
        AbstractDynamicTableDataProvider.prototype.previousElement = function () {
            this.palTableEventPublisher.next({ event: 'previousItem', item: null });
        };
        AbstractDynamicTableDataProvider.prototype.getColumnsStyleUrl = function () {
            return './styles/pal-table-cells-style.scss';
        };
        return AbstractDynamicTableDataProvider;
    }());

    var DynamicExpandableTableDataProvider = /** @class */ (function (_super) {
        __extends(DynamicExpandableTableDataProvider, _super);
        function DynamicExpandableTableDataProvider() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.expandedItemTableColumns = [
                { columnId: 'expandedItemExpandableColumn', column: '', icon: 'timer', backgroundColor: '#494949', color: '#ffffff' },
                { columnId: 'icon', column: 'Icon', icon: '', backgroundColor: '', color: '' },
                { columnId: 'unit', column: 'Einheit', icon: '', backgroundColor: '', color: '' },
                { columnId: 'product', column: 'Produkt', icon: '', backgroundColor: '', color: '' },
                { columnId: 'article', column: 'Art', icon: '', backgroundColor: '', color: '' },
                { columnId: 'date-range', column: 'Wirkzeitraum', icon: '', backgroundColor: '', color: '' },
                { columnId: 'reason', column: 'Grund', icon: '', backgroundColor: '', color: '' },
                { columnId: 'physician-drug-administrator', column: 'Verordnet', icon: '', backgroundColor: '', color: '' },
                { columnId: 'comment', column: 'Bemerkung', icon: '', backgroundColor: '', color: '' },
            ];
            _this.expandedItemDetailsTableColumns = [
                { columnId: 'icon', column: 'Icon', icon: '', backgroundColor: '', color: '' },
                { columnId: 'unit', column: 'Einheit', icon: '', backgroundColor: '', color: '' },
                { columnId: 'product', column: 'Produkt', icon: '', backgroundColor: '', color: '' },
                { columnId: 'article', column: 'Art', icon: '', backgroundColor: '', color: '' },
                { columnId: 'date-range', column: 'Wirkzeitraum', icon: '', backgroundColor: '', color: '' },
                { columnId: 'reason', column: 'Grund', icon: '', backgroundColor: '', color: '' },
                { columnId: 'physician-drug-administrator', column: 'Verordnet', icon: '', backgroundColor: '', color: '' },
                { columnId: 'comment', column: 'Bemerkung', icon: '', backgroundColor: '', color: '' },
            ];
            _this.expandedDataSource = ['one1', 'two2', 'three3', 'four4', 'five5', 'six6', 'seven7', 'eight8'];
            return _this;
        }
        DynamicExpandableTableDataProvider.prototype.getExpandedItemTableColumns = function (expandedItem) {
            return this.expandedItemTableColumns;
        };
        DynamicExpandableTableDataProvider.prototype.getExpandedItemTableData = function (expandedItem) {
            return rxjs.of(this.expandedDataSource);
        };
        DynamicExpandableTableDataProvider.prototype.getExpandedItemDetailsTableColumns = function (expandedItemDetails, expandedItem) {
            return this.expandedItemDetailsTableColumns;
        };
        DynamicExpandableTableDataProvider.prototype.getExpandedItemDetailsTableData = function (expandedItemDetails, expandedItem) {
            return rxjs.of(this.expandedDataSource);
        };
        DynamicExpandableTableDataProvider.prototype.getOptions = function () {
            var options = [];
            var groupBy = {
                groupByField: 'approval',
                rules: [
                    {
                        'operator': '>',
                        'value': 1
                    }
                ]
            };
            var tableOptions = {
                groupName: 'Requested',
                groupExpressions: [
                    {
                        group: groupBy,
                        operator: ''
                    }
                ],
                groupItemRowColor: '',
                hideColumns: true,
                hideColumnsOfExpandedItems: true,
                hideColumnsOfExpandedItemDetails: true,
                columnOptions: []
            };
            options.push(tableOptions);
            return options;
        };
        DynamicExpandableTableDataProvider = __decorate([
            core.Injectable()
        ], DynamicExpandableTableDataProvider);
        return DynamicExpandableTableDataProvider;
    }(DynamicTableDataProvider));

    var DynamicExpandableTableComponent = /** @class */ (function (_super) {
        __extends(DynamicExpandableTableComponent, _super);
        function DynamicExpandableTableComponent(injector) {
            var _this = _super.call(this, injector) || this;
            _this.iconRegistry = injector.get(material.MatIconRegistry);
            _this.sanitizer = injector.get(platformBrowser.DomSanitizer);
            _this.palTableDataProvider = injector.get(DynamicExpandableTableDataProvider);
            _this.tableOptions = _this.palTableDataProvider.getOptions();
            _this.iconRegistry.addSvgIcon('expand', _this.sanitizer.bypassSecurityTrustResourceUrl('assets/ui/images/svg/expand-icon.svg'));
            return _this;
        }
        DynamicExpandableTableComponent = __decorate([
            core.Component({
                selector: 'dynamic-expandable-table',
                template: "<div class=\"pal-expandable-table-container\">\n\n    <div class=\"pal-table-header\" *ngIf=\"showFilter\">\n        <mat-form-field class=\"pal-table-filter\">\n            <input matInput (keyup)=\"applyFilter($event.target.value)\" value=\"{{filterHint}}\" (click)=\"onFilterEnter()\"\n                (blur)=\"onFilterLeave()\">\n        </mat-form-field>\n    </div>\n\n    <!-- EXPANDABLE TABLE WITH GROUPS -->\n    <div class=\"pal-expandable-table-grouped-container\" *ngIf=\"tableOptions != null && tableOptions.length > 0\">\n        <div class=\"pal-expandable-table-grouped\" *ngFor=\"let tableOption of tableOptions; let tableIndex = index;\">\n            <mat-toolbar class=\"pal-expandable-table-grouped-toolbar\">{{tableOption.groupName}} </mat-toolbar>\n            <expandable-table-instance [palTableContainer]=\"tableIndex\" [hideColumns]=\"tableOption.hideColumns\"\n                [hideColumnsOfExpandedItems]=\"tableOption.hideColumnsOfExpandedItems\"\n                [hideColumnsOfExpandedItemDetails]=\"tableOption.hideColumnsOfExpandedItemDetails\" [groupIndex]=\"tableIndex\"\n                [groupName]=\"tableOption.groupName\" [groupExpressions]=\"tableOption.groupExpressions\" [itemRowColor]=\"tableOption.groupItemRowColor\"\n                [columnOptions]=\"tableOption.columnOptions\" [actionsSubject]=\"actionsSubject\" [mouseEventsSubject]=\"mouseEventsSubject\"></expandable-table-instance>\n        </div>\n    </div>\n\n    <!-- EXPANDABLE TABLE ONLY -->\n    <expandable-table-instance *ngIf=\"tableOptions == null || tableOptions.length == 0\" [hideColumns]=\"true\"\n        [hideColumnsOfExpandedItems]=\"true\" [hideColumnsOfExpandedItemDetails]=\"true\" [groupName]=\"null\"\n        [groupExpressions]=\"null\" [itemRowColor]=\"null\" [columnOptions]=\"null\" [actionsSubject]=\"actionsSubject\"\n        [mouseEventsSubject]=\"mouseEventsSubject\"></expandable-table-instance>\n\n\n\n\n\n\n</div>",
                styles: [
                    "\n@import '../dynamic-table/table/table-instance.component.scss';\n\n$mat-cell-height: 130px;\n\n.pal-expandable-table-container {\n    position: relative;\n    display: flex;\n    flex-direction: column;\n    min-width: 300px;\n    height: 100vh;\n    padding-bottom: $mat-cell-height;\n    overflow: auto;\n    -webkit-overflow-scrolling: touch;\n}\n\n// Columns\n.flex-column {\n  display: flex;\n  flex-wrap: wrap;\n  flex-direction: row;\n  justify-content: flex-end;\n  align-items: center;\n  align-content: center; //align-content: space-between;\n  margin-left: 2px;\n}\n\n.expandable-row-column {\n  @extend .flex-column;\n  cursor: pointer;\n  justify-content: flex-start;\n  width: 10px;\n  min-width: 10px;\n  max-width: 10px;\n}\n\n.example-element-diagram {\n  min-width: 80px;\n  border: 2px solid black;\n  padding: 8px;\n  font-weight: lighter;\n  margin: 8px 0;\n  height: 104px;\n}\n\n.example-element-symbol {\n  font-weight: bold;\n  font-size: 40px;\n  line-height: normal;\n}\n\n.example-element-description {\n  padding: 16px;\n}\n\n.example-element-description-attribution {\n  opacity: 0.5;\n}\n\n.pal-expandable-table-grouped-container {\n  @extend .pal-table-grouped-container;\n}\n\n.pal-expandable-table-grouped {\n  @extend .pal-table-grouped;\n}\n\n.pal-expandable-table-grouped-toolbar {\n  min-height: 50px;\n  height: 50px;\n}\n",
                    "// COLORS\n//-------------------------------------//\n$md-primary-color: #00DB5D;\n$md-accent-color: #1EBAE4;\n$md-warning-color: #D32F2F;\n$md-white-color: #FFF;\n$md-grey-color: #929292;\n$md-blue-color: #40C4FF;\n\n// FONT FAMILY AND FONT SIZE\n//-------------------------------------//\n$application-font: 'RobotoLight',\nsans-serif;\n$application-font-color: #00c853;\n$application-font-placeholder-color: #B6B6B6;\n$application-font-white: #FFF;\n$font-size-50: 7.25vw;\n$font-size-40: 3.5vw;\n$font-size-35: 2.3vw;\n$font-size-30: 1.95vw;\n$font-size-28: 1.85vw;\n$font-size-25: 1.7vw;\n$font-size-20: 1.57vw;\n$font-size-18: 1.4vw;\n$font-size-15: 1.1vw;\n$font-size-13: 1vw;\n\n\n// OTHER VARIABLES\n//-------------------------------------//\n$mat-cell-height: 130px;\n\n\n// ICONS\n//-------------------------------------//\n.icon-medium {\n    width: 32px;\n    height: 32px;\n    font-size: 32px;\n}\n\n.icon-large {\n    width: 48px;\n    height: 48px;\n    font-size: 48px;\n}\n\n.icon-big {\n    width: 64px;\n    height: 64px;\n    font-size: 64px;\n}\n\n.icon-color-grey {\n    color: #929292;\n}\n\n.icon-color-white {\n    color: #ffffff;\n}\n\n\n\n// CLASSES\n//-------------------------------------//\n.pal-table-container {\n    position: relative;\n    display: flex;\n    flex-direction: column;\n    min-width: 300px;\n    height: 94vh;\n    padding-bottom: $mat-cell-height;\n    overflow: auto;\n    -webkit-overflow-scrolling: touch;\n}\n\n.pal-table-header {\n    min-height: 65px;\n    height: 65px;\n    width: 100%;\n    display: flex;\n    align-items: center;\n    padding-left: 24px;\n    padding-right: 24px;\n    padding-top: 12px;\n}\n\n.pal-table {\n    overflow: auto;\n    height: 100%;\n    font-size: 1.5vw;\n}\n\n.pal-table-loading-shade {\n    position: absolute;\n    top: 0;\n    left: 0; // bottom: 56px;\n    height: 100%;\n    right: 0;\n    background: rgba(0, 0, 0, 0.10);\n    z-index: 1;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n}\n\n.pal-table-message {\n    color: #980000;\n    max-width: 360px;\n    text-align: center;\n}\n\n.mat-header-cell.mat-sort-header-sorted {\n    color: black;\n}\n\n.mat-row {\n    min-height: $mat-cell-height;\n    padding: 0 7px;\n}\n\n.mat-cell {\n    font-size: $font-size-20;\n    min-height: $mat-cell-height;\n}\n\n// Columns\n.flex-column {\n    display: -webkit-box;\n    display: -moz-box;\n    display: -ms-flexbox;\n    display: -webkit-flex;\n    display: flex;\n    flex-wrap: wrap;\n    flex-direction: row;\n}\n\n.color-column {\n    @extend .flex-column;\n    font-size: $font-size-28;\n    width: 40px;\n    min-width: 40px;\n    max-width: 40px;\n}\n\n.title-column {\n    @extend .flex-column;\n}\n\n.icon-column {\n    @extend .flex-column;\n    width: 5%;\n    min-width: 5%;\n    max-width: 5%;\n}\n\n.description-column {\n    @extend .flex-column;\n}\n\n.html-content-summary-column {\n    @extend .flex-column;\n    width: 15%;\n    min-width: 15%;\n    max-width: 15%;\n}\n\n.additional-info-column {\n    @extend .flex-column;\n    width: 15%;\n    min-width: 15%;\n    max-width: 15%;\n}\n\n.actions-column {\n    @extend .flex-column;\n    width: 30%;\n    min-width: 30%;\n    max-width: 30%;\n}\n\n.other-text-based-column {\n    @extend .flex-column;\n}\n\n.no-data-found-icon {\n    height: 128px;\n    width: 128px;\n}\n\n.no-data-found-text {\n    font-size: 32px;\n    color: gray;\n    font-weight: 700;\n}\n\n.no-header-columns {\n    display: none;\n}\n\n.current-selected-row {\n    background-color: rgb(245, 252, 253);\n}\n\n.selected-row-icon {\n    font-size: 12px;\n    color: $md-accent-color;\n}\n\n.selected-row-column {\n    @extend .flex-column;\n    justify-content: flex-start;\n    width: 12px;\n    min-width: 12px;\n    max-width: 12px;\n}\n\n.speed-dial-container {\n    position: fixed;\n    bottom: 32px;\n    right: 32px;\n}\n\n.speed-dial-option-icon {\n    color: #ffffff;\n}\n\n.toolbar-buttons {\n    width: 50%;\n}\n\n.toolbar-button {\n    margin: 5px;\n}\n\n.mat-form-field-label-wrapper {\n    top: -3px;\n    padding-top: -3px;\n}\n\n.mat-toolbar {\n    background-color: #494949;\n}\n\n.pal-table-grouped-container {\n    width: 100%\n}\n\n.pal-table-grouped {\n    width: 100%\n}"
                ],
                animations: [
                    animations.trigger('detailExpand', [
                        animations.state('collapsed', animations.style({ height: '0px', minHeight: '0px', display: 'none' })),
                        animations.state('expanded', animations.style({ display: 'inline', height: '*' })),
                        animations.transition('expanded <=> collapsed', animations.animate('225ms cubic-bezier(0.4, 0.0, 0.2, 1)')),
                    ]),
                ],
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], DynamicExpandableTableComponent);
        return DynamicExpandableTableComponent;
    }(DynamicTableComponent));

    var DynamicExpandableTableUtils = /** @class */ (function () {
        function DynamicExpandableTableUtils() {
        }
        DynamicExpandableTableUtils.convertToColumnIds = function (columns) {
            var columnNames = [];
            if (columns != null) {
                for (var _i = 0, columns_1 = columns; _i < columns_1.length; _i++) {
                    var palExpandableTableExpandedItemColumn = columns_1[_i];
                    columnNames.push(palExpandableTableExpandedItemColumn.columnId);
                }
            }
            return columnNames;
        };
        return DynamicExpandableTableUtils;
    }());

    var ExpandableTableInstanceComponent = /** @class */ (function (_super) {
        __extends(ExpandableTableInstanceComponent, _super);
        function ExpandableTableInstanceComponent(injector) {
            var _this = _super.call(this, injector) || this;
            _this.injector = injector;
            _this.expandedItemDetailsDataSource = new material.MatTableDataSource();
            _this.isLoadingExpandedItemResults = true;
            _this.noExpandedItemDataFound = false;
            _this.palExpandableDataProvider = injector.get(DynamicExpandableTableDataProvider);
            return _this;
        }
        ExpandableTableInstanceComponent.prototype.addStandardColumns = function () {
        };
        ExpandableTableInstanceComponent.prototype.selectItem = function (index) {
            _super.prototype.selectItem.call(this, index);
            var currentSelectedItem = this.getCurrentSelectedItem();
            this.expandedElement = (this.expandedElement !== currentSelectedItem) ? currentSelectedItem : null;
            this.expandedElement2 = null;
            this.expandedItemDetailsDataSource.data = [];
        };
        ExpandableTableInstanceComponent.prototype.getColumnColor = function (columnId) {
            switch (columnId) {
                case 'expandableColumn':
                    if (this.expandedElement != null) {
                        var columnOption = DynamicTableUtils.getColumnById(columnId, this.columnOptions);
                        if (columnOption != null) {
                            var columnColor = columnOption['hoverBackgroundColor'];
                            return this.sanitizer.bypassSecurityTrustStyle(columnColor);
                        }
                    }
                    return _super.prototype.getColumnColor.call(this, columnId);
                default:
                    return _super.prototype.getColumnColor.call(this, columnId);
            }
        };
        ExpandableTableInstanceComponent.prototype.selectItem2 = function (expandedItemDetails, expandedItem) {
            this.expandedElement2 = expandedItemDetails;
            this.expandedItemDetailsDataSource.data = [];
            this.loadExpandedItemDetailsTableData(expandedItemDetails, expandedItem);
        };
        ExpandableTableInstanceComponent.prototype.getExpandedItemTableColumns = function (expandedItem) {
            return this.palExpandableDataProvider.getExpandedItemTableColumns(expandedItem);
        };
        ExpandableTableInstanceComponent.prototype.getExpandedItemTableColumnIds = function (expandedItem) {
            return DynamicExpandableTableUtils.convertToColumnIds(this.getExpandedItemTableColumns(expandedItem));
        };
        ExpandableTableInstanceComponent.prototype.getExpandedItemTableData = function (expandedItem) {
            return this.palExpandableDataProvider.getExpandedItemTableData(expandedItem);
        };
        ExpandableTableInstanceComponent.prototype.getExpandedItemDetailsTableColumns = function (expandedItemDetails, expandedItem) {
            return this.palExpandableDataProvider.getExpandedItemDetailsTableColumns(expandedItemDetails, expandedItem);
        };
        ExpandableTableInstanceComponent.prototype.getExpandedItemDetailsTableColumnIds = function (expandedItemDetails, expandedItem) {
            return DynamicExpandableTableUtils.convertToColumnIds(this.getExpandedItemDetailsTableColumns(expandedItemDetails, expandedItem));
        };
        ExpandableTableInstanceComponent.prototype.loadExpandedItemDetailsTableData = function (expandedItemDetails, expandedItem) {
            var _this = this;
            this.isLoadingExpandedItemResults = true;
            this.palExpandableDataProvider.getExpandedItemDetailsTableData(expandedItemDetails, expandedItem)
                .subscribe(function (items) {
                _this.expandedItemDetailsDataSource.data = items;
                _this.isLoadingExpandedItemResults = false;
                if (items.length === 0) {
                    _this.noDataFound = true;
                }
                else {
                    _this.noDataFound = false;
                }
            }, catchError(function (error) {
                console.error('Error in loading pal table data', error);
                _this.expandedItemDetailsDataSource.data = [];
                _this.isLoadingExpandedItemResults = false;
                return rxjs.of([]);
            }));
        };
        ExpandableTableInstanceComponent.EXPANDED_ITEM_EXPANDABLE_COLUMN_ID = 'expandedItemExpandableColumn';
        __decorate([
            core.Input(),
            __metadata("design:type", Number)
        ], ExpandableTableInstanceComponent.prototype, "groupIndex", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Boolean)
        ], ExpandableTableInstanceComponent.prototype, "hideColumnsOfExpandedItems", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Boolean)
        ], ExpandableTableInstanceComponent.prototype, "hideColumnsOfExpandedItemDetails", void 0);
        ExpandableTableInstanceComponent = __decorate([
            core.Component({
                selector: 'expandable-table-instance',
                template: "<mat-table #expandableTable [dataSource]=\"dataSource\" multiTemplateDataRows matSort class=\"pal-table mat-elevation-z2\">\n\n    <!-- Expandable Row Column -->\n    <ng-container matColumnDef=\"expandableColumn\">\n        <mat-header-cell *matHeaderCellDef class=\"expandable-row-column\"></mat-header-cell>\n        <mat-cell *matCellDef=\"let row; let rowIndex = dataIndex;\" class=\"expandable-row-column\" [style.background]=\"getColumnColor('expandableColumn')\"\n            (click)=\"selectItem(rowIndex);\">\n            <mat-icon *ngIf=\"expandedElement !== row\" class=\"expandable-row-icon\" svgIcon=\"expand\"></mat-icon>\n            <mat-icon *ngIf=\"expandedElement === row\" class=\"expandable-row-icon\" svgIcon=\"expand\"></mat-icon>\n        </mat-cell>\n    </ng-container>\n\n    <!-- Position Column -->\n    <ng-container matColumnDef=\"{{COLUMN_DEFINITIONS.INDICATOR_COLOR}}\" *ngIf=\"isColumnDefined(COLUMN_DEFINITIONS.INDICATOR_COLOR)\">\n        <mat-header-cell *matHeaderCellDef class=\"color-column\" mat-sort-header>{{getColumnName(COLUMN_DEFINITIONS.INDICATOR_COLOR)}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let item; let rowIndex = dataIndex;\" [style.background-color]=\"getIndicatorColor(item)\"\n            class=\"color-column\">\n            {{(rowIndex+1)}} {{getIndicatorSign(item, rowIndex, groupIndex)}} </mat-cell>\n    </ng-container>\n\n    <!-- Icon column -->\n    <ng-container matColumnDef=\"{{COLUMN_DEFINITIONS.HTML_ICON}}\" *ngIf=\"isColumnDefined(COLUMN_DEFINITIONS.HTML_ICON)\">\n        <mat-header-cell *matHeaderCellDef class=\"icon-column\">{{getColumnName(COLUMN_DEFINITIONS.HTML_ICON)}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let item; let i = dataIndex;\" class=\"icon-column\" [style.background]=\"getColumnColor(COLUMN_DEFINITIONS.HTML_ICON)\">\n            {{getHTMLIcon(item, i, groupIndex)}}\n            <ng-template [palTableIconContainer]=\"i\"></ng-template>\n        </mat-cell>\n    </ng-container>\n\n    <!-- Title Column -->\n    <ng-container matColumnDef=\"{{COLUMN_DEFINITIONS.TITLE}}\" *ngIf=\"isColumnDefined(COLUMN_DEFINITIONS.TITLE)\">\n        <mat-header-cell *matHeaderCellDef mat-sort-header class=\"title-column\">\n            {{getColumnName(COLUMN_DEFINITIONS.TITLE)}}\n        </mat-header-cell>\n        <mat-cell *matCellDef=\"let item; let i = dataIndex;\" class=\"title-column\" [style.background]=\"getColumnColor(COLUMN_DEFINITIONS.TITLE)\">\n            {{getTitle(item, i, groupIndex)}}\n            <ng-template [palTableTitleContainer]=\"i\"></ng-template>\n        </mat-cell>\n    </ng-container>\n\n    <!-- Description column -->\n    <ng-container matColumnDef=\"{{COLUMN_DEFINITIONS.DESCRIPTION}}\" *ngIf=\"isColumnDefined(COLUMN_DEFINITIONS.DESCRIPTION)\">\n        <mat-header-cell *matHeaderCellDef class=\"description-column\" mat-sort-header>\n            {{getColumnName(COLUMN_DEFINITIONS.DESCRIPTION)}}\n        </mat-header-cell>\n        <mat-cell *matCellDef=\"let item; let i = dataIndex;\" class=\"description-column\" [style.background]=\"getColumnColor(COLUMN_DEFINITIONS.DESCRIPTION)\">\n            {{getDescription(item, i, groupIndex)}}\n            <ng-template [palTableDescriptionContainer]=\"i\"></ng-template>\n        </mat-cell>\n    </ng-container>\n\n    <!-- Additional info column -->\n    <ng-container matColumnDef=\"{{COLUMN_DEFINITIONS.ADDITIONAL_INFO}}\" *ngIf=\"isColumnDefined(COLUMN_DEFINITIONS.ADDITIONAL_INFO)\">\n        <mat-header-cell *matHeaderCellDef class=\"additional-info-column\" mat-sort-header>{{getColumnName(COLUMN_DEFINITIONS.ADDITIONAL_INFO)}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let item; let i = dataIndex;\" class=\"additional-info-column\" fxLayout=\"row\"\n            fxLayoutAlign=\"space-around center\" [style.background]=\"getColumnColor(COLUMN_DEFINITIONS.ADDITIONAL_INFO)\">\n            {{getAdditionalInfo(item, i, groupIndex)}}\n            <ng-template [palTableAdditionalInfoContainer]=\"i\"></ng-template>\n        </mat-cell>\n    </ng-container>\n\n    <!-- Other Text Based Column -->\n    <ng-container matColumnDef=\"{{COLUMN_DEFINITIONS.OTHER_TEXT_BASED1}}\" *ngIf=\"isColumnDefined(COLUMN_DEFINITIONS.OTHER_TEXT_BASED1)\">\n        <mat-header-cell *matHeaderCellDef mat-sort-header class=\"other-text-based-column\">{{getColumnName(COLUMN_DEFINITIONS.OTHER_TEXT_BASED1)}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let item\" class=\"other-text-based-column\" [style.background]=\"getColumnColor(COLUMN_DEFINITIONS.OTHER_TEXT_BASED1)\">{{getOtherTextBased(item,\n            1, groupIndex)}}</mat-cell>\n    </ng-container>\n\n\n    <!-- Other Text Based Column -->\n    <ng-container matColumnDef=\"{{COLUMN_DEFINITIONS.OTHER_TEXT_BASED2}}\" *ngIf=\"isColumnDefined(COLUMN_DEFINITIONS.OTHER_TEXT_BASED2)\">\n        <mat-header-cell *matHeaderCellDef mat-sort-header class=\"other-text-based-column\">{{getColumnName(COLUMN_DEFINITIONS.OTHER_TEXT_BASED2)}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let item\" class=\"other-text-based-column\" [style.background]=\"getColumnColor(COLUMN_DEFINITIONS.OTHER_TEXT_BASED2)\">{{getOtherTextBased(item,\n            2, groupIndex)}}</mat-cell>\n    </ng-container>\n\n\n    <!-- Other Text Based Column -->\n    <ng-container matColumnDef=\"{{COLUMN_DEFINITIONS.OTHER_TEXT_BASED3}}\" *ngIf=\"isColumnDefined(COLUMN_DEFINITIONS.OTHER_TEXT_BASED3)\">\n        <mat-header-cell *matHeaderCellDef mat-sort-header class=\"other-text-based-column\">{{getColumnName(COLUMN_DEFINITIONS.OTHER_TEXT_BASED3)}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let item\" class=\"other-text-based-column\" [style.background]=\"getColumnColor(COLUMN_DEFINITIONS.OTHER_TEXT_BASED3)\">{{getOtherTextBased(item,\n            3, groupIndex)}}</mat-cell>\n    </ng-container>\n\n\n    <!-- Other Text Based Column -->\n    <ng-container matColumnDef=\"{{COLUMN_DEFINITIONS.OTHER_TEXT_BASED4}}\" *ngIf=\"isColumnDefined(COLUMN_DEFINITIONS.OTHER_TEXT_BASED4)\">\n        <mat-header-cell *matHeaderCellDef mat-sort-header class=\"other-text-based-column\">{{getColumnName(COLUMN_DEFINITIONS.OTHER_TEXT_BASED4)}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let item\" class=\"other-text-based-column\" [style.background]=\"getColumnColor(COLUMN_DEFINITIONS.OTHER_TEXT_BASED4)\">{{getOtherTextBased(item,\n            4, groupIndex)}}</mat-cell>\n    </ng-container>\n\n    <!-- Content summary column -->\n    <ng-container matColumnDef=\"{{COLUMN_DEFINITIONS.HTML_CONTENT_SUMMARY}}\" *ngIf=\"isColumnDefined(COLUMN_DEFINITIONS.HTML_CONTENT_SUMMARY)\">\n        <mat-header-cell *matHeaderCellDef class=\"html-content-summary-column\" mat-sort-header>{{getColumnName(COLUMN_DEFINITIONS.HTML_CONTENT_SUMMARY)}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let item; let i = dataIndex;\" class=\"html-content-summary-column\" fxLayout=\"row\"\n            fxLayoutAlign=\"space-around center\" [style.background]=\"getColumnColor(COLUMN_DEFINITIONS.HTML_CONTENT_SUMMARY)\">\n            {{getHTMLContentSummary(item, i, groupIndex)}}\n            <ng-template [palTableContentSummaryContainer]=\"i\"></ng-template>\n        </mat-cell>\n    </ng-container>\n\n    <!-- Actions column -->\n    <ng-container matColumnDef=\"{{COLUMN_DEFINITIONS.HTML_ACTIONS}}\" *ngIf=\"isColumnDefined(COLUMN_DEFINITIONS.HTML_ACTIONS)\">\n        <mat-header-cell *matHeaderCellDef class=\"actions-column\">{{getColumnName(COLUMN_DEFINITIONS.HTML_ACTIONS)}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let item; let i = dataIndex;\" class=\"actions-column\" [style.background]=\"getColumnColor(COLUMN_DEFINITIONS.HTML_ACTIONS)\">\n            <div fxLayout=\"row\" fxLayoutAlign=\"space-around center\">\n                {{getHTMLAction(item, i, groupIndex)}}\n                <ng-template [palTableActionsContainer]=\"i\"></ng-template>\n            </div>\n        </mat-cell>\n    </ng-container>\n\n    <!-- Expanded Item Content Column - The detail row is made up of this one column that spans across all columns -->\n    <ng-container matColumnDef=\"expandedDetail\">\n        <mat-cell *matCellDef=\"let element; let rowIndex = dataIndex;\" [attr.colspan]=\"displayedColumns.length\" class=\"example-element-detail\">\n            <div [@detailExpand]=\"element == expandedElement ? 'expanded' : 'collapsed'\" class=\"expanded-container\"\n                *ngIf=\"element == expandedElement\">\n                <table mat-table matSort [dataSource]=\"getExpandedItemTableData(element)\" multiTemplateDataRows class=\"expanded-table mat-elevation-z8\">\n\n                    <div *ngFor=\"let expandedTableColumn of getExpandedItemTableColumns(element)\">\n                        <!-- Expanded Item Expandable Row Column -->\n                        <ng-container *ngIf=\"expandedTableColumn.columnId === 'expandedItemExpandableColumn'\"\n                            matColumnDef=\"expandedItemExpandableColumn\">\n                            <mat-header-cell *matHeaderCellDef mat-sort-header [style.background]=\"expandedTableColumn.backgroundColor\"\n                                [style.color]=\"expandedTableColumn.color\" class=\"expanded-item-header-column expanded-item-column-{{expandedTableColumn.columnId}}\">\n                                <mat-icon [style.color]=\"expandedTableColumn.color\">{{expandedTableColumn.icon}}</mat-icon>\n                            </mat-header-cell>\n                            <mat-cell *matCellDef=\"let expandedItem; let expandedItemRowIndex = dataIndex;\" class=\"expanded-item-column expanded-item-column-{{expandedTableColumn.columnId}}\"\n                                (click)=\"selectItem2(expandedItem, element);\">\n                                <mat-icon *ngIf=\"expandedItem !== expandedElement2\" class=\"expanded-item-expand-row-icon\">play_arrow</mat-icon>\n                                <mat-icon *ngIf=\"expandedItem === expandedElement2\" class=\"expanded-item-collapse-row-icon\">arrow_drop_down</mat-icon>\n                            </mat-cell>\n                        </ng-container>\n\n                        <!-- Text based Columns -->\n                        <ng-container *ngIf=\"expandedTableColumn.columnId !== 'expandedItemExpandableColumn'\"\n                            matColumnDef=\"{{expandedTableColumn.columnId}}\">\n                            <mat-header-cell *matHeaderCellDef mat-sort-header [style.background]=\"expandedTableColumn.backgroundColor\"\n                                [style.color]=\"expandedTableColumn.color\" class=\"expanded-item-header-column expanded-item-column-{{expandedTableColumn.columnId}}\">\n                                <mat-icon>{{expandedTableColumn.icon}}</mat-icon> {{expandedTableColumn.column}}\n                            </mat-header-cell>\n                            <mat-cell *matCellDef=\"let expandedItem; let expandedItemRowIndex = dataIndex;\" class=\"expanded-item-column expanded-item-column-{{expandedTableColumn.columnId}}\">\n                                {{expandedItem[expandedTableColumn.columnId]}}\n                            </mat-cell>\n                        </ng-container>\n                    </div>\n\n                    <!-- Expanded Item Details Content -->\n                    <ng-container matColumnDef=\"expandedDetail2\">\n                        <mat-cell *matCellDef=\"let element2; let rowIndex = dataIndex;\" [attr.colspan]=\"displayedColumns.length\"\n                            class=\"example-element-detail\">\n\n                            <div [@detailExpand]=\"element2 == expandedElement2 ? 'expanded' : 'collapsed'\" *ngIf=\"element2 == expandedElement2\"\n                                class=\"expanded-container\">\n\n                                <table mat-table matSort [dataSource]=\"expandedItemDetailsDataSource\" class=\"expanded-table mat-elevation-z8\">\n\n                                    <!-- Columns -->\n                                    <ng-container *ngFor=\"let expandedTableColumn of getExpandedItemDetailsTableColumns(element2, element)\"\n                                        matColumnDef=\"{{expandedTableColumn.columnId}}\">\n                                        <mat-header-cell *matHeaderCellDef mat-sort-header [style.background]=\"expandedTableColumn.backgroundColor\"\n                                            [style.color]=\"expandedTableColumn.color\" class=\"expanded-item-detail-header-column expanded-item-detail-column-{{expandedTableColumn.columnId}}\">\n                                            <mat-icon *ngIf=\"expandedTableColumn.icon !== null\" svgIcon=\"{{expandedTableColumn.icon}}\" [style.color]=\"expandedTableColumn.color\">{{expandedTableColumn.icon}}</mat-icon>\n                                            {{expandedTableColumn.column}}\n                                        </mat-header-cell>\n                                        <mat-cell *matCellDef=\"let expandedItem; let expandedItemRowIndex = dataIndex;\"\n                                            class=\"expanded-item-detail-column expanded-item-detail-column-{{expandedTableColumn.columnId}}\">\n                                            <mat-icon *ngIf=\"expandedTableColumn.icon !== null\" svgIcon=\"{{expandedTableColumn.icon}}\" class=\"expanded-item-detail-column-expanded-row\">{{expandedTableColumn.icon}}</mat-icon>\n                                            {{expandedItem[expandedTableColumn.columnId]}}\n                                        </mat-cell>\n                                    </ng-container>\n\n\n                                    <mat-header-row *matHeaderRowDef=\"getExpandedItemDetailsTableColumnIds(element2, element)\"\n                                        [ngClass]=\"{'no-header-columns': hideColumnsOfExpandedItemDetails}\"></mat-header-row>\n                                    <mat-row *matRowDef=\"let element2; columns: getExpandedItemDetailsTableColumnIds(element2, element);\"\n                                        (click)=\"selectItem2(element2, element);\"></mat-row>\n                                </table>\n\n                                <div class=\"pal-table-loading-shade\" *ngIf=\"isLoadingExpandedItemResults || noExpandedItemDataFound\">\n                                    <div class=\"loading-shade-container\">\n                                        <div fxLayout=\"column\" fxLayoutAlign=\"space-around center\" *ngIf=\"isLoadingExpandedItemResults\">\n                                            <mat-spinner mode=\"indeterminate\" color=\"accent\" [diameter]=\"50\"\n                                                [strokeWidth]=\"2\"></mat-spinner>\n                                            <!-- <mat-progress-bar mode=\"buffer\" color=\"accent\"></mat-progress-bar> -->\n                                            <span class=\"loading-message\">wird geladen...</span>\n                                        </div>\n                                        <!--\n                                    <div fxLayout=\"column\" fxLayoutAlign=\"space-around center\" class=\"pal-table-message\"\n                                        *ngIf=\"noExpandedItemDataFound\">\n                                        <mat-icon svgIcon=\"no-data-found\" class=\"no-data-found-icon\"></mat-icon>\n                                        <span class=\"no-data-found-text\">No data found!</span>\n                                    </div>\n                                    -->\n                                    </div>\n                                </div>\n                            </div>\n                        </mat-cell>\n                    </ng-container>\n\n\n                    <mat-header-row *matHeaderRowDef=\"getExpandedItemTableColumnIds(element)\" [ngClass]=\"{'no-header-columns': hideColumnsOfExpandedItems}\"\n                        class=\"expanded-item-header-row\"></mat-header-row>\n                    <mat-row *matRowDef=\"let element; columns: getExpandedItemTableColumnIds(element);\"></mat-row>\n                    <mat-row *matRowDef=\"let element2; columns: ['expandedDetail2']\" class=\"expanded-item-row\"\n                        [ngStyle]=\"{ 'display': expandedElement2 === element2 ? 'inline' : 'none' }\"></mat-row>\n                </table>\n            </div>\n        </mat-cell>\n    </ng-container>\n\n    <mat-header-row *matHeaderRowDef=\"displayedColumns\" [ngClass]=\"{'no-header-columns': hideColumns}\"></mat-header-row>\n    <!-- TABLE ITEM ROW -->\n    <mat-row *matRowDef=\"let row; columns: displayedColumns; let rowIndex = dataIndex;\" class=\"table-item-row\"\n        [class.example-expanded-row]=\"expandedElement === row\" [class.mat-elevation-z1]=\"currentSelectedRowIndex == rowIndex\"\n        [style.background]=\"getItemRowColor()\" [ngClass]=\"{'current-selected-row': currentSelectedRowIndex == rowIndex}\">\n    </mat-row>\n    <!-- EXPANDED ITEM ROW -->\n    <mat-row *matRowDef=\"let row; let rowIndex = dataIndex; columns: ['expandedDetail']\" class=\"expanded-item-row\"\n        [ngStyle]=\"{ 'display': expandedElement === row ? 'inline' : 'none' }\">\n    </mat-row>\n</mat-table>\n\n<div class=\"pal-table-loading-shade\" *ngIf=\"isLoadingResults || noDataFound\">\n    <div class=\"loading-shade-container\">\n        <div fxLayout=\"column\" fxLayoutAlign=\"space-around center\" *ngIf=\"isLoadingResults\">\n            <mat-spinner mode=\"indeterminate\" color=\"primary\" [diameter]=\"80\" [strokeWidth]=\"2\"></mat-spinner>\n            <!-- <mat-progress-bar mode=\"buffer\" color=\"accent\"></mat-progress-bar> -->\n            <span class=\"loading-message\">wird geladen...</span>\n        </div>\n        <!--\n    <div fxLayout=\"column\" fxLayoutAlign=\"space-around center\" class=\"pal-table-message\" *ngIf=\"noDataFound\">\n        <mat-icon svgIcon=\"no-data-found\" class=\"no-data-found-icon\"></mat-icon>\n        <span class=\"no-data-found-text\">No data found!</span>\n    </div>\n    -->\n    </div>\n</div>",
                styles: [
                    "@import '../../dynamic-table/table/table-instance.component.scss';\n\n$mat-cell-height: 90px;\n\n.table-item-row {\n    min-height: 80px;\n    height: 80px;\n}\n\n.example-element-detail {\n    display: flex;\n    align-items: flex-start;\n    overflow: hidden;\n    padding-left: 0px;\n    padding-right: 0px;\n}\n\n.expanded-table {\n    margin: 0px;\n    overflow: auto;\n    height: 100%;\n    width: 100%;\n}\n\n.mat-row {\n    min-height: $mat-cell-height !important;\n    padding: 0 0px !important;\n}\n\n.mat-cell {\n    min-height: $mat-cell-height !important;\n}\n\n.expanded-container {\n    width: 100%;\n}\n\n.expanded-item-header-row {\n    min-height: 40px;\n    height: 40px;\n    max-height: 40px;\n}\n\n.expanded-item-row {\n    padding: 0px;\n    font-size: 14px !important;\n    font-weight: 300;\n    line-height: 16px;\n}\n\n.expanded-item-header-column {\n    @extend .flex-column;\n    justify-content: center;\n    font-size: 0.8vw;\n    font-weight: 500;\n    border-right: 1px solid #ffffff;\n}\n\n.expanded-item-detail-header-column {\n    @extend .expanded-item-header-column;\n}\n\n.expanded-item-column {\n    border-right: 1px solid #ffffff;\n}\n\n.expanded-item-detail-column {\n    border-right: 1px solid #D0D0D0;\n}\n\n.expandable-row-icon {\n    color: #FFFFFF;\n    width: 40px;\n    height: 40px;\n    font-size: 40px;\n}\n\n.expanded-item-expand-row-icon {\n    color: #FFFFFF;\n    width: 28px;\n    height: 28px;\n    font-size: 28px;\n}\n\n.expanded-item-collapse-row-icon {\n    color: #FFFFFF;\n    width: 38px;\n    height: 38px;\n    font-size: 38px;\n}\n\nmat-footer-row::after,\nmat-header-row::after,\nmat-row::after {\n    min-height: 0px;\n}\n\n.pal-table-loading-shade {\n    position: relative !important;\n}\n\n.loading-shade-container {\n    margin: 20px;\n}\n\n.loading-message {\n    font-size: 12px;\n    font-weight: 400;\n}\n\nmat-cell:first-child {\n    padding-left: 0px !important;\n}\n\n.expanded-item-detail-column-expanded-row {\n    color: #494949;\n    width: 32px;\n    height: 32px;\n    font-size: 32px;\n}",
                    "// COLORS\n//-------------------------------------//\n$md-primary-color: #00DB5D;\n$md-accent-color: #1EBAE4;\n$md-warning-color: #D32F2F;\n$md-white-color: #FFF;\n$md-grey-color: #929292;\n$md-blue-color: #40C4FF;\n\n// FONT FAMILY AND FONT SIZE\n//-------------------------------------//\n$application-font: 'RobotoLight',\nsans-serif;\n$application-font-color: #00c853;\n$application-font-placeholder-color: #B6B6B6;\n$application-font-white: #FFF;\n$font-size-50: 7.25vw;\n$font-size-40: 3.5vw;\n$font-size-35: 2.3vw;\n$font-size-30: 1.95vw;\n$font-size-28: 1.85vw;\n$font-size-25: 1.7vw;\n$font-size-20: 1.57vw;\n$font-size-18: 1.4vw;\n$font-size-15: 1.1vw;\n$font-size-13: 1vw;\n\n\n// OTHER VARIABLES\n//-------------------------------------//\n$mat-cell-height: 130px;\n\n\n// ICONS\n//-------------------------------------//\n.icon-medium {\n    width: 32px;\n    height: 32px;\n    font-size: 32px;\n}\n\n.icon-large {\n    width: 48px;\n    height: 48px;\n    font-size: 48px;\n}\n\n.icon-big {\n    width: 64px;\n    height: 64px;\n    font-size: 64px;\n}\n\n.icon-color-grey {\n    color: #929292;\n}\n\n.icon-color-white {\n    color: #ffffff;\n}\n\n\n\n// CLASSES\n//-------------------------------------//\n.pal-table-container {\n    position: relative;\n    display: flex;\n    flex-direction: column;\n    min-width: 300px;\n    height: 94vh;\n    padding-bottom: $mat-cell-height;\n    overflow: auto;\n    -webkit-overflow-scrolling: touch;\n}\n\n.pal-table-header {\n    min-height: 65px;\n    height: 65px;\n    width: 100%;\n    display: flex;\n    align-items: center;\n    padding-left: 24px;\n    padding-right: 24px;\n    padding-top: 12px;\n}\n\n.pal-table {\n    overflow: auto;\n    height: 100%;\n    font-size: 1.5vw;\n}\n\n.pal-table-loading-shade {\n    position: absolute;\n    top: 0;\n    left: 0; // bottom: 56px;\n    height: 100%;\n    right: 0;\n    background: rgba(0, 0, 0, 0.10);\n    z-index: 1;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n}\n\n.pal-table-message {\n    color: #980000;\n    max-width: 360px;\n    text-align: center;\n}\n\n.mat-header-cell.mat-sort-header-sorted {\n    color: black;\n}\n\n.mat-row {\n    min-height: $mat-cell-height;\n    padding: 0 7px;\n}\n\n.mat-cell {\n    font-size: $font-size-20;\n    min-height: $mat-cell-height;\n}\n\n// Columns\n.flex-column {\n    display: -webkit-box;\n    display: -moz-box;\n    display: -ms-flexbox;\n    display: -webkit-flex;\n    display: flex;\n    flex-wrap: wrap;\n    flex-direction: row;\n}\n\n.color-column {\n    @extend .flex-column;\n    font-size: $font-size-28;\n    width: 40px;\n    min-width: 40px;\n    max-width: 40px;\n}\n\n.title-column {\n    @extend .flex-column;\n}\n\n.icon-column {\n    @extend .flex-column;\n    width: 5%;\n    min-width: 5%;\n    max-width: 5%;\n}\n\n.description-column {\n    @extend .flex-column;\n}\n\n.html-content-summary-column {\n    @extend .flex-column;\n    width: 15%;\n    min-width: 15%;\n    max-width: 15%;\n}\n\n.additional-info-column {\n    @extend .flex-column;\n    width: 15%;\n    min-width: 15%;\n    max-width: 15%;\n}\n\n.actions-column {\n    @extend .flex-column;\n    width: 30%;\n    min-width: 30%;\n    max-width: 30%;\n}\n\n.other-text-based-column {\n    @extend .flex-column;\n}\n\n.no-data-found-icon {\n    height: 128px;\n    width: 128px;\n}\n\n.no-data-found-text {\n    font-size: 32px;\n    color: gray;\n    font-weight: 700;\n}\n\n.no-header-columns {\n    display: none;\n}\n\n.current-selected-row {\n    background-color: rgb(245, 252, 253);\n}\n\n.selected-row-icon {\n    font-size: 12px;\n    color: $md-accent-color;\n}\n\n.selected-row-column {\n    @extend .flex-column;\n    justify-content: flex-start;\n    width: 12px;\n    min-width: 12px;\n    max-width: 12px;\n}\n\n.speed-dial-container {\n    position: fixed;\n    bottom: 32px;\n    right: 32px;\n}\n\n.speed-dial-option-icon {\n    color: #ffffff;\n}\n\n.toolbar-buttons {\n    width: 50%;\n}\n\n.toolbar-button {\n    margin: 5px;\n}\n\n.mat-form-field-label-wrapper {\n    top: -3px;\n    padding-top: -3px;\n}\n\n.mat-toolbar {\n    background-color: #494949;\n}\n\n.pal-table-grouped-container {\n    width: 100%\n}\n\n.pal-table-grouped {\n    width: 100%\n}"
                ],
                animations: [
                    animations.trigger('detailExpand', [
                        animations.state('collapsed', animations.style({ height: '0px', minHeight: '0px', display: 'none' })),
                        animations.state('expanded', animations.style({ display: 'inline', height: '*' })),
                        animations.transition('expanded <=> collapsed', animations.animate('225ms cubic-bezier(0.4, 0.0, 0.2, 1)')),
                    ]),
                ],
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], ExpandableTableInstanceComponent);
        return ExpandableTableInstanceComponent;
    }(TableInstanceComponent));

    var DynamicExpandableTableModule = /** @class */ (function () {
        function DynamicExpandableTableModule() {
        }
        DynamicExpandableTableModule_1 = DynamicExpandableTableModule;
        DynamicExpandableTableModule.forRoot = function () {
            //const palTableModuleWithProviders: ModuleWithProviders = DynamicTableModule.forRoot();
            //.concat(palTableModuleWithProviders.providers)
            return {
                ngModule: DynamicExpandableTableModule_1,
                providers: []
            };
        };
        DynamicExpandableTableModule = DynamicExpandableTableModule_1 = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    DynamicTableModule,
                    DynamicTableModule.forRoot()
                ],
                exports: [
                    ExpandableTableInstanceComponent,
                    DynamicExpandableTableComponent
                ],
                declarations: [
                    ExpandableTableInstanceComponent,
                    DynamicExpandableTableComponent
                ],
                providers: [
                    DynamicExpandableTableDataProvider
                ]
            })
        ], DynamicExpandableTableModule);
        return DynamicExpandableTableModule;
        var DynamicExpandableTableModule_1;
    }());

    var AbstractDynamicExpandableTableDataProvider = /** @class */ (function (_super) {
        __extends(AbstractDynamicExpandableTableDataProvider, _super);
        function AbstractDynamicExpandableTableDataProvider() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return AbstractDynamicExpandableTableDataProvider;
    }(AbstractDynamicTableDataProvider));

    var DynamicExpandableTableColumnDefinitionConstants = /** @class */ (function (_super) {
        __extends(DynamicExpandableTableColumnDefinitionConstants, _super);
        function DynamicExpandableTableColumnDefinitionConstants() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(DynamicExpandableTableColumnDefinitionConstants.prototype, "EXPANDABLE_COLUMN", {
            get: function () {
                return DynamicExpandableTableColumnDefinitionConstants.EXPANDABLE_COLUMN;
            },
            enumerable: true,
            configurable: true
        });
        DynamicExpandableTableColumnDefinitionConstants.EXPANDABLE_COLUMN = 'expandableColumn';
        return DynamicExpandableTableColumnDefinitionConstants;
    }(DynamicTableColumnDefinitionConstants));

    exports.AbstractWebWidgetComponent = AbstractWebWidgetComponent;
    exports.AbstractDynamicBaseService = AbstractDynamicBaseService;
    exports.DynamicTableModule = DynamicTableModule;
    exports.DynamicTableComponent = DynamicTableComponent;
    exports.TableInstanceComponent = TableInstanceComponent;
    exports.DynamicTableUtils = DynamicTableUtils;
    exports.DynamicTableDynamicCellBuilder = DynamicTableDynamicCellBuilder;
    exports.DynamicTableDataProvider = DynamicTableDataProvider;
    exports.DynamicTableColumnDefinitionConstants = DynamicTableColumnDefinitionConstants;
    exports.AbstractDynamicTableDataProvider = AbstractDynamicTableDataProvider;
    exports.DynamicTableActionMessageService = DynamicTableActionMessageService;
    exports.DynamicTableMouseEventMessageService = DynamicTableMouseEventMessageService;
    exports.DynamicTableActionsContainerDirective = DynamicTableActionsContainerDirective;
    exports.PalTableAdditionalInfoContainerDirective = PalTableAdditionalInfoContainerDirective;
    exports.DynamicTableColumnsContainerDirective = DynamicTableColumnsContainerDirective;
    exports.DynamicTableContentSummaryContainerDirective = DynamicTableContentSummaryContainerDirective;
    exports.DynamicTableDescriptionContainerDirective = DynamicTableDescriptionContainerDirective;
    exports.DynamicTableIconContainerDirective = DynamicTableIconContainerDirective;
    exports.DynamicTableTitleContainerDirective = DynamicTableTitleContainerDirective;
    exports.DynamicTableContainerDirective = DynamicTableContainerDirective;
    exports.DynamicExpandableTableModule = DynamicExpandableTableModule;
    exports.DynamicExpandableTableComponent = DynamicExpandableTableComponent;
    exports.AbstractDynamicExpandableTableDataProvider = AbstractDynamicExpandableTableDataProvider;
    exports.DynamicExpandableTableDataProvider = DynamicExpandableTableDataProvider;
    exports.DynamicExpandableTableColumnDefinitionConstants = DynamicExpandableTableColumnDefinitionConstants;
    exports.DynamicExpandableTableUtils = DynamicExpandableTableUtils;
    exports.ExpandableTableInstanceComponent = ExpandableTableInstanceComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
